//-------------------------------------------------------------------------
//-------------------------------- DATEI.C --------------------------------
//-------------------------------------------------------------------------
//--------------- Dateioperationen "Wertdiskrete Informationstheorie"------
//-------------------- Erstellt von: Georg Delle --------------------------

#include <windows.h>
#include <math.h>
#include <commdlg.h>
#include <io.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <time.h>
#include "wdit.h"
#include "wdit_typ.h"
#include "dir.h"


#define DISKERROR1                                                      \
 {                                                                      \
 _lclose(hFile);                                                        \
 GlobalUnlock (hBuffer) ;                                               \
 GlobalFree (hBuffer) ;                                                 \
 MessageBox(hwndFrame, (LPSTR) "Datei kann nicht geschrieben werden!",  \
		 (LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK); \
 return(FALSE);                                                         \
 }

extern LPSTR	        lpstrBuffer;
extern LPSTR	        lpstrCod;
extern HANDLE 			  hBuffer;
extern HWND            hwndFrame;
extern HMENU           hMenu;
extern HANDLE			  hInst;
extern HCURSOR         hCurWait, hCurArrow;
extern LPSTR			  lpstrBufferPar;
extern HANDLE       	  hBufferPar;
BOOL			           fehler(char*);
extern double			  Statist_P[8];
extern unsigned		  Datei_Groes;
long						  Konv_Groes;
extern short			  Modell;
extern STRUCT_FENSTER  Fenster;
extern STRUCT_TOCHTER  SF, HFK, ETP, PAR;
extern STRUCT_DATEI    Datei1, Datei2;
extern char            directory[MAXPATH];
extern char				  szDirName[_MAX_PATH];
char                   szFile[_MAX_PATH];
char 			           szPuffer[_MAX_PATH];
extern char				  drive[_MAX_DRIVE];
extern char				  dir[_MAX_DIR];
extern char				  file[_MAX_FNAME];
extern char				  ext[_MAX_EXT];
float						  Warsch_keit[11];
extern float			  u[15];
double 					  Entrop;
double					  Summe=0.0;
extern BOOL				  codiert;
extern BOOL				  decodiert;
extern BOOL				  OhneZI;
extern BOOL				  OhneLZ;
extern BOOL				  OhneIP;
extern BOOL				  OhneSZ;
extern BOOL				  Frei_L;
extern BOOL				  Quelle;
extern BOOL            Folge_L;
extern BOOL				  Frei_R;
extern BOOL				  Folgedec;
extern BOOL            Folge_R;
extern BOOL 			  FlagNormal;
extern BOOL				  FlagKlein;
extern BOOL 			  FlagGross;
extern BOOL 			  FlagZI;
extern BOOL 			  FlagLZ;
extern BOOL 			  FlagIP;
extern BOOL				  FlagSZ;
extern BOOL				  FlagUmlaut;
BOOL						  OK;

BOOL FAR PASCAL        Statist_DlgProc(HWND, UINT, UINT, LONG);

BOOL FAR PASCAL Statist_DlgProc (HWND hDlg, UINT message, UINT wParam, LONG lparam)
 {

 char         szString[15];
 short        i;

 switch (message)
  {
  case WM_INITDIALOG:

	 for (i=0; i<=7; i++)
	  {
	  gcvt (Statist_P[i], 7, szString);
	  SetDlgItemText (hDlg, IDD_Pa+i, (LPSTR) szString);
	  }
	 ltoa (Datei_Groes, szString, 10);
	 SetDlgItemText (hDlg, IDD_GROES_SUN, (LPSTR) szString);

	 Entrop=0;
	 for(i=0;i<=7;i++)
	  {
	  if(Statist_P[i]>0)
		Entrop=Entrop-Statist_P[i]*log(Statist_P[i])/log(2);
	  }
	 sprintf(szString, "%.4f", Entrop);
	 SetDlgItemText (hDlg, IDD_ENTRP, (LPSTR) szString);


		return TRUE;


 case WM_COMMAND:
		switch (wParam)
		 {
		 case IDD_P_LZ:
			  Summe=0.0;
			  for (i=0; i<=6; i++)
				{
				GetDlgItemText (hDlg, IDD_Pa+i, (LPSTR) szString, 7);
				Statist_P[i]=atof(szString);
				Summe=Summe+Statist_P[i];
				}
			  Statist_P[7]=1.0-Summe;
			  sprintf(szString, "%.4f", Statist_P[7]);
			  Statist_P[7]=atof(szString);
			  gcvt (Statist_P[7], 7, szString);
			  SetDlgItemText (hDlg, IDD_Plz, (LPSTR) szString);

				if (Statist_P[7]<0 || Statist_P[7]>1)
				 {
				 if(MessageBox (hDlg,"Unzul\344ssiger Wert f\374r"
				  " Wahrscheinlichkeit!\n\n"
				  "M\366gliche Fehler:\n"
				  " - Wert zu gro\n"
				  " - Wert < 0\n"
				  " - Komma wurde verwendet",
				  "Wertdiskrete Informationstheorie", MB_RETRYCANCEL | MB_ICONSTOP) == IDRETRY)
				  return TRUE;
				 else
				  {
				  EndDialog (hDlg, 0);
				  return TRUE;
				  }
				 }
				Entrop=0;
				for(i=0;i<=7;i++)
				 {
				 if(Statist_P[i]>0)
				  Entrop=Entrop-Statist_P[i]*log(Statist_P[i])/log(2);
				 }
				sprintf(szString, "%.4f", Entrop);
				SetDlgItemText (hDlg, IDD_ENTRP, (LPSTR) szString);

			  return TRUE;


		 case IDOK:
			  Summe=0;
			  for (i=0; i<=7; i++)
				{
				GetDlgItemText (hDlg, IDD_Pa+i, (LPSTR) szString, 7);
				Statist_P[i]=atof(szString);
				Summe=Summe+Statist_P[i];
				if (Statist_P[i]<0 || Statist_P[i]>1 || fehler(&szString[0]))
				 {
				 if(MessageBox (hDlg,"Unzul\344ssiger Wert f\374r"
				  " Wahrscheinlichkeit!\n\n"
				  "M\366gliche Fehler:\n"
				  " - Wert > 1\n"
				  " - Wert < 0\n"
				  " - Komma wurde verwendet",
				  "Wertdiskrete Informationstheorie", MB_RETRYCANCEL | MB_ICONSTOP) == IDRETRY)
				  return TRUE;
				 else
				  {
				  EndDialog (hDlg, 0);
				  return TRUE;
				  }
				 }
				}
				if (Summe<0.99999 || Summe>1.0001)
				 {
				 if(MessageBox (hDlg,"Die Summe der Wahrscheinlichkeiten\n"
				  " ist ungleich eins!\n\n"
				  "Schalter 'Summe = 1' wurde nicht ben\374tzt\n",
				  "Wertdiskrete Informationstheorie", MB_RETRYCANCEL | MB_ICONSTOP) == IDRETRY)
				  return TRUE;
				 else
				  {
				  EndDialog (hDlg, 0);
				  return TRUE;
				  }
				 }
			  GetDlgItemText (hDlg, IDD_GROES_SUN, (LPSTR) szString, 6);
			  Datei_Groes=(unsigned)atol(szString);

		  if(fehler(&szString[0]))
				 {
				 if(MessageBox (hDlg,"Unzulssiger Wert fr Dateigre!",
				  "Wertdiskrete Informationstheorie", MB_RETRYCANCEL | MB_ICONSTOP) == IDRETRY)
				  return TRUE;
				 else
				  {
				  EndDialog (hDlg, 0);
				  return TRUE;
				  }
				 }

			  if(Datei_Groes>20000)
				{
				if(MessageBox (hDlg,"Die Groesse der Folge darf 20000 nicht berschreiten!",
					"Wertdiskrete Informationstheorie", MB_RETRYCANCEL | MB_ICONSTOP) == IDRETRY)
				 return TRUE;
				else
				 {
				 EndDialog (hDlg, 0);
				 return TRUE;
				 }
				}
			  EndDialog (hDlg, 1);
			  return TRUE;


		 case IDCANCEL:
			  EndDialog (hDlg, 0);
			  return TRUE;
		}
		break;

 }
 return FALSE;
}


void StatistDatei(HWND hwnd)
 {

 char				  szBuffer[8];
 int				  hFile, laenge;
 int				  Zufall;
 float           Grenze_U, Grenze_O;
 FARPROC         lpDlgProc;
 int				  i;
 OPENFILENAME 	  ofn;
 char         	  *szFilter[] = {"Statist. unabh. Symbole (*.sun)","*.sun", ""};

 szPuffer[0] = '\0';

 ofn.lStructSize        = sizeof(OPENFILENAME);
 ofn.hwndOwner          = hwndFrame;
 ofn.hInstance          = (HANDLE)NULL;
 ofn.lpstrFilter        = szFilter[0];
 ofn.lpstrCustomFilter  = (LPSTR)NULL;
 ofn.nMaxCustFilter     = 0L;
 ofn.nFilterIndex       = 0L;
 ofn.lpstrFile          = szPuffer;
 ofn.nMaxFile           = sizeof(szPuffer);
 ofn.lpstrFileTitle     = NULL;
 ofn.nMaxFileTitle      = 0;
 ofn.lpstrInitialDir    = szDirName;
 ofn.lpstrTitle         = (LPSTR)"Wertdiskrete Informationstheorie";
 ofn.Flags              = OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT;
 ofn.nFileOffset        = 0;
 ofn.nFileExtension     = 0;
 ofn.lpstrDefExt        = (LPSTR)"SUN";
 ofn.lCustData          = 0L;
 ofn.lpfnHook           = (FARPROC)NULL;
 ofn.lpTemplateName     = (LPSTR)NULL;

 lpDlgProc = MakeProcInstance((FARPROC)Statist_DlgProc, hInst);
 OK=DialogBox(hInst, "STATISTISCH", hwnd, lpDlgProc);
 FreeProcInstance(lpDlgProc);

 if(OK)
  {
  if(GetSaveFileName(&ofn))
	{
	_splitpath(szPuffer, drive, dir, file, ext);
	if(stricmp(ext, ".sun"))
	 {
	 MessageBox(hwndFrame, (LPSTR) "Kein gltiger Dateiname!",
			(LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
	 return;
	 }
	_makepath(szDirName, drive, dir, "", "");
	_fullpath(szDirName, szDirName, _MAX_PATH);

	SetCursor(hCurWait);
	hFile= _lcreat (szPuffer, 0);
	laenge=strlen(szPuffer);
	hBuffer = GlobalAlloc (GHND, 20000);
	lpstrBuffer=GlobalLock(hBuffer);

//Statistisch unabhngige Symbole-datei erzeugen
	randomize();
	for(i=1; i<=Datei_Groes; i++)
	 {
	 Grenze_U=0;
	 Grenze_O=Statist_P[0]*10000;
	 Zufall=random(10000);
	 if(Zufall >= Grenze_U && Zufall < Grenze_O)
	  *(lpstrBuffer+i-1)=65;
	 Grenze_U=Grenze_O;
	 Grenze_O+=Statist_P[1]*10000;

	 if(Zufall >= Grenze_U && Zufall < Grenze_O)
	  *(lpstrBuffer+i-1)=66;
	 Grenze_U=Grenze_O;
	 Grenze_O=Grenze_O+Statist_P[2]*10000;

	 if(Zufall >= Grenze_U && Zufall < Grenze_O)
	  *(lpstrBuffer+i-1)=67;
	 Grenze_U=Grenze_O;
	 Grenze_O=Grenze_O+Statist_P[3]*10000;

	 if(Zufall >= Grenze_U && Zufall < Grenze_O)
	  *(lpstrBuffer+i-1)=68;
	 Grenze_U=Grenze_O;
	 Grenze_O=Grenze_O+Statist_P[4]*10000;

	 if(Zufall >= Grenze_U && Zufall < Grenze_O)
	  *(lpstrBuffer+i-1)=69;
	 Grenze_U=Grenze_O;
	 Grenze_O=Grenze_O+Statist_P[5]*10000;

	 if(Zufall >= Grenze_U && Zufall < Grenze_O)
	  *(lpstrBuffer+i-1)=70;
	 Grenze_U=Grenze_O;
	 Grenze_O=Grenze_O+Statist_P[6]*10000;

	 if(Zufall >= Grenze_U && Zufall < Grenze_O)
	  *(lpstrBuffer+i-1)=71;
	 Grenze_U=Grenze_O;
	 Grenze_O=Grenze_O+Statist_P[7]*10000;

	 if(Zufall >= Grenze_U && Zufall < Grenze_O)
	  *(lpstrBuffer+i-1)=32;
	 }
	_lwrite(hFile, lpstrBuffer, Datei_Groes);
	_lclose(hFile);
	GlobalUnlock(hBuffer);
	GlobalFree(hBuffer);

//Datei mit Wahrscheinlichkeiten erzeugen
	laenge=strlen(szPuffer);
	szPuffer[laenge-3]='p';
	szPuffer[laenge-2]=' ';
	szPuffer[laenge-1]=' ';
	hFile= _lcreat (szPuffer, 0);

	for(i=0; i<=7; i++)
	 {
	 _llseek (hFile, 0, 2);
	 sprintf (szBuffer, "%.5f", Statist_P[i]);
	 _lwrite (hFile, szBuffer, strlen(szBuffer));
	 _llseek (hFile, 0, 2);
	 _lwrite (hFile, " ", 1);
	 }
	_lclose(hFile);

  }
  SetCursor(hCurArrow);
  }

 return;
 }


void Markov2_Erzeugen(float pAA, float pBB, unsigned Datei_Groes)
 {
 OPENFILENAME ofn;
 char         *szFilter[] = {"Markov (*.mk2)","*.mk2", ""};
 unsigned	  i;
 int			  hFile, Zufall;
 short		  Zeichen;

 szPuffer[0] = '\0';

 ofn.lStructSize        = sizeof(OPENFILENAME);
 ofn.hwndOwner          = hwndFrame;
 ofn.hInstance          = (HANDLE)NULL;
 ofn.lpstrFilter        = szFilter[0];
 ofn.lpstrCustomFilter  = (LPSTR)NULL;
 ofn.nMaxCustFilter     = 0L;
 ofn.nFilterIndex       = 0L;
 ofn.lpstrFile          = szPuffer;
 ofn.nMaxFile           = sizeof(szPuffer);
 ofn.lpstrFileTitle     = NULL;
 ofn.nMaxFileTitle      = 0;
 ofn.lpstrInitialDir    = szDirName;
 ofn.lpstrTitle         = (LPSTR)"Wertdiskrete Informationstheorie";
 ofn.Flags              = OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT;
 ofn.nFileOffset        = 0;
 ofn.nFileExtension     = 0;
 ofn.lpstrDefExt        = (LPSTR)"MK2";
 ofn.lCustData          = 0L;
 ofn.lpfnHook           = (FARPROC)NULL;
 ofn.lpTemplateName     = (LPSTR)NULL;

  if(GetSaveFileName(&ofn))
	{
	_splitpath(szPuffer, drive, dir, file, ext);
	if(stricmp(ext, ".mk2"))
	 {
	 MessageBox(hwndFrame, (LPSTR) "Kein gltiger Dateiname!",
			(LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
	 return;
	 }
	_makepath(szDirName, drive, dir, "", "");
	_fullpath(szDirName, szDirName, _MAX_PATH);
	SetCursor(hCurWait);
	hFile= _lcreat (szPuffer, 0);
	hBuffer = GlobalAlloc (GHND, 60000U);
	lpstrBuffer=GlobalLock(hBuffer);

	randomize();
	Zeichen=1;
	for(i=1; i<=(Datei_Groes+100); i++)
	 {
	 switch(Zeichen)
	  {
	  case 1:
				if(i>100)//Die ersten hundert Werte vernachlssigen
				 *(lpstrBuffer+i-101)=65;
				Zufall=random(10000)+1;
				if(Zufall<=(pAA*10000))
				 Zeichen=1;
				else
				 Zeichen=2;
				break;

	  case 2:
				if(i>100)//Die ersten hundert Werte vernachlssigen
				 *(lpstrBuffer+i-101)=66;
				Zufall=random(10000)+1;
				if(Zufall<=(pBB*10000))
				 Zeichen=2;
				else
				 Zeichen=1;
				break;

	  }
	 }
	_lwrite(hFile, lpstrBuffer, Datei_Groes);
	_lclose(hFile);
	GlobalUnlock(hBuffer);
	GlobalFree(hBuffer);
	SetCursor(hCurArrow);

	}
 return;
 }


void Markov3_Erzeugen(float P, float KonstMarkov, unsigned Datei_Groes)
 {
 OPENFILENAME ofn;
 char         *szFilter[] = {"Markov (*.mk3)","*.mk3", ""};
 unsigned	  i;
 int			  hFile, Zufall;
 short		  Zeichen;

 szPuffer[0] = '\0';

 ofn.lStructSize        = sizeof(OPENFILENAME);
 ofn.hwndOwner          = hwndFrame;
 ofn.hInstance          = (HANDLE)NULL;
 ofn.lpstrFilter        = szFilter[0];
 ofn.lpstrCustomFilter  = (LPSTR)NULL;
 ofn.nMaxCustFilter     = 0L;
 ofn.nFilterIndex       = 0L;
 ofn.lpstrFile          = szPuffer;
 ofn.nMaxFile           = sizeof(szPuffer);
 ofn.lpstrFileTitle     = NULL;
 ofn.nMaxFileTitle      = 0;
 ofn.lpstrInitialDir    = szDirName;
 ofn.lpstrTitle         = (LPSTR)"Wertdiskrete Informationstheorie";
 ofn.Flags              = OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT;
 ofn.nFileOffset        = 0;
 ofn.nFileExtension     = 0;
 ofn.lpstrDefExt        = (LPSTR)"MK3";
 ofn.lCustData          = 0L;
 ofn.lpfnHook           = (FARPROC)NULL;
 ofn.lpTemplateName     = (LPSTR)NULL;

 if(OK)
  if(GetSaveFileName(&ofn))
	{
	_splitpath(szPuffer, drive, dir, file, ext);
	if(stricmp(ext, ".mk3"))
	 {
	 MessageBox(hwndFrame, (LPSTR) "Kein gltiger Dateiname!",
			(LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
	 return;
	 }
	_makepath(szDirName, drive, dir, "", "");
	_fullpath(szDirName, szDirName, _MAX_PATH);
	SetCursor(hCurWait);
	hFile= _lcreat (szPuffer, 0);
	hBuffer = GlobalAlloc (GHND, 60000U);
	lpstrBuffer=GlobalLock(hBuffer);

	randomize();
	Zeichen=1;
	for(i=1; i<=(Datei_Groes+100); i++)
	 {
	 switch(Zeichen)
	  {
	  case 1:
				if(i>100)//Die ersten hundert Werte vernachlssigen
				 *(lpstrBuffer+i-101)=65;
				Zufall=random(10000)+1;
				if(Zufall<=(P*KonstMarkov*10000))
				 Zeichen=1;
				else if(Zufall>(P*KonstMarkov*10000) && (Zufall<=(2*P*KonstMarkov*10000)))
				 Zeichen=2;
				else if(Zufall>(2*P*KonstMarkov*10000))
				 Zeichen=3;
				break;

	  case 2:
				if(i>100)//Die ersten hundert Werte vernachlssigen
				 *(lpstrBuffer+i-101)=66;
				Zufall=random(10000)+1;
				if(Zufall<=(P*10000))
				 Zeichen=2;
				else if(Zufall>(P*10000) && (Zufall<=(2*P*10000)))
				 Zeichen=3;
				else if(Zufall>(2*P*10000))
				 Zeichen=1;
				break;

	  case 3:
				if(i>100)//Die ersten hundert Werte vernachlssigen
				 *(lpstrBuffer+i-101)=67;
				Zufall=random(10000)+1;
				if(Zufall<=(P*10000))
				 Zeichen=3;
				else if(Zufall>(P*10000) && (Zufall<=(2*P*10000)))
				 Zeichen=1;
				else if(Zufall>(2*P*10000))
				 Zeichen=2;
				break;

	  }
	 }
	_lwrite(hFile, lpstrBuffer, Datei_Groes);
	_lclose(hFile);
	GlobalUnlock(hBuffer);
	GlobalFree(hBuffer);
	SetCursor(hCurArrow);

	}
 return;
 }


void LoadASCII(void)
{
 extern void  Para1_unchecked(void);
 extern void  Para2_unchecked(void);
 long         lLength;
 OPENFILENAME ofn;
 int          hFile;
 char         *szFilter[] = {"ASCII-Text (*.asc)","*.asc",
							  "Text (*.txt)", "*.txt", ""};
 szFile[0] = '\0';

 ofn.lStructSize        = sizeof(OPENFILENAME);
 ofn.hwndOwner          = hwndFrame;
 ofn.hInstance          = (HANDLE)NULL;
 ofn.lpstrFilter        = szFilter[0];
 ofn.lpstrCustomFilter  = (LPSTR)NULL;
 ofn.nMaxCustFilter     = 0L;
 ofn.nFilterIndex       = 1L;
 ofn.lpstrFile          = szFile;
 ofn.nMaxFile           = sizeof(szFile);
 ofn.lpstrFileTitle     = NULL;
 ofn.nMaxFileTitle      = 0;
 ofn.lpstrInitialDir    = szDirName;
 ofn.lpstrTitle         = (LPSTR)"Wertdiskrete Informationstheorie";
 ofn.Flags              = OFN_HIDEREADONLY;
 ofn.nFileOffset        = 0;
 ofn.nFileExtension     = 0;
 ofn.lpstrDefExt        = (LPSTR)NULL;
 ofn.lCustData          = 0L;
 ofn.lpfnHook           = (FARPROC)NULL;
 ofn.lpTemplateName     = (LPSTR)NULL;

 if(GetOpenFileName(&ofn))
  {
  _splitpath(szFile, drive, dir, file, ext);
  if(stricmp(ext, ".asc") && stricmp(ext, ".txt"))
	{
	MessageBox(hwndFrame, (LPSTR) "Kein gltiger Dateiname!",
			(LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
	return;
	}
	_makepath(szDirName, drive, dir, "", "");
	_fullpath(szDirName, szDirName, _MAX_PATH);
  SetCursor(hCurWait);
  if(-1 == (hFile = _lopen ((LPSTR)szFile, OF_READ|OF_SHARE_DENY_WRITE)))
	{
	MessageBox(hwndFrame, (LPSTR) "Datei kann nicht gelesen werden!",
		 (LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
	_lclose (hFile);
	return;
	}
  lLength=filelength(hFile);
  _lclose (hFile) ;

	Modell=8;
	HFK.ermittelt1 = FALSE;
	ETP.ermittelt1 = FALSE;
	Datei1.laenge = lLength;
	strcpy(Datei1.szFileName, szFile);
	EnableMenuItem(hMenu, IDM_HUFFCOD, MF_GRAYED);
	EnableMenuItem(hMenu, IDM_HUFFDEC, MF_GRAYED);
	EnableMenuItem(hMenu, IDM_UEBFEHLER, MF_GRAYED);
	EnableMenuItem(hMenu, IDM_SFOPT, MF_ENABLED);
	EnableMenuItem(hMenu, IDM_HFKOPT, MF_ENABLED);
	EnableMenuItem(hMenu, IDM_ETPOPT, MF_ENABLED);
   RemoveMenu(hMenu, IDM_HAEUFIG, MF_BYCOMMAND);

	if(!Fenster.null)//nur erforderlich falls mindestens 1 Fenster
	 {               //offen
	 EnableMenuItem(hMenu, IDM_RUN, MF_ENABLED);
	 Fenster.aktualisiert = FALSE;
	 }
	SetCursor(hCurArrow);
	return;
	}
  SetCursor(hCurArrow);
 return;
}


void LoadStatist(void)
{
 extern void  Para1_unchecked(void);
 extern void  Para2_unchecked(void);
 long         lLength;
 OPENFILENAME ofn;
 char			  Zeichen[2]="";
 char			  Warsch[8];
 int			  i, j;
 int			  laenge;
 int          hFile;
 char         *szFilter[] = {"Statist. unabh. Symbole (*.sun)","*.sun", ""};

 szFile[0] = '\0';

 ofn.lStructSize        = sizeof(OPENFILENAME);
 ofn.hwndOwner          = hwndFrame;
 ofn.hInstance          = (HANDLE)NULL;
 ofn.lpstrFilter        = szFilter[0];
 ofn.lpstrCustomFilter  = (LPSTR)NULL;
 ofn.nMaxCustFilter     = 0L;
 ofn.nFilterIndex       = 0L;
 ofn.lpstrFile          = szFile;
 ofn.nMaxFile           = sizeof(szFile);
 ofn.lpstrFileTitle     = NULL;
 ofn.nMaxFileTitle      = 0;
 ofn.lpstrInitialDir    = szDirName;
 ofn.lpstrTitle         = (LPSTR)"Wertdiskrete Informationstheorie";
 ofn.Flags              = OFN_HIDEREADONLY;
 ofn.nFileOffset        = 0;
 ofn.nFileExtension     = 0;
 ofn.lpstrDefExt        = (LPSTR)NULL;
 ofn.lCustData          = 0L;
 ofn.lpfnHook           = (FARPROC)NULL;
 ofn.lpTemplateName     = (LPSTR)NULL;

 if(GetOpenFileName(&ofn))
  {
  strcpy(szPuffer, szFile);
  _splitpath(szFile, drive, dir, file, ext);
  if(stricmp(ext, ".sun"))
	{
	MessageBox(hwndFrame, (LPSTR) "Kein gltiger Dateiname!",
		(LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
	return;
	}
	_makepath(szDirName, drive, dir, "", "");
	_fullpath(szDirName, szDirName, _MAX_PATH);
  SetCursor(hCurWait);
  if(-1 == (hFile = _lopen ((LPSTR)szFile, OF_READ|OF_SHARE_DENY_WRITE)))
	{
	MessageBox(hwndFrame, (LPSTR) "Datei kann nicht gelesen werden!",
		 (LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
	_lclose (hFile);
	return;
	}

	lLength=filelength(hFile);
	Datei1.laenge = lLength;
	_lclose (hFile) ;

  strcpy(szPuffer, szFile);
  laenge=strlen(szPuffer);
  szPuffer[laenge-3]='p';
  szPuffer[laenge-2]=' ';
  szPuffer[laenge-1]=' ';

  hFile = _lopen((LPSTR)szPuffer, OF_READ|OF_SHARE_DENY_WRITE);

  if(hFile==-1)
	{
	MessageBox(hwndFrame, (LPSTR) "Datei mit Wahrscheinlichkeiten\n"
											"kann nicht gelesen werden!\n\n"
											"Bitte neue Datei mit statistisch\n"
											"unabhngigen Symbolen erzeugen",
		 (LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
	_lclose (hFile);

	return;
	}

  j=0;
  memset(Warsch, 0, 8);
  for(i=1; i<=64; i++)
	{
	_lread (hFile, Zeichen, (WORD)1);
	if(Zeichen[0]!=' ')
	 strcat(Warsch, Zeichen);
	else
	 {
	 u[j]=atof(Warsch);
	 j++;
	 strcpy(Warsch,"");
	 }
	}
	_lclose(hFile);

	codiert=FALSE;
	decodiert=FALSE;
	HFK.ermittelt1 = FALSE;
	ETP.ermittelt1 = FALSE;
	OhneZI=FALSE;
	OhneLZ=FALSE;
	OhneIP=FALSE;
	OhneSZ=FALSE;
	Frei_L=FALSE;
	Quelle=TRUE;
	Folge_L=FALSE;
	Frei_R=TRUE;
	Folgedec=FALSE;
	Folge_R=FALSE;
	EnableMenuItem(hMenu, IDM_HUFFCOD, MF_ENABLED);
	EnableMenuItem(hMenu, IDM_HUFFDEC, MF_ENABLED);
	EnableMenuItem(hMenu, IDM_UEBFEHLER, MF_GRAYED);
	EnableMenuItem(hMenu, IDM_SFOPT, MF_ENABLED);
	EnableMenuItem(hMenu, IDM_HFKOPT, MF_GRAYED);
	EnableMenuItem(hMenu, IDM_ETPOPT, MF_GRAYED);
   RemoveMenu(hMenu, IDM_HAEUFIG, MF_BYCOMMAND);

	strcpy(Datei1.szFileName, szFile);
	Modell=5;
	if(!Fenster.null)//nur erforderlich falls mindestens 1 Fenster
	 {               //offen
	 EnableMenuItem(hMenu, IDM_RUN, MF_ENABLED);
	 Fenster.aktualisiert = FALSE;
	 }

	}
  SetCursor(hCurArrow);
 return;
}

void LoadMarkov2(void)
{
 extern void  Para1_unchecked(void);
 extern void  Para2_unchecked(void);
 long         lLength;
 OPENFILENAME ofn;
 int          hFile;
 char         *szFilter[] = {"Markov (*.mk2)","*.mk2", ""};

 szFile[0] = '\0';

 ofn.lStructSize        = sizeof(OPENFILENAME);
 ofn.hwndOwner          = hwndFrame;
 ofn.hInstance          = (HANDLE)NULL;
 ofn.lpstrFilter        = szFilter[0];
 ofn.lpstrCustomFilter  = (LPSTR)NULL;
 ofn.nMaxCustFilter     = 0L;
 ofn.nFilterIndex       = 0L;
 ofn.lpstrFile          = szFile;
 ofn.nMaxFile           = sizeof(szFile);
 ofn.lpstrFileTitle     = NULL;
 ofn.nMaxFileTitle      = 0;
 ofn.lpstrInitialDir    = szDirName;
 ofn.lpstrTitle         = (LPSTR)"Wertdiskrete Informationstheorie";
 ofn.Flags              = OFN_HIDEREADONLY;
 ofn.nFileOffset        = 0;
 ofn.nFileExtension     = 0;
 ofn.lpstrDefExt        = (LPSTR)NULL;
 ofn.lCustData          = 0L;
 ofn.lpfnHook           = (FARPROC)NULL;
 ofn.lpTemplateName     = (LPSTR)NULL;

 if(GetOpenFileName(&ofn))
  {
  strcpy(szPuffer, szFile);
  _splitpath(szFile, drive, dir, file, ext);
  if(stricmp(ext, ".mk2"))
	{
	MessageBox(hwndFrame, (LPSTR) "Kein gltiger Dateiname!",
		(LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
	return;
	}
	_makepath(szDirName, drive, dir, "", "");
	_fullpath(szDirName, szDirName, _MAX_PATH);
  SetCursor(hCurWait);
  if(-1 == (hFile = _lopen ((LPSTR)szFile, OF_READ|OF_SHARE_DENY_WRITE)))
	{
	MessageBox(hwndFrame, (LPSTR) "Datei kann nicht gelesen werden!",
		 (LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
	_lclose (hFile);
	return;
	}
  lLength=filelength(hFile);
  Datei1.laenge = lLength;
  _lclose (hFile) ;
  HFK.ermittelt1 = FALSE;
  ETP.ermittelt1 = FALSE;
  EnableMenuItem(hMenu, IDM_HUFFCOD, MF_GRAYED);
  EnableMenuItem(hMenu, IDM_HUFFDEC, MF_GRAYED);
  EnableMenuItem(hMenu, IDM_UEBFEHLER, MF_GRAYED);
  EnableMenuItem(hMenu, IDM_SFOPT, MF_GRAYED);
  EnableMenuItem(hMenu, IDM_HFKOPT, MF_GRAYED);
  EnableMenuItem(hMenu, IDM_ETPOPT, MF_ENABLED);
  RemoveMenu(hMenu, IDM_HAEUFIG, MF_BYCOMMAND);

  strcpy(Datei1.szFileName, szFile);
  Modell=6;
	if(!Fenster.null)//nur erforderlich falls mindestens 1 Fenster
	 {               //offen
	 EnableMenuItem(hMenu, IDM_RUN, MF_ENABLED);
	 Fenster.aktualisiert = FALSE;
	 }
	}
  SetCursor(hCurArrow);
 return;
}

void LoadMarkov3(void)
{
 extern void  Para1_unchecked(void);
 extern void  Para2_unchecked(void);
 long         lLength;
 OPENFILENAME ofn;
 int          hFile;
 char         *szFilter[] = {"Markov (*.mk3)","*.mk3", ""};

 szFile[0] = '\0';

 ofn.lStructSize        = sizeof(OPENFILENAME);
 ofn.hwndOwner          = hwndFrame;
 ofn.hInstance          = (HANDLE)NULL;
 ofn.lpstrFilter        = szFilter[0];
 ofn.lpstrCustomFilter  = (LPSTR)NULL;
 ofn.nMaxCustFilter     = 0L;
 ofn.nFilterIndex       = 0L;
 ofn.lpstrFile          = szFile;
 ofn.nMaxFile           = sizeof(szFile);
 ofn.lpstrFileTitle     = NULL;
 ofn.nMaxFileTitle      = 0;
 ofn.lpstrInitialDir    = szDirName;
 ofn.lpstrTitle         = (LPSTR)"Wertdiskrete Informationstheorie";
 ofn.Flags              = OFN_HIDEREADONLY;
 ofn.nFileOffset        = 0;
 ofn.nFileExtension     = 0;
 ofn.lpstrDefExt        = (LPSTR)NULL;
 ofn.lCustData          = 0L;
 ofn.lpfnHook           = (FARPROC)NULL;
 ofn.lpTemplateName     = (LPSTR)NULL;

 if(GetOpenFileName(&ofn))
  {
  strcpy(szPuffer, szFile);
  _splitpath(szFile, drive, dir, file, ext);
  if(stricmp(ext, ".mk3"))
	{
	MessageBox(hwndFrame, (LPSTR) "Kein gltiger Dateiname!",
		(LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
	return;
	}
	_makepath(szDirName, drive, dir, "", "");
	_fullpath(szDirName, szDirName, _MAX_PATH);
  SetCursor(hCurWait);
  if(-1 == (hFile = _lopen ((LPSTR)szFile, OF_READ|OF_SHARE_DENY_WRITE)))
	{
	MessageBox(hwndFrame, (LPSTR) "Datei kann nicht gelesen werden!",
		 (LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
	_lclose (hFile);
	return;
	}
  lLength=filelength(hFile);
  Datei1.laenge = lLength;
  _lclose (hFile) ;
  HFK.ermittelt1 = FALSE;
  ETP.ermittelt1 = FALSE;
  EnableMenuItem(hMenu, IDM_HUFFCOD, MF_GRAYED);
  EnableMenuItem(hMenu, IDM_HUFFDEC, MF_GRAYED);
  EnableMenuItem(hMenu, IDM_UEBFEHLER, MF_GRAYED);
  EnableMenuItem(hMenu, IDM_SFOPT, MF_GRAYED);
  EnableMenuItem(hMenu, IDM_HFKOPT, MF_GRAYED);
  EnableMenuItem(hMenu, IDM_ETPOPT, MF_ENABLED);
  RemoveMenu(hMenu, IDM_HAEUFIG, MF_BYCOMMAND);

  strcpy(Datei1.szFileName, szFile);
  Modell=7;
	if(!Fenster.null)//nur erforderlich falls mindestens 1 Fenster
	 {               //offen
	 EnableMenuItem(hMenu, IDM_RUN, MF_ENABLED);
	 Fenster.aktualisiert = FALSE;
	 }
	}
  SetCursor(hCurArrow);
 return;
}


long Dateigroesse(int hFile)
{
 long lCurrentPos = _llseek(hFile, 0L, 1) ;
 long lFileLength = _llseek(hFile, 0L, 2) ;
 _llseek (hFile, lCurrentPos, 0) ;
 return lFileLength ;
}

BOOL FAR PASCAL        Konvert_DlgProc(HWND, UINT, UINT, LONG);

BOOL FAR PASCAL Konvert_DlgProc (HWND hDlg, UINT message, UINT wParam, LONG lparam)
 {
 char			szBuffer[15];

 switch (message)
  {
  case WM_INITDIALOG:

		 if(FlagNormal)
		  CheckRadioButton(hDlg, IDD_NORMAL, IDD_NURGROSS, IDD_NORMAL);
		 else if(FlagKlein)
		  CheckRadioButton(hDlg, IDD_NORMAL, IDD_NURGROSS, IDD_NURKLEIN);
		 else if(FlagGross)
		  CheckRadioButton(hDlg, IDD_NORMAL, IDD_NURGROSS, IDD_NURGROSS);
		 if(FlagZI)
		  CheckDlgButton(hDlg, IDD_FLAGZI, 1);
		 if(FlagLZ)
		  CheckDlgButton(hDlg, IDD_FLAGLZ, 1);
		 if(FlagIP)
		  CheckDlgButton(hDlg, IDD_FLAGIP, 1);
		 if(FlagSZ)
		  CheckDlgButton(hDlg, IDD_FLAGSZ, 1);
		 if(FlagUmlaut)
		  CheckDlgButton(hDlg, IDD_UMLAUT, 1);
		 ltoa(Konv_Groes, szBuffer, 10);
		 SetDlgItemText (hDlg, IDD_KONVGROES, (LPSTR) szBuffer);

		return TRUE;


 case WM_COMMAND:
		switch (wParam)
		 {

		 case IDD_NORMAL:
			  FlagNormal=TRUE;
			  FlagKlein=FALSE;
			  FlagGross=FALSE;
			  return TRUE;

		 case IDD_NURKLEIN:
			  FlagKlein=TRUE;
			  FlagNormal=FALSE;
			  FlagGross=FALSE;
			  return TRUE;

		 case IDD_NURGROSS:
			  FlagGross=TRUE;
			  FlagNormal=FALSE;
			  FlagKlein=FALSE;
			  return TRUE;

		 case IDD_FLAGZI:
			  FlagZI=!FlagZI;
			  return TRUE;

		 case IDD_FLAGLZ:
			  FlagLZ=!FlagLZ;
			  return TRUE;

		 case IDD_FLAGIP:
			  FlagIP=!FlagIP;
			  return TRUE;

		 case IDD_FLAGSZ:
			  FlagSZ=!FlagSZ;
			  return TRUE;

		 case IDD_UMLAUT:
			  FlagUmlaut=!FlagUmlaut;
			  return TRUE;


		 case IDOK:
			  GetDlgItemText (hDlg, IDD_KONVGROES, (LPSTR) szBuffer, 9);
			  Konv_Groes=atol(szBuffer);
			  EndDialog (hDlg, 1);
			  return TRUE;


		 case IDCANCEL:
			  EndDialog (hDlg, 0);
			  return TRUE;
		}
		break;

 }
 return FALSE;
}


void Konvertieren(HWND hwnd)
{
 LPSTR         lpstrBuffer1, lpstrBuffer2;
 HANDLE        hBuffer1, hBuffer2;
 long         lLaenge, lLength, Ende;
 unsigned	  y=0;
 FARPROC      lpDlgProc;
 OPENFILENAME ofn;
 BOOL			  LZ=FALSE;
 BOOL			  Tab=FALSE;
 BOOL			  CR=FALSE;
 BOOL			  CR_Multi=FALSE;
 BOOL			  written=FALSE;
 int          laenge, hFile1,hFile2;
 char         *szFilter[] = {"Textdatei (*.*)","*.*",""};
 char			  Code[2];
 long			  lPosition=0;
 unsigned 	  Byte=0;

 szFile[0] = '\0';

 ofn.lStructSize        = sizeof(OPENFILENAME);
 ofn.hwndOwner          = hwndFrame;
 ofn.hInstance          = (HANDLE)NULL;
 ofn.lpstrFilter        = szFilter[0];
 ofn.lpstrCustomFilter  = (LPSTR)NULL;
 ofn.nMaxCustFilter     = 0L;
 ofn.nFilterIndex       = 0L;
 ofn.lpstrFile          = szFile;
 ofn.nMaxFile           = sizeof(szFile);
 ofn.lpstrFileTitle     = NULL;
 ofn.nMaxFileTitle      = 0;
 ofn.lpstrInitialDir    = szDirName;
 ofn.lpstrTitle         = (LPSTR)"Wertdiskrete Informationstheorie";
 ofn.Flags              = OFN_HIDEREADONLY;
 ofn.nFileOffset        = 0;
 ofn.nFileExtension     = 0;
 ofn.lpstrDefExt        = (LPSTR)NULL;
 ofn.lCustData          = 0L;
 ofn.lpfnHook           = (FARPROC)NULL;
 ofn.lpTemplateName     = (LPSTR)NULL;


if(GetOpenFileName(&ofn))
 {
 if(-1 == (hFile1 = _lopen ((LPSTR)szFile, OF_READ|OF_SHARE_DENY_WRITE)))
  {
  MessageBox(hwndFrame, (LPSTR) "Datei kann nicht ge\366ffnet werden!",
		(LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
  _lclose (hFile1);
  return;
  }
 Konv_Groes=filelength(hFile1);
 lLength=Konv_Groes;
 lpDlgProc = MakeProcInstance((FARPROC)Konvert_DlgProc, hInst);
 OK=DialogBox(hInst, "KONVERT", hwnd, lpDlgProc);
 FreeProcInstance(lpDlgProc);

 if(OK)
  {
 _splitpath(szFile, drive, dir, file, ext);
	_makepath(szDirName, drive, dir, "", "");
	_fullpath(szDirName, szDirName, _MAX_PATH);
 SetCursor(hCurWait);
 Code[1]='\0';

 if(Konv_Groes<=lLength)
  lLaenge=Konv_Groes;
 else
  lLaenge=lLength;
 laenge=strlen(szFile);

 szFile[laenge-3]='a';
 szFile[laenge-2]='s';
 szFile[laenge-1]='c';
 hFile2= _lcreat (szFile, 0);

while(lLaenge>0)
 {
  hBuffer1 = GlobalAlloc (GHND, 65535U);
  lpstrBuffer1=GlobalLock(hBuffer1);
  hBuffer2 = GlobalAlloc (GHND, 65535U);
  lpstrBuffer2=GlobalLock(hBuffer2);
  _llseek(hFile1, lPosition, 0);
  _lread (hFile1, lpstrBuffer1, (unsigned)60000U);
  lPosition+=60000L;
  if(lLaenge<60000U)
	Ende=lLaenge;
  else
	Ende=60000L;
  lLaenge-=60000L;
  y=0;

  while (y <= (Ende-1))
	{
	Code[0]= *(lpstrBuffer1+y);

  if ((int)Code[0]!=9 && (int)Code[0]!=32 && (int)Code[0]!=10 && (int)Code[0]!=13)
	{
	if(written)
	 {
	 LZ=FALSE;
	 Tab=FALSE;
	 CR=FALSE;
	 CR_Multi=FALSE;
	 written=FALSE;
	 }
	//Grobuchstaben

	if ((int)Code[0]>=65 && (int)Code[0]<=90)
	 {
	 if(FlagKlein)
	  *(lpstrBuffer2+Byte)=(int)Code[0]+32;
	 else
	  *(lpstrBuffer2+Byte)=(int)Code[0];
	 Byte++;
	 written=TRUE;
	 }

	//Kleinbuchstaben
	else if ((int)Code[0]>=97 && (int)Code[0]<=122)
	 {
	 if(FlagGross)
	  *(lpstrBuffer2+Byte)=(int)Code[0]-32;
	 else
	  *(lpstrBuffer2+Byte)=(int)Code[0];
	 Byte++;
	 written=TRUE;
	 }

	//Umlaut 
	else if ((int)Code[0]==-124)
	 {
	 if(FlagGross)
	  {
	  if(FlagUmlaut)
		{
		*(lpstrBuffer2+Byte)=65;
		Byte++;
		*(lpstrBuffer2+Byte)=69;
		Byte++;
		}
	  else
		{
		*(lpstrBuffer2+Byte)=(int)Code[0]+10;
		Byte++;
		}
	  }
	 else
	  {
	  if(FlagUmlaut)
		{
		*(lpstrBuffer2+Byte)=97;
		Byte++;
		*(lpstrBuffer2+Byte)=101;
		Byte++;
		}
	  else
		{
		*(lpstrBuffer2+Byte)=(int)Code[0];
		Byte++;
		}
	  }
	 written=TRUE;
	 }

	//Umlaut 
	else if ((int)Code[0]==-114)
	 {
	 if(FlagKlein)
	  {
	  if(FlagUmlaut)
		{
		*(lpstrBuffer2+Byte)=97;
		Byte++;
		*(lpstrBuffer2+Byte)=101;
		Byte++;
		}
	  else
		{
		*(lpstrBuffer2+Byte)=(int)Code[0]-10;
		Byte++;
		}
	  }
	 else
	  {
	  if(FlagUmlaut)
		{
		*(lpstrBuffer2+Byte)=65;
		Byte++;
		*(lpstrBuffer2+Byte)=69;
		Byte++;
		}
	  else
		{
		*(lpstrBuffer2+Byte)=(int)Code[0];
		Byte++;
		}
	  }
	 written=TRUE;
	 }

	//Umlaut 
	else if ((int)Code[0]==-108)
	 {
	 if(FlagGross)
	  {
	  if(FlagUmlaut)
		{
		*(lpstrBuffer2+Byte)=79;
		Byte++;
		*(lpstrBuffer2+Byte)=69;
		Byte++;
		}
	  else
		{
		*(lpstrBuffer2+Byte)=(int)Code[0]+5;
		Byte++;
		}
	  }
	 else
	  {
	  if(FlagUmlaut)
		{
		*(lpstrBuffer2+Byte)=111;
		Byte++;
		*(lpstrBuffer2+Byte)=101;
		Byte++;
		}
	  else
		{
		*(lpstrBuffer2+Byte)=(int)Code[0];
		Byte++;
		}
	  }
	 written=TRUE;
	 }

	//Umlaut 
	else if ((int)Code[0]==-103)
	 {
	 if(FlagKlein)
	  {
	  if(FlagUmlaut)
		{
		*(lpstrBuffer2+Byte)=111;
		Byte++;
		*(lpstrBuffer2+Byte)=101;
		Byte++;
		}
	  else
		{
		*(lpstrBuffer2+Byte)=(int)Code[0]-5;
		Byte++;
		}
	  }
	 else
	  {
	  if(FlagUmlaut)
		{
		*(lpstrBuffer2+Byte)=79;
		Byte++;
		*(lpstrBuffer2+Byte)=69;
		Byte++;
		}
	  else
		{
		*(lpstrBuffer2+Byte)=(int)Code[0];
		Byte++;
		}
	  }
	 written=TRUE;
	 }

	//Umlaut 
	else if ((int)Code[0]==-127)
	 {
	 if(FlagGross)
	  {
	  if(FlagUmlaut)
		{
		*(lpstrBuffer2+Byte)=85;
		Byte++;
		*(lpstrBuffer2+Byte)=69;
		Byte++;
		}
	  else
		{
		*(lpstrBuffer2+Byte)=(int)Code[0]+25;
		Byte++;
		}
	  }
	 else
	  {
	  if(FlagUmlaut)
		{
		*(lpstrBuffer2+Byte)=117;
		Byte++;
		*(lpstrBuffer2+Byte)=101;
		Byte++;
		}
	  else
		{
		*(lpstrBuffer2+Byte)=(int)Code[0];
		Byte++;
		}
	  }
	 written=TRUE;
	 }

	//Umlaut 
	else if ((int)Code[0]==-102)
	 {
	 if(FlagKlein)
	  {
	  if(FlagUmlaut)
		{
		*(lpstrBuffer2+Byte)=117;
		Byte++;
		*(lpstrBuffer2+Byte)=101;
		Byte++;
		}
	  else
		{
		*(lpstrBuffer2+Byte)=(int)Code[0]-25;
		Byte++;
		}
	  }
	 else
	  {
	  if(FlagUmlaut)
		{
		*(lpstrBuffer2+Byte)=85;
		Byte++;
		*(lpstrBuffer2+Byte)=69;
		Byte++;
		}
	  else
		{
		*(lpstrBuffer2+Byte)=(int)Code[0];
		Byte++;
		}
	  }
	 written=TRUE;
	 }

	//Scharfes 
	else if ((int)Code[0]==-31)
	 {
	 if(FlagGross)
	  {
	  if(FlagUmlaut)
		{
		*(lpstrBuffer2+Byte)=83;
		Byte++;
		*(lpstrBuffer2+Byte)=83;
		Byte++;
		}
	  else
		{
		*(lpstrBuffer2+Byte)=(int)Code[0];
		Byte++;
		}
	  }
	 else
	  {
	  if(FlagUmlaut)
		{
		*(lpstrBuffer2+Byte)=115;
		Byte++;
		*(lpstrBuffer2+Byte)=115;
		Byte++;
		}
	  else
		{
		*(lpstrBuffer2+Byte)=(int)Code[0];
		Byte++;
		}
	  }
	 written=TRUE;
	 }

	//Ziffern
	else if ((int)Code[0]>=48 && (int)Code[0]<=57)
	 {
	 if(!FlagZI)
	  {
	  *(lpstrBuffer2+Byte)=(int)Code[0];
	  Byte++;
	  written=TRUE;
	  }
	 }

	//Interpunktion (,;.:!?-)
	else if ((int)Code[0]==33 || (int)Code[0]==44 || (int)Code[0]==45 || (int)Code[0]==46 ||
				(int)Code[0]==58 || (int)Code[0]==59 || (int)Code[0]==63)
	 {
	 if(!FlagIP)
	  {
	  *(lpstrBuffer2+Byte)=(int)Code[0];
	  Byte++;
	  written=TRUE;
	  }
	 }

	//Sonderzeichen([](){}")
	else if (((int)Code[0]>=34 && (int)Code[0]<=43) || (int)Code[0]==47 || ((int)Code[0]>=60 && (int)Code[0]<=62) ||
				(int)Code[0]==64 || ((int)Code[0]>=91 && (int)Code[0]<=95) || ((int)Code[0]>=123 && (int)Code[0]<=126))
	 {
	 if(!FlagSZ)
	  {
	  *(lpstrBuffer2+Byte)=(int)Code[0];
	  Byte++;
	  written=TRUE;
	  }
	 }
	}

	//Leerzeichen
	else if ((int)Code[0]==32 && LZ==FALSE && Tab==FALSE && CR_Multi==FALSE)
	 {
	 if(!FlagLZ)
	  {
	  *(lpstrBuffer2+Byte)=(int)Code[0];
	  Byte++;
	  LZ=TRUE;
	  written=FALSE;
	  }
	 }

	//Tabulator
	else if ((int)Code[0]==9 && LZ==FALSE && Tab==FALSE && CR_Multi==FALSE)
	 {
	 if(!FlagLZ)
	  {
	  *(lpstrBuffer2+Byte)=32;
	  Byte++;
	  Tab=TRUE;
	  written=FALSE;
	  }
	 }

	//Zeilenvorschub
	else if ((int)Code[0]==13)
	 CR=TRUE;

	else if ((int)Code[0]==10 && CR==TRUE && LZ==FALSE && Tab==FALSE && CR_Multi==FALSE)
	 {
	 if(!FlagLZ)
	  {
	  *(lpstrBuffer2+Byte)=32;
	  Byte++;
	  CR=FALSE;
	  CR_Multi=TRUE;
	  written=FALSE;
	  }
	 }

	y++;
	}
  _llseek (hFile2, 0, 2);
  _lwrite (hFile2, lpstrBuffer2, Byte);
  GlobalUnlock(hBuffer1);
  GlobalFree(hBuffer1);
  GlobalUnlock(hBuffer2);
  GlobalFree(hBuffer2);
  Byte=0;
  }
  SetCursor(hCurArrow);
 }
 _lclose(hFile1);
 _lclose(hFile2);
 }

 return;
}


BOOL fehler(char str[]) //ueberprueft ob bei Eingabe
			//ein Fehler aufgetreten ist
{
 int i, zustand;

 zustand = 0;
 for (i = 0; str[i]; i++)
  {
  switch(zustand)
	{
	case 0:
		  if (str[i] == '+' || str[i] == '-')
			zustand = 1;
		  else if (str[i] == '.')
			zustand = 3;
		  else if (str[i] >= '0' && str[i] <= '9')
			zustand = 2;
		  else
			return(1);
		  break;

	case 1:
		  if (str[i] >= '0' && str[i] <= '9')
			zustand = 2;
		  else
			return(1);
		  break;

	case 2:
		  if (str[i] == '.')
			zustand = 5;
		  else if (str[i] >= '0' && str[i] <= '9')
			zustand = 2;
	else if ((str[i] == 'e')||(str[i] == 'E'))
	 zustand = 6;
		  else
			return(1);
		  break;

	case 3:
		  if (str[i] >= '0' && str[i] <= '9')
			zustand = 5;
		  else
			return(1);
		  break;

	case 4://noetig, sonst evtl. nur '.' moeglich
		  if (str[i] >= '0' && str[i] <= '9')
			zustand = 4;
		  else
			return(1);
		  break;

	case 5:
		  if (str[i] >= '0' && str[i] <= '9')
			zustand = 5;
	else if ((str[i] == 'e')||(str[i] == 'E'))
	 zustand = 6;
		  else
			return(1);
		  break;

	case 6:
		  if (str[i] >= '0' && str[i] <= '9')
			zustand = 4;
		  else if (str[i] == '+' || str[i] == '-')
			zustand = 4;
		  else
	 return(1);
		  break;

	default:
		  break;
	}
  }
 if (zustand == 2 || zustand == 4 || zustand == 5)
  return(0);
 else
  return(1);
}


