//---------------------------------------------------------------------------
//------------------------------- FENSTER.C ---------------------------------
//---------------------------------------------------------------------------
//-------- Verwaltung der Tochterfenster "Wertdiskrete Informationstheorie"--
//---------------------- Erstellt von: Georg Delle --------------------------


#include <windows.h>
#include "wdit.h"
#include "wdit_typ.h"

extern HWND           hwndSF, hwndHFK, hwndETP, hwndPAR;
extern HANDLE         hInst;
extern HMENU          hMenu;
extern STRUCT_FENSTER Fenster;
extern STRUCT_TOCHTER SF, HFK, ETP, PAR;


void FensterInit(HWND hwndClient)//faerbt Menuepunkte um und setzt Marken
{
 HWND hwndChild;

 if(Fenster.aktuell != 0)
  {
  hwndChild = LOWORD(SendMessage(hwndClient, WM_MDIGETACTIVE, 0, 0L));
  if(!IsIconic(hwndChild))
   SendMessage(hwndClient, WM_MDIRESTORE, hwndChild, 0L);
  }//Ruecksetzen des Fensters ist unbedingt noetig

 Fenster.aktuell ++;

 if(Fenster.neu != 4)
  Fenster.neu = Fenster.aktuell;


 if((Fenster.null == TRUE) && (Fenster.aktuell != 0))//mindestens 1 Fenster
  {                                                  //offen
  EnableMenuItem(hMenu, IDM_SALLE, MF_ENABLED);
  EnableMenuItem(GetSubMenu(hMenu, 3), 2, MF_ENABLED|MF_BYPOSITION);
  EnableMenuItem(GetSubMenu(hMenu, 3), 3, MF_ENABLED|MF_BYPOSITION);
  Fenster.null = FALSE;
  }

 if(Fenster.aktuell == 4)
  {
  EnableMenuItem(hMenu, IDM_OALLE, MF_GRAYED);
  EnableMenuItem(GetSubMenu(hMenu, 3), 1, MF_GRAYED|MF_BYPOSITION);
  Fenster.alle = TRUE;
  }
 return;
}



void FensterDest(HWND hwndClient) //erledigt Verwaltungsarbeiten bei
				  //Zerstoerung von Tochterfenstern
{
 HWND hwndChild;


 Fenster.aktuell--;

 if(Fenster.aktuell != 0)
  {
  hwndChild = LOWORD(SendMessage(hwndClient, WM_MDIGETACTIVE, 0, 0L));
  if(!IsIconic(hwndChild))
   SendMessage(hwndClient, WM_MDIRESTORE, hwndChild, 0L);
  }//Ruecksetzen des Fensters ist unbedingt noetig

 if(Fenster.neu != 0)
  Fenster.neu = Fenster.aktuell;

 if((Fenster.alle == TRUE) && (Fenster.aktuell != 4))
  {
  EnableMenuItem(hMenu, IDM_OALLE, MF_ENABLED);
  EnableMenuItem(GetSubMenu(hMenu, 3), 1, MF_ENABLED|MF_BYPOSITION);
  Fenster.alle = FALSE;
  }

 if(Fenster.aktuell == 0)//kein Fenster offen
  {
  EnableMenuItem(hMenu, IDM_SALLE, MF_GRAYED);
  EnableMenuItem(GetSubMenu(hMenu, 3), 2, MF_GRAYED|MF_BYPOSITION);
  EnableMenuItem(GetSubMenu(hMenu, 3), 3, MF_GRAYED|MF_BYPOSITION);
  EnableMenuItem(hMenu, IDM_RUN, MF_GRAYED);
  Fenster.null = TRUE;
  }
 return;
}


void OrdnenAufbau(HWND hwnd, char z)
     //Ordnet Tochterfenster nach Initialisierung neu an
{
 BOOL  links = FALSE;
 BOOL  icon;
 short anzahl;
 char  i;
 char  f[3];
 void  Ort(char, char);
 void  Verschieben(HWND, char);


 if((Fenster.SF && IsIconic(hwndSF))||(Fenster.HFK && IsIconic(hwndHFK))||
    (Fenster.ETP && IsIconic(hwndETP))||(Fenster.PAR && IsIconic(hwndPAR)))
  icon = TRUE;
 else
  icon = FALSE;

 if(Fenster.neu == 1)
  {
  Ort(z, 'm');
  if(!icon)
   Verschieben(hwnd, 'm');
  }

 if(Fenster.neu == 2)
  {
  Ort(z, 'l');
  if(!icon)
   Verschieben(hwnd, 'l');
  if(Fenster.SF)
   Ort('f', 'r');
  else if(Fenster.HFK)
   Ort('k', 'r');
  else if(Fenster.ETP)
   Ort('v', 'r');
  else if(Fenster.PAR)
   Ort('p', 'r');
  }

 if(Fenster.neu == 3)
  {
  if(Fenster.SF)//Fehlerfolge ist immer unten
   {
   Ort('f', 'u');
   Ort( z, 'v');
   links = TRUE;
   if(!icon)
    Verschieben(hwnd, 'v');
   }
  else if(z == 'f')
   {
   Ort( z, 'u');
   if(!icon)
    Verschieben(hwnd, 'u');
   }

  if(!Fenster.SF && (z != 'f'))//Fehlerfolge ist nicht offen
   {
   if(Fenster.PAR)//->Parameter ist immer unten
    {
    Ort('p', 'u');
    Ort( z, 'v');
    links = TRUE;
    if(!icon)
     Verschieben(hwnd, 'v');
    }
   else
    {
    Ort( z, 'u');//z == 'p'(immer)
    if(!icon)
     Verschieben(hwnd, 'u');
    }
   }

  if(Fenster.PAR && links && (Fenster.SF || (z == 'f')))
   Ort('p', 'w');
  else if(Fenster.PAR && !links && (Fenster.SF || (z == 'f')))
   {
   Ort('p', 'v');
   links = TRUE;
   }

  if(Fenster.HFK && links)
   Ort('k', 'w');
  else if(Fenster.HFK && !links)
   {
   Ort('k', 'v');
   links = TRUE;
   }

  if(Fenster.ETP)
   Ort('v', 'w');
  }


 if(Fenster.neu == 4)// && Fenster.aktuell == 4
      //Fenster werden dann alle auf einmal verschoben,
      //werden aber zuerst gross dargestellt
  {
  Ort('f', 'a');
  Ort('k', 'b');
  Ort('v', 'c');
  Ort('p', 'd');

  if((z == 'f' ) && !icon)
   Verschieben(hwnd, 'a');

  if((z == 'k' ) && !icon)
   Verschieben(hwnd, 'b');

  if((z == 'v' ) && !icon)
   Verschieben(hwnd, 'c');

  if((z == 'p' ) && !icon)
   Verschieben(hwnd, 'd');
  }

 if(!icon)//zeichnet Fenster nur, falls keines als Ikone dargestellt ist
  {
  if(Fenster.SF)
   Verschieben(hwndSF, SF.ort);

  if(Fenster.HFK)
   Verschieben(hwndHFK, HFK.ort);

  if(Fenster.ETP)
   Verschieben(hwndETP, ETP.ort);

  if(Fenster.PAR)
   Verschieben(hwndPAR, PAR.ort);
  }
 else//zeichnet Fenster nur, falls mindestens ein Fenster
     //als Ikone existiert
  {
  anzahl = Fenster.neu;
  if(Fenster.SF && IsIconic(hwndSF))
   anzahl --;
  if(Fenster.HFK && IsIconic(hwndHFK))
   anzahl --;
  if(Fenster.ETP && IsIconic(hwndETP))
   anzahl --;
  if(Fenster.PAR && IsIconic(hwndPAR))
   anzahl --;

  if(anzahl == 1)
   Verschieben(hwnd, 'g');

  if(anzahl == 2)
   {
   if(Fenster.aktuell == Fenster.neu)//noetig, da auch 2 Fenster
				     //gleichzeitig aufgehen koennen
    Verschieben(hwnd, 'e');
   else
    Verschieben(hwnd, 'f');
   if(Fenster.SF && !IsIconic(hwndSF))
    Verschieben(hwndSF, 'f');
   if(Fenster.HFK && !IsIconic(hwndHFK))
    Verschieben(hwndHFK, 'f');
   if(Fenster.ETP && !IsIconic(hwndETP))
    Verschieben(hwndETP, 'f');
   if(Fenster.PAR && !IsIconic(hwndPAR))
    Verschieben(hwndPAR, 'f');
   }

  if(anzahl == 3)
   {
   if(Fenster.SF && IsIconic(hwndSF))
    i = 'f';
   else if(Fenster.HFK && IsIconic(hwndHFK))
    i = 'k';
   else if(Fenster.ETP && IsIconic(hwndETP))
    i = 'v';
   else
    i = 'p';

   if(i != 'f')
    f[0] = 'f';

   if(i != 'k' && f[0] != 'f')
    f[0] = 'k';
   else if(i != 'k' && f[0] == 'f')
    f[1] = 'k';

   if(i != 'v' && f[1] != 'k')
    f[1] = 'v';
   else if(i != 'v' && f[1] == 'k')
    f[2] = 'v';

   if(i != 'p')
    f[2] = 'p';

   if(z == 'f')
    Verschieben(hwnd, 'h');

   if(z == 'k' && f[0] == 'f')
    Verschieben(hwnd, 'i');
   else if(z == 'k' && f[0] == 'k')
    Verschieben(hwnd, 'h');

   if(z == 'v' && f[1] == 'k')
    Verschieben(hwnd, 'j');
   else if(z == 'v' && f[1] == 'v')
    Verschieben(hwnd, 'i');

   if(z == 'p')
    Verschieben(hwnd, 'j');

   if(Fenster.SF && !IsIconic(hwndSF) && f[0] == 'f')
    Verschieben(hwndSF, 'h');

   if(Fenster.HFK && !IsIconic(hwndHFK) && f[0] == 'f')
    Verschieben(hwndHFK, 'i');
   else if(Fenster.HFK && !IsIconic(hwndHFK) && f[0] == 'k')
    Verschieben(hwndHFK, 'h');

   if(Fenster.ETP && !IsIconic(hwndETP) && f[1] == 'k')
    Verschieben(hwndETP, 'j');
   else if(Fenster.ETP && !IsIconic(hwndETP) && f[1] == 'v')
    Verschieben(hwndETP, 'i');

   if(Fenster.PAR && !IsIconic(hwndPAR))
    Verschieben(hwndPAR, 'j');
   }
  }

 return;
}


void OrdnenAbbau(HWND hwndClient) //Ordnet Tochterfenster
				  //nach Zerstoerung neu an
{
 void  Ort(char, char);
 void  Tile(HWND);
 BOOL  links = FALSE;
 BOOL  unten = FALSE;

 if(Fenster.aktuell == 1)
  {
  if(Fenster.SF)
   Ort('f', 'm');
  else if(Fenster.HFK)
   Ort('k', 'm');
  else if(Fenster.ETP)
   Ort('v', 'm');
  else if(Fenster.PAR)
   Ort('p', 'm');
  }

 if(Fenster.aktuell == 2)
  {
  if(Fenster.SF)
   {
   Ort('f', 'l');
   links = TRUE;
   }

  if(Fenster.HFK && links)
   Ort('k', 'r');
  else if(Fenster.HFK && !links)
   {
   Ort('k', 'l');
   links = TRUE;
   }

  if(Fenster.ETP && links)
   Ort('v', 'r');
  else if(Fenster.ETP && !links)
   Ort('v', 'l');

  if(Fenster.PAR)
   Ort('p', 'r');
  }


 if(Fenster.aktuell == 3)
  {
   if(Fenster.SF)
    {
    Ort('f', 'u');
    unten = TRUE;
    }

   if(Fenster.PAR && unten)
    {
    Ort('p', 'v');
    links = TRUE;
    }
   else if(Fenster.PAR && !unten)
    {
    Ort('p', 'u');
    unten = TRUE;
    }

   if(Fenster.HFK && links)
    Ort('k', 'w');
   else if(Fenster.HFK && !links)
    Ort('k', 'v');

   if(Fenster.ETP)
    Ort('v', 'w');
  }
 Tile(hwndClient);
 return;
}


void Tile(HWND hwndClient) //Ordnet Tochterfenster bei Aufruf
			   //in gespeicherter Position an
{
 void  Verschieben(HWND, char);
 HWND  hwndChild;

 if((Fenster.SF && IsIconic(hwndSF))||(Fenster.HFK && IsIconic(hwndHFK))||
    (Fenster.ETP && IsIconic(hwndETP))||(Fenster.PAR && IsIconic(hwndPAR)))
  SendMessage(hwndClient, WM_MDITILE, 0, 0L);//falls Ikone existiert
   //wird Anordnen System ueberlassen
 else
  {
  hwndChild = LOWORD(SendMessage(hwndClient, WM_MDIGETACTIVE, 0, 0L));
  if(!IsIconic(hwndChild))
   SendMessage(hwndClient, WM_MDIRESTORE, hwndChild, 0L);

  if(Fenster.SF)
   Verschieben(hwndSF, SF.ort);

  if(Fenster.HFK)
   Verschieben(hwndHFK, HFK.ort);

  if(Fenster.ETP)
   Verschieben(hwndETP, ETP.ort);

  if(Fenster.PAR)
   Verschieben(hwndPAR, PAR.ort);
  }
 return;
}




void Verschieben(HWND hwnd, char o) //Verschiebt Tochterfenster
				    // in angegebene Lage
{
 HWND hwndClient;
 RECT rect;
 int  y;


 hwndClient = GetParent(hwnd);
 GetClientRect(hwndClient, &rect);

 switch(o)
  {
  case 'a':
       MoveWindow(hwnd, 0, 0, rect.right/2, rect.bottom/2, TRUE);
       break;

  case 'b':
       MoveWindow(hwnd, rect.right/2, 0, rect.right/2,
		  rect.bottom/2, TRUE);
       break;

  case 'c':
       MoveWindow(hwnd, 0, rect.bottom/2, rect.right/2,
		  rect.bottom/2, TRUE);
       break;

  case 'd':
       MoveWindow(hwnd, rect.right/2, rect.bottom/2,
		  rect.right/2, rect.bottom/2, TRUE);
       break;

  case 'e':
       y = 2.5*GetSystemMetrics(SM_CYICON);
       MoveWindow(hwnd, 0, 0, rect.right/2, rect.bottom-y, TRUE);
       break;

  case 'f':
       y = 2.5*GetSystemMetrics(SM_CYICON);
       MoveWindow(hwnd, rect.right/2, 0, rect.right/2,
		  rect.bottom-y, TRUE);
       break;

  case 'g':
       y = 2.5*GetSystemMetrics(SM_CYICON);
       MoveWindow(hwnd, 0, 0, rect.right, rect.bottom-y, TRUE);
       break;

  case 'h':
       y = 2.5*GetSystemMetrics(SM_CYICON);
       MoveWindow(hwnd, 0, 0, rect.right/3,
		  rect.bottom-y, TRUE);
       break;

  case 'i':
       y = 2.5*GetSystemMetrics(SM_CYICON);
       MoveWindow(hwnd, rect.right/3, 0,
		  rect.right/3, rect.bottom-y, TRUE);
       break;

  case 'j':
       y = 2.5*GetSystemMetrics(SM_CYICON);
       MoveWindow(hwnd, 2*rect.right/3, 0,
		  rect.right/3, rect.bottom-y, TRUE);
       break;

  case 'l':
       MoveWindow(hwnd, 0, 0, rect.right/2, rect.bottom, TRUE);
       break;

  case 'm':
       MoveWindow(hwnd, 0, 0, rect.right, rect.bottom, TRUE);
       break;

  case 'r':
       MoveWindow(hwnd, rect.right/2, 0, rect.right/2, rect.bottom, TRUE);
       break;

  case 'u':
       MoveWindow(hwnd, 0, 2*rect.bottom/3, rect.right,
		  rect.bottom/3, TRUE);
       break;

  case 'v':
       MoveWindow(hwnd, 0, 0, rect.right/2, 2*rect.bottom/3, TRUE);
       break;

  case 'w':
       MoveWindow(hwnd, rect.right/2, 0, rect.right/2,
		  2*rect.bottom/3, TRUE);
       break;
  }
 return;
}



void Ort(char z, char o)//speichert Lage der Fenster
{
 switch(z)
   {
   case 'f':
	SF.ort = o;
	break;

   case 'k':
	HFK.ort = o;
	break;

   case 'v':
	ETP.ort = o;
	break;

   case 'p':
	PAR.ort = o;
	break;

   default:
	break;
   }
 return;
}


