//--------------------------------------------------------------------------
//-------------------------------- HUFFMAN.C -------------------------------
//--------------------------------------------------------------------------
//-- Parametereingabe Huffman-Codierung "Wertdiskrete Informationstheorie" -
//---------------------- Erstellt von: Georg Delle -------------------------



#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include <io.h>
#include <stdio.h>
#include <math.h>
#include <time.h>
#include "wdit.h"
#include "wdit_typ.h"
#include <commdlg.h>
#include "dir.h"


extern LPSTR			  lpstrCod;
extern HWND            hwndSF, hwndHFK, hwndETP, hwndPAR;
extern HMENU           hMenu;
extern HANDLE          hInst;
extern HCURSOR         hCurWait, hCurArrow;
extern HWND            hwndFrame;
extern STRUCT_FENSTER  Fenster;
extern STRUCT_TOCHTER  SF, HFK, ETP, PAR;
extern short			  Modell;
extern LPSTR			  lpstrPar;
extern float			  pBit[2];
extern BOOL				  OK;
extern BOOL				  codiert;
extern BOOL				  Frei_L;
extern BOOL				  Quelle;
extern BOOL            Folge_L;
extern BOOL				  Frei_R;
extern BOOL				  Folgedec;
extern BOOL            Folge_R;
extern char            directory[MAXPATH];
extern char				  szDirName[_MAX_PATH];
extern char				  szPuffer[_MAX_PATH];
extern char            szFile[_MAX_PATH];
extern char				  drive[_MAX_DRIVE];
extern char				  dir[_MAX_DIR];
extern char				  file[_MAX_FNAME];
extern char				  ext[_MAX_EXT];
char						  codedat[_MAX_PATH];
char				  		  CodePuffer[_MAX_PATH];
extern short			  *Bkground;
extern short			  *HervorHeb;
extern short			  Letztes_Zeichen1, Letztes_Zeichen2, Letztes_Zeichen3, Letztes_Zeichen4;
unsigned				  	  CodeLength;
BOOL                   gemc1,gemc2;
BOOL						  selbsterstellt;
BOOL						  ungueltig;
char						  Code_Strn[8][8];
short						  CodeArt=0;
extern double			  Statist_P[8];
extern BOOL				  manuell;
extern float			  Haeufigkeit1[36];
float						  u[15];
float						  HFK_Cod1[2];
float						  HFK_Cod2[2][2];
float						  HFK_Cod3[2][2][2];
float						  HFK_Cod4[2][2][2][2];
float						  HFK_Cod5[2][2][2][2][2];
float						  HFK_Cod6[2][2][2][2][2][2];
float						  HFK_Cod7[2][2][2][2][2][2][2];
float						  HFK_Cod8[2][2][2][2][2][2][2][2];
float						  HFK_Cod9[2][2][2][2][2][2][2][2][2];
float						  HFK_Cod10[2][2][2][2][2][2][2][2][2][2];
long						  lLength;
float						  Schrittzahl;
void 						  HUFFCOD_Erzeugen(void);
void 						  HUFFDatei_Erzeugen(void);
void						  CODEDatei_Erzeugen(void);
void 						  CODEeinlesen(HWND hDlg);
void 						  CODE_kontrolle(void);
void 						  Uebernehmen(HWND hDlg);
extern BOOL				  fehler(char*);
BOOL FAR PASCAL        HUFFCOD_DlgProc(HWND, UINT, UINT, LONG);

BOOL FAR PASCAL HUFFCOD_DlgProc (HWND hDlg, UINT message, UINT wParam, LONG lparam)
{
 short        i;

 switch (message)
  {
  case WM_INITDIALOG :

	SendDlgItemMessage(hDlg, IDD_HUFFCOD1, BM_SETCHECK, 1, 0L);
	SendMessage(hDlg, WM_COMMAND, IDD_HUFFCOD1, 0L);
	for (i=0; i<=7; i++)
	 {
	 EnableWindow(GetDlgItem(hDlg, IDD_CODEa+i), FALSE);
	 SetDlgItemText (hDlg, IDD_CODEa+i, (LPSTR) Code_Strn[i]);
	 }

		 return TRUE ;

  case WM_COMMAND :
		 switch (wParam)
	{

	case IDD_HUFFCOD1:
		  for (i=0; i<=10; i++)
			EnableWindow(GetDlgItem(hDlg, IDD_CODEa+i), FALSE);
		  selbsterstellt=FALSE;
		  HUFFCOD_Erzeugen();
		  for(i=0; i<=7;i++)
			{
			strrev(Code_Strn[i]);
			SetDlgItemText (hDlg, IDD_CODEa+i, (LPSTR) Code_Strn[i]);
			}
		  return TRUE;

	case IDD_HUFFCOD2:
		  for (i=0; i<=10; i++)
			EnableWindow(GetDlgItem(hDlg, IDD_CODEa+i), FALSE);
		  selbsterstellt=FALSE;
		  CODEeinlesen(hDlg);
		  for(i=0; i<=7;i++)
			SetDlgItemText (hDlg, IDD_CODEa+i, (LPSTR) Code_Strn[i]);
		  return TRUE;

	case IDD_HUFFCOD3:
		  for (i=0; i<=10; i++)
			EnableWindow(GetDlgItem(hDlg, IDD_CODEa+i), TRUE);
		  selbsterstellt=TRUE;
		  return TRUE;

	case IDD_HUFFCOD4:
		  for(i=0; i<=7; i++)
			GetDlgItemText (hDlg, IDD_CODEa+i, (LPSTR) Code_Strn[i], 8);
		  Uebernehmen(hDlg);
		  return TRUE;

	case IDOK :

		  if(selbsterstellt)
			{
			for(i=0; i<=7; i++)
			 GetDlgItemText (hDlg, IDD_CODEa+i, (LPSTR) Code_Strn[i], 8);
			}
		  EndDialog (hDlg, 1);
		  return TRUE;


	case IDCANCEL :
		  EndDialog (hDlg, 0);
		  return TRUE ;

	}
		 break ;

  }
 return FALSE ;
}


void HUFFCOD(HWND hwnd)
{
 extern double	  Statist_P[8];
 extern void     Para1_unchecked(void);
 extern void     Para2_unchecked(void);
 void            Umrechnung(HWND, float*);
 FARPROC         lpDlgProc;

 lpDlgProc = MakeProcInstance((FARPROC)HUFFCOD_DlgProc, hInst);
 OK=DialogBox(hInst, "HUFFCOD", hwnd, lpDlgProc);
 FreeProcInstance(lpDlgProc);

 if(OK)
  {
  CODE_kontrolle();
  if(!ungueltig)
	{
	HUFFDatei_Erzeugen();
	if(!selbsterstellt)
	 CODEDatei_Erzeugen();
	}
  if(Fenster.SF)
	InvalidateRect(hwndSF, NULL, TRUE);
  if(Fenster.HFK)
	InvalidateRect(hwndHFK, NULL, TRUE);
  if(Fenster.ETP)
	InvalidateRect(hwndETP, NULL, TRUE);
  if(Fenster.PAR)
	InvalidateRect(hwndPAR, NULL, TRUE);
  }
 return;
}


void HUFFCOD_Erzeugen(void)
 {
 extern double	  Statist_P[8];
 float			  low1, low2, Puffer;
 int				  i, j=0, k, index1, index2, Start;
 int				  Knoten_l[7][8];
 int				  Knoten_r[7][8];
 BOOL				  gueltig[15];
 short			  Stelle[8];
 short			  Code[8][8];


//Initialisieren
 for(i=0; i<=14; i++)
  gueltig[i]=TRUE;

 for(i=8; i<=14; i++)
  u[i]=0.0;

 for(i=0; i<=6; i++)
  {
  for(j=0; j<=7; j++)
	{
	Knoten_l[i][j]=100;
	Knoten_r[i][j]=100;
	}
  }

 for(i=0; i<=7; i++)
  Stelle[i]=0;

 for(i=0; i<=7; i++)
  {
  for(j=0; j<=7; j++)
	Code[i][j]=2;
  }

 for(i=0; i<=7; i++)
  stpcpy(Code_Strn[i], "");

for(j=0; j<=6; j++)
 {
//Auswahl gltiger Wahrscheinlichkeiten > '0'
 for(i=0; i<=14; i++)
  {
  if(u[i]==1.0)
	break;
  if(gueltig[i]==TRUE)
	{
	if(u[i]>0)
	 {
	 low1=u[i];
	 index1=i;
	 break;
	 }
	}
  }
 if(u[i]==1.0)
  break;
 for(i=(index1+1); i<=14; i++)
  {
  if(gueltig[i]==TRUE)
	{
	if(u[i]>0)
	 {
	 low2=u[i];
	 index2=i;
	 break;
	 }
	}
  }

 if(u[i]==1.0)
  break;
 if(low1>low2)
  {
  Puffer=low1;
  low1=low2;
  low2=Puffer;
  Puffer=index1;
  index1=index2;
  index2=Puffer;
  }
 if(index1>index2)
  Start=index1;
 else
  Start=index2;

//Auswahl der niedrigsten Wahrscheinlichkeiten
 for(i=(Start+1); i<=14; i++)
  {
  if(gueltig[i]==TRUE)
	{
  Puffer=u[i];
  if(Puffer>0 && Puffer<low1)
	{
	low2=low1;
	index2=index1;
	low1=Puffer;
	index1=i;
	}
  else if(Puffer>0 && Puffer<low2)
	{
	low2=Puffer;
	index2=i;
	}
	}
  }
 u[j+8]=low1+low2;
 gueltig[index1]=FALSE;
 gueltig[index2]=FALSE;

 Knoten_l[j][0]=index1;
 Knoten_r[j][0]=index2;
 }


//Liste der abhngigen Knoten erstellen
 for(i=0; i<=6; i++)
  {
  j=0;
  k=0;
  if(Knoten_l[i][0]>7 && Knoten_l[i][0]<100)
	{
	Puffer=Knoten_l[i][0];
	while(Knoten_l[Puffer-8][k]<100)
	 {
	 Knoten_l[i][j]=Knoten_l[Puffer-8][k];
	 j++;
	 k++;
	 }
	k=0;
	while(Knoten_r[Puffer-8][k]<100)
	 {
	 Knoten_l[i][j]=Knoten_r[Puffer-8][k];
	 j++;
	 k++;
	 }
	}

  j=0;
  k=0;
  if(Knoten_r[i][0]>7 && Knoten_r[i][0]<100)
	{
	Puffer=Knoten_r[i][0];
	while(Knoten_l[Puffer-8][k]<100)
	 {
	 Knoten_r[i][j]=Knoten_l[Puffer-8][k];
	 j++;
	 k++;
	 }
	k=0;
	while(Knoten_r[Puffer-8][k]<100)
	 {
	 Knoten_r[i][j]=Knoten_r[Puffer-8][k];
	 j++;
	 k++;
	 }
	}
  }

//Code erzeugen
  for(i=0; i<=6; i++)
	{
	k=0;
	while(Knoten_l[i][k]<100)
	 {
	 Puffer=Knoten_l[i][k];
	 Code[Puffer][Stelle[Puffer]]=0;
	 if(Stelle[Puffer]==0)
	  stpcpy(Code_Strn[Puffer], "0");
	 else
	  strcat(Code_Strn[Puffer], "0");
	 Stelle[Puffer]++;
	 k++;
	 }

	k=0;
	while(Knoten_r[i][k]<100)
	 {
	 Puffer=Knoten_r[i][k];
	 Code[Puffer][Stelle[Puffer]]=1;
	 if(Stelle[Puffer]==0)
	  stpcpy(Code_Strn[Puffer], "1");
	 else
	  strcat(Code_Strn[Puffer], "1");
	 Stelle[Puffer]++;
	 k++;
	 }
	}

 return;
}


void HUFFDatei_Erzeugen(void)
{
 int			   laenge,hFile1,hFile2;
 char 		   Zeichen;
 unsigned		i, j, k, l, m, n, o, p, q, r, s;
 extern void   Haeufigk_zaehlen(BOOL m);
 extern void   Entropie_berechnen(short Letztes_Zeichen1, short Letztes_Zeichen2,
								short Letztes_Zeichen3, short Letztes_Zeichen4);

 if(!HFK.ermittelt1)
  {
  Haeufigk_zaehlen(FALSE);
  Entropie_berechnen(Letztes_Zeichen1, Letztes_Zeichen2,
							Letztes_Zeichen3, Letztes_Zeichen4);
  HFK.ermittelt1 = TRUE;
  ETP.ermittelt1 = TRUE;
  }

 SetCursor(hCurWait);
 memset((lpstrCod), 0, 65500U);
 if(Modell==5)
  {
  strcpy(szPuffer, szFile);
  laenge=strlen(szPuffer);
  hFile1 = _lopen((LPSTR)szPuffer, OF_READ|OF_SHARE_DENY_WRITE);
  lLength = filelength(hFile1);
  szPuffer[laenge-3]='h';
  szPuffer[laenge-2]='u';
  szPuffer[laenge-1]='f';
  strcpy(CodePuffer, szPuffer);
  memset((lpstrPar), 0, 65500U);
  _lread (hFile1, lpstrPar, (unsigned)lLength);
  }
 if(Modell==1)
  {
  strcpy(szFile, szDirName);
  strcat(szFile, "\\CODEDAT.HUF");
  strcpy(szPuffer, szFile);
  strcpy(CodePuffer, szPuffer);
  }

  hFile2= _lcreat (szPuffer, 0);
  if(hFile2==-1)
	{
	MessageBox(hwndFrame, (LPSTR) "Huffman-Datei kann nicht erzeugt werden!\n\n"
											"Mglicher Fehler:\n"
											"Umgebungsvariable 'RTEMP' falsch gesetzt.",
		 (LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
	_lclose (hFile2);
	return;
	}

  l=0;
  for(i=1; i<=lLength; i++)
	{
	Zeichen=*(lpstrPar+i-1);
	if(Zeichen==32)
	 Zeichen=7;
	else
	 Zeichen-=65;
	_llseek (hFile2, 0, 2);

	k=strlen(Code_Strn[Zeichen])-1;
	for(j=0; j<=k; j++)
	 {
	 *(lpstrCod+l)=Code_Strn[Zeichen][j];
	 l++;
	 if(l>65000L)
	  {
	  MessageBox(hwndFrame, (LPSTR)"Offensichtlich wurde ein vllig\n"
											"unsinniger Huffman-Code verwendet!\n\n"
											"Bitte anderen Huffman-Code eingeben.",
		 (LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
	  _lclose(hFile1);
	  _lclose (hFile2);
	  codiert=FALSE;
	  Frei_L=FALSE;
	  Quelle=TRUE;
	  Folge_L=FALSE;
	  Frei_R=TRUE;
	  Folge_R=FALSE;
	  Folgedec=FALSE;
	  return;
	  }
	 }
	Bkground[i-1]=strlen(Code_Strn[Zeichen]);
	}
  CodeLength=l;

  _lwrite (hFile2, lpstrCod, l);

  Schrittzahl=(float)l/(float)lLength;

  _lclose(hFile1);
  _lclose(hFile2);

  memset(HFK_Cod1, 0, 8);
  memset(HFK_Cod2, 0, 16);
  memset(HFK_Cod3, 0, 32);
  memset(HFK_Cod4, 0, 64);
  memset(HFK_Cod5, 0, 128);
  memset(HFK_Cod6, 0, 256);
  memset(HFK_Cod7, 0, 512);
  memset(HFK_Cod8, 0, 1024);
  memset(HFK_Cod9, 0, 2048);
  memset(HFK_Cod10, 0, 4096);

  for(i=0; i<=l-1; i++)
	HFK_Cod1[*(lpstrCod+i)-48]++;
  for(i=0; i<=l-2; i++)
	HFK_Cod2[*(lpstrCod+i)-48][*(lpstrCod+i+1)-48]++;
  for(i=0; i<=l-3; i++)
	HFK_Cod3[*(lpstrCod+i)-48][*(lpstrCod+i+1)-48][*(lpstrCod+i+2)-48]++;
  for(i=0; i<=l-4; i++)
	HFK_Cod4[*(lpstrCod+i)-48][*(lpstrCod+i+1)-48][*(lpstrCod+i+2)-48][*(lpstrCod+i+3)-48]++;
  for(i=0; i<=l-5; i++)
	HFK_Cod5[*(lpstrCod+i)-48][*(lpstrCod+i+1)-48][*(lpstrCod+i+2)-48][*(lpstrCod+i+3)-48][*(lpstrCod+i+4)-48]++;
  for(i=0; i<=l-6; i++)
	HFK_Cod6[*(lpstrCod+i)-48][*(lpstrCod+i+1)-48][*(lpstrCod+i+2)-48][*(lpstrCod+i+3)-48][*(lpstrCod+i+4)-48][*(lpstrCod+i+5)-48]++;
  for(i=0; i<=l-7; i++)
	HFK_Cod7[*(lpstrCod+i)-48][*(lpstrCod+i+1)-48][*(lpstrCod+i+2)-48][*(lpstrCod+i+3)-48][*(lpstrCod+i+4)-48][*(lpstrCod+i+5)-48][*(lpstrCod+i+6)-48]++;
  for(i=0; i<=l-8; i++)
	HFK_Cod8[*(lpstrCod+i)-48][*(lpstrCod+i+1)-48][*(lpstrCod+i+2)-48][*(lpstrCod+i+3)-48][*(lpstrCod+i+4)-48][*(lpstrCod+i+5)-48][*(lpstrCod+i+6)-48][*(lpstrCod+i+7)-48]++;
  for(i=0; i<=l-9; i++)
	HFK_Cod9[*(lpstrCod+i)-48][*(lpstrCod+i+1)-48][*(lpstrCod+i+2)-48][*(lpstrCod+i+3)-48][*(lpstrCod+i+4)-48][*(lpstrCod+i+5)-48][*(lpstrCod+i+6)-48][*(lpstrCod+i+7)-48][*(lpstrCod+i+8)-48]++;
  for(i=0; i<=l-10; i++)
	HFK_Cod10[*(lpstrCod+i)-48][*(lpstrCod+i+1)-48][*(lpstrCod+i+2)-48][*(lpstrCod+i+3)-48][*(lpstrCod+i+4)-48][*(lpstrCod+i+5)-48][*(lpstrCod+i+6)-48][*(lpstrCod+i+7)-48][*(lpstrCod+i+8)-48][*(lpstrCod+i+9)-48]++;

  for(i=0; i<=1; i++)
	{
	HFK_Cod1[i]*=100.0;
	HFK_Cod1[i]/=(float)l;
	for(j=0; j<=1; j++)
	 {
	 HFK_Cod2[i][j]*=100.0;
	 HFK_Cod2[i][j]/=(float)l-1;
	 for(k=0; k<=1; k++)
	  {
	  HFK_Cod3[i][j][k]*=100.0;
	  HFK_Cod3[i][j][k]/=(float)l-2;
	  for(m=0; m<=1; m++)
		{
		HFK_Cod4[i][j][k][m]*=100.0;
		HFK_Cod4[i][j][k][m]/=(float)l-3;
		for(n=0; n<=1; n++)
		 {
		 HFK_Cod5[i][j][k][m][n]*=100.0;
		 HFK_Cod5[i][j][k][m][n]/=(float)l-4;
		 for(o=0; o<=1; o++)
		  {
		  HFK_Cod6[i][j][k][m][n][o]*=100.0;
		  HFK_Cod6[i][j][k][m][n][o]/=(float)l-5;
		  for(p=0; p<=1; p++)
			{
			HFK_Cod7[i][j][k][m][n][o][p]*=100.0;
			HFK_Cod7[i][j][k][m][n][o][p]/=(float)l-6;
			for(q=0; q<=1; q++)
			 {
			 HFK_Cod8[i][j][k][m][n][o][p][q]*=100.0;
			 HFK_Cod8[i][j][k][m][n][o][p][q]/=(float)l-7;
			 for(r=0; r<=1; r++)
			  {
			  HFK_Cod9[i][j][k][m][n][o][p][q][r]*=100.0;
			  HFK_Cod9[i][j][k][m][n][o][p][q][r]/=(float)l-8;
			  for(s=0; s<=1; s++)
				{
				HFK_Cod10[i][j][k][m][n][o][p][q][r][s]*=100.0;
				HFK_Cod10[i][j][k][m][n][o][p][q][r][s]/=(float)l-9;
				}
			  }
			 }
			}
		  }
		 }
		}
	  }
	 }
	}

 codiert=TRUE;
 Folge_R=TRUE;
 Frei_R=FALSE;
 Folgedec=FALSE;
 memset(HervorHeb, 0, 131000L);
 EnableMenuItem(hMenu, IDM_UEBFEHLER, MF_ENABLED);
 SetCursor(hCurArrow);

 return;
}


void CODEDatei_Erzeugen()
{
 int			   i,laenge,hFile;
 char				Zeichen[3];

 SetCursor(hCurWait);

 strcpy(szPuffer, szFile);
 laenge=strlen(szPuffer);

  szPuffer[laenge-3]='c';
  szPuffer[laenge-2]='o';
  szPuffer[laenge-1]='d';
  hFile= _lcreat (szPuffer, 0);

  for(i=0; i<=7; i++)
	{
	_llseek (hFile, 0, 2);
	sprintf (Zeichen, "%c", 65+i);
	_lwrite (hFile, Zeichen, strlen(Zeichen));
	_llseek (hFile, 0, 2);
	_lwrite (hFile, Code_Strn[i], strlen(Code_Strn[i]));
	}

  _lclose(hFile);
  SetCursor(hCurArrow);

 return;
}

void CODEeinlesen(HWND hDlg)
{
 OPENFILENAME 	  ofn;
 short			  i,j;
 int          	  hFile;
 char				  Zeichen[2]="";
 long				  sLengthCod;
 char        	  *szFilter[] = {"Code-Datei (*.cod)","*.cod", ""};

 codedat[0] = '\0';

 ofn.lStructSize        = sizeof(OPENFILENAME);
 ofn.hwndOwner          = hDlg;
 ofn.hInstance          = (HANDLE)NULL;
 ofn.lpstrFilter        = szFilter[0];
 ofn.lpstrCustomFilter  = (LPSTR)NULL;
 ofn.nMaxCustFilter     = 0L;
 ofn.nFilterIndex       = 0L;
 ofn.lpstrFile          = codedat;
 ofn.nMaxFile           = sizeof(codedat);
 ofn.lpstrFileTitle     = NULL;
 ofn.nMaxFileTitle      = 0;
 ofn.lpstrInitialDir    = szDirName;
 ofn.lpstrTitle         = (LPSTR)"Wertdiskrete Informationstheorie";
 ofn.Flags              = OFN_HIDEREADONLY;
 ofn.nFileOffset        = 0;
 ofn.nFileExtension     = 0;
 ofn.lpstrDefExt        = (LPSTR)NULL;
 ofn.lCustData          = 0L;
 ofn.lpfnHook           = (FARPROC)NULL;
 ofn.lpTemplateName     = (LPSTR)NULL;

 for(i=0; i<=7; i++)
  stpcpy(Code_Strn[i], "");

 if(GetOpenFileName(&ofn))
  {
  _splitpath(codedat, drive, dir, file, ext);
  if(stricmp(ext, ".cod"))
	{
	MessageBox(hwndFrame, (LPSTR) "Kein gltiger Dateiname!",
		(LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
	return;
	}
	_makepath(szDirName, drive, dir, "", "");
	_fullpath(szDirName, szDirName, _MAX_PATH);
  SetCursor(hCurWait);
  if(-1 == (hFile = _lopen ((LPSTR)codedat, OF_READ|OF_SHARE_DENY_WRITE)))
	{
	MessageBox(hwndFrame, (LPSTR) "Datei kann nicht gelesen werden!",
		 (LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
	_lclose (hFile);
	return;
	}
  sLengthCod=filelength(hFile);

//Code einlesen
  for(i=1; i<=sLengthCod; i++)
	{
	_lread (hFile, Zeichen, (WORD)1);
	if(Zeichen[0]>=65 && Zeichen[0]<=72)
	 j=Zeichen[0]-65;
	else
	 strcat(Code_Strn[j], Zeichen);
	}

  _lclose(hFile);
  SetCursor(hCurArrow);

  }
 return;
}

void CODE_kontrolle(void)
 {
 short			i,j,k;

 ungueltig=FALSE;
 for(i=0; i<=7; i++)
  {
  k=strlen(Code_Strn[i]);
  for(j=0; j<=(k-1); j++)
	{
	if(Code_Strn[i][j] !=48 && Code_Strn[i][j] !=49 && Code_Strn[i][j] !=0)
	 {
	 ungueltig=TRUE;
	 break;
	 }
	}
  }

 if(ungueltig)
	 MessageBox(hwndFrame, (LPSTR) "Kein g\374ltiger Code!\n\n"
			 "Code darf nur aus '0' und '1' bestehen",
			(LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);

 return;
 }


void Uebernehmen(HWND hDlg)
{
 OPENFILENAME ofn;
 BOOL         SaveFolge(BOOL, BOOL);
 void         Datei_ueberschrieben(void);
 char         *szFilter[] = {"Fehlerfolge (*.cod)","*.cod", ""};

 szPuffer[0] = '\0';

 ofn.lStructSize        = sizeof(OPENFILENAME);
 ofn.hwndOwner          = hDlg;
 ofn.hInstance          = (HANDLE)NULL;
 ofn.lpstrFilter        = szFilter[0];
 ofn.lpstrCustomFilter  = (LPSTR)NULL;
 ofn.nMaxCustFilter     = 0L;
 ofn.nFilterIndex       = 0L;
 ofn.lpstrFile          = codedat;
 ofn.nMaxFile           = sizeof(codedat);
 ofn.lpstrFileTitle     = NULL;
 ofn.nMaxFileTitle      = 0;
 ofn.lpstrInitialDir    = NULL;
 ofn.lpstrTitle         = (LPSTR)"Wertdiskrete Informationstheorie";
 ofn.Flags              = OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT;
 ofn.nFileOffset        = 0;
 ofn.nFileExtension     = 0;
 ofn.lpstrDefExt        = (LPSTR)"COD";
 ofn.lCustData          = 0L;
 ofn.lpfnHook           = (FARPROC)NULL;
 ofn.lpTemplateName     = (LPSTR)NULL;

 if(GetSaveFileName(&ofn))
  {
  _splitpath(codedat, drive, dir, file, ext);
  if(stricmp(ext, ".cod"))
	{
	MessageBox(hDlg, (LPSTR) "Kein gltiger Dateiname!",
		(LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
	return;
	}
  SetCursor(hCurWait);
  CODEDatei_Erzeugen();
  SetCursor(hCurArrow);
  }
 return;
}


BOOL FAR PASCAL        UEBFEHLER_DlgProc(HWND, UINT, UINT, LONG);

BOOL FAR PASCAL UEBFEHLER_DlgProc (HWND hDlg, UINT message, UINT wParam, LONG lparam)
 {
 int				i;
 char         szString[15];


 switch (message)
  {
  case WM_INITDIALOG :

	 for (i=0; i<=1; i++)
	  {
	  gcvt (pBit[i], 7, szString);
	  SetDlgItemText (hDlg, IDD_PBIT0+i, (LPSTR) szString);
	  }
	 if(manuell)
	  CheckDlgButton(hDlg, IDD_MANUELL, 1);
	 else
	  CheckDlgButton(hDlg, IDD_MANUELL, 0);

		 return TRUE ;

  case WM_COMMAND :
		 switch (wParam)
	{

	case IDOK :

			  if(IsDlgButtonChecked(hDlg, IDD_MANUELL))
				manuell=TRUE;
			  else
			  	manuell=FALSE;

			  for (i=0; i<=1; i++)
				{
				GetDlgItemText (hDlg, IDD_PBIT0+i, (LPSTR) szString, 7);
				pBit[i]=atof(szString);
				if (pBit[i]<0 || pBit[i]>1 || fehler(&szString[0]))
				 {
				 if(MessageBox (hDlg,"Unzul\344ssiger Wert f\374r"
				  " Wahrscheinlichkeit!\n\n"
				  "M\366gliche Fehler:\n"
				  " - Wert > 1\n"
				  " - Wert < 0\n"
				  " - Komma wurde verwendet",
				  "Wertdiskrete Informationstheorie", MB_RETRYCANCEL | MB_ICONSTOP) == IDRETRY)
				  return TRUE;
				 else
				  {
				  EndDialog (hDlg, 0);
				  return TRUE;
				  }
				 }
				}

		  EndDialog (hDlg, 1);
		  return TRUE;


	case IDCANCEL :
		  EndDialog (hDlg, 0);
		  return TRUE ;

	}
		 break ;

  }
 return FALSE ;
}


void Uebertragungsfehler1(HWND hwnd)
 {
 FARPROC          lpDlgProc;
 int					laenge, Zufall;
 int					hFile;
 unsigned			i;
 long					Cod_Groes;

 lpDlgProc = MakeProcInstance((FARPROC)UEBFEHLER_DlgProc, hInst);
 OK=DialogBox(hInst, "UEBFEHLER", hwnd, lpDlgProc);
 FreeProcInstance(lpDlgProc);

 if(OK)
  {
  strcpy(szPuffer, szFile);
  laenge=strlen(szPuffer);
  szPuffer[laenge-3]='h';
  szPuffer[laenge-2]='u';
  szPuffer[laenge-1]='f';
  hFile = _lopen((LPSTR)szPuffer, OF_READ|OF_SHARE_DENY_WRITE);
  Cod_Groes = filelength(hFile);
  memset(lpstrCod, 0, 65500U);
  _lread (hFile, lpstrCod, (unsigned)65000L);
  randomize();
  for(i=0; i<=(Cod_Groes-1); i++)
	{
	Zufall=random(10001);
	if(*(lpstrCod+i)==48)
	 {
	 if(Zufall<pBit[0]*10000)
	  {
	  *(lpstrCod+i)=49;
	  HervorHeb[i]=1;
	  }
	 }
	else
	 {
	 if(Zufall<pBit[1]*10000)
	  {
	  *(lpstrCod+i)=48;
	  HervorHeb[i]=1;
	  }
	 }
	}

  _lclose(hFile);
  hFile= _lcreat (szPuffer, 0);
  _lwrite(hFile, lpstrCod, (unsigned)Cod_Groes);
  _lclose(hFile);
  InvalidateRect(hwndSF, NULL, TRUE);
  }

 return;
 }
