//-------------------------------------------------------------------------
//-------------------------------- MARKOV.C -------------------------------
//-------------------------------------------------------------------------
//--- Parametereingabe Markov-Quellen "Wertdiskrete Informationstheorie" --
//---------------------- Erstellt von: Georg Delle ------------------------


#include <windows.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "wdit.h"
#include "wdit_typ.h"


extern HMENU           hMenu;
extern HANDLE          hInst;
extern STRUCT_FENSTER  Fenster;
extern STRUCT_TOCHTER  SF, HFK, ETP, PAR;
extern short			  Modell;
extern float			  pMarkov2[2];
extern float			  pMarkov3;
extern float			  KonstMarkov;
extern unsigned		  Datei_Groes;
double					  W[3];
double					  H[4], H_unend;
extern BOOL				  OK;

BOOL FAR PASCAL        MARKOV2_DlgProc(HWND, UINT, UINT, LONG);
BOOL FAR PASCAL        MARKOV3_DlgProc(HWND, UINT, UINT, LONG);

BOOL FAR PASCAL MARKOV2_DlgProc (HWND hDlg, UINT message, UINT wParam, LONG lparam)
{
 static HANDLE	hMF;
 HWND         hwndBild;
 PAINTSTRUCT  ps;
 HDC          hdc;
 RECT         rect;
 char         szString[15];
 short        i;
 extern BOOL  fehler(char*);

 switch (message)
  {
  case WM_INITDIALOG :

		 for(i=0; i<=1; i++)
		  {
		  gcvt ((1.0-pMarkov2[i]), 7, szString);
		  SetDlgItemText (hDlg, IDD_pAA+i, (LPSTR) szString);
		  }
		 ltoa (Datei_Groes, szString, 10);
		 SetDlgItemText (hDlg, IDD_GROES_M2, (LPSTR) szString);

		 return TRUE ;

  case WM_COMMAND :
		 switch (wParam)
	{

	case IDOK :

		 for(i=0; i<=1; i++)
		  {
		  GetDlgItemText (hDlg, IDD_pAA+i, (LPSTR) szString, 7);
		  pMarkov2[i]=1.0-atof(szString);

				if (pMarkov2[i]<0 || pMarkov2[i]>1 || fehler(&szString[0]))
				 {
				 if(MessageBox (hDlg,"Unzulssiger Wert!\n\n"
				  "Mgliche Fehler:\n"
				  "Wahrscheinlichkeit 'p' mu im Bereich\n"
				  "0<=p<=1 liegen;\n"
				  "Komma wurde verwendet;",
				  "Wertdiskrete Informationstheorie", MB_RETRYCANCEL | MB_ICONSTOP) == IDRETRY)
				  return TRUE;
				 else
				  {
				  EndDialog (hDlg, 0);
				  return TRUE;
				  }
				 }
		  }

		  GetDlgItemText (hDlg, IDD_GROES_M2, (LPSTR) szString, 7);
		  Datei_Groes=(unsigned)atol(szString);

		  if(fehler(&szString[0]))
				 {
				 if(MessageBox (hDlg,"Unzulssiger Wert fr Gre!",
				  "Wertdiskrete Informationstheorie", MB_RETRYCANCEL | MB_ICONSTOP) == IDRETRY)
				  return TRUE;
				 else
				  {
				  EndDialog (hDlg, 0);
				  return TRUE;
				  }
				 }
			  if(Datei_Groes>60000U)
				{
				if(MessageBox (hDlg,"Die Groesse der Folge darf 60000 nicht berschreiten!",
					"Wertdiskrete Informationstheorie", MB_RETRYCANCEL | MB_ICONSTOP) == IDRETRY)
				 return TRUE;
				else
				 {
				 EndDialog (hDlg, 0);
				 return TRUE;
				 }
				}

		  EndDialog (hDlg, 1);
		  return TRUE;

	case IDCANCEL :
		  EndDialog (hDlg, 0);
		  return TRUE ;

	}
		 break ;

  case WM_PAINT:
		 hwndBild = GetDlgItem(hDlg, IDD_PAINT);
		 hdc = BeginPaint (hwndBild, &ps);
		 SetMapMode (hdc, MM_ISOTROPIC);
		 GetClientRect (hwndBild, &rect);
		 SetWindowExt (hdc, rect.right, rect.bottom);
		 SetViewportExt (hdc, rect.right, rect.bottom);
		 SetViewportOrg (hdc, 0, 0);
		 hMF=GetMetaFile("markov2.wmf");
		 PlayMetaFile(hdc, hMF);
		 DeleteMetaFile(hMF);
		 EndPaint (hwndBild, &ps);
		 break;
  }
 return FALSE ;
}


void Markov2_Datei(HWND hwnd)
{
 extern void     Markov2_Erzeugen(float pAA, float pBB, unsigned Datei_Groes);
 extern void     Para2_unchecked(void);
 FARPROC         lpDlgProc;

 lpDlgProc = MakeProcInstance((FARPROC)MARKOV2_DlgProc, hInst);
 OK=DialogBox(hInst, "MARKOV2", hwnd, lpDlgProc);
 FreeProcInstance(lpDlgProc);

 if(OK)
  Markov2_Erzeugen(pMarkov2[0], pMarkov2[1], Datei_Groes);

 return;
}


BOOL FAR PASCAL MARKOV3_DlgProc (HWND hDlg, UINT message, UINT wParam, LONG lparam)
{
 static HANDLE	hMF;
 HWND         hwndBild;
 PAINTSTRUCT  ps;
 HDC          hdc;
 RECT         rect;
 char         szString[15];
 extern BOOL  fehler(char*);

 switch (message)
  {
  case WM_INITDIALOG :

		 gcvt (pMarkov3, 7, szString);
		 SetDlgItemText (hDlg, IDD_UEB_P3, (LPSTR) szString);
		 gcvt (KonstMarkov, 7, szString);
		 SetDlgItemText (hDlg, IDD_KONST, (LPSTR) szString);
		 ltoa (Datei_Groes, szString, 10);
		 SetDlgItemText (hDlg, IDD_GROES_M3, (LPSTR) szString);

		 return TRUE ;

  case WM_COMMAND :
		 switch (wParam)
	{

	case IDOK :

		  GetDlgItemText (hDlg, IDD_UEB_P3, (LPSTR) szString, 7);
		  pMarkov3=atof(szString);

				if (pMarkov3<0 || pMarkov3>.5 || fehler(&szString[0]))
				 {
				 if(MessageBox (hDlg,"Unzulssiger Wert!\n\n"
				  "Mgliche Fehler:\n"
				  "Wahrscheinlichkeit 'p' mu im Bereich\n"
				  "0<=p<=0.5 liegen;\n"
				  "Komma wurde verwendet;",
				  "Wertdiskrete Informationstheorie", MB_RETRYCANCEL | MB_ICONSTOP) == IDRETRY)
				  return TRUE;
				 else
				  {
				  EndDialog (hDlg, 0);
				  return TRUE;
				  }
				 }

		  GetDlgItemText (hDlg, IDD_KONST, (LPSTR) szString, 7);
		  KonstMarkov=atof(szString);

				if (KonstMarkov<0 || KonstMarkov>1 || fehler(&szString[0]))
				 {
				 if(MessageBox (hDlg,"Unzulssiger Wert!\n\n"
				  "Mgliche Fehler:\n"
				  "- Konstante k mu im Bereich 0<=k<=1 liegen;\n"
				  "- Komma wurde verwendet;",
				  "Wertdiskrete Informationstheorie", MB_RETRYCANCEL | MB_ICONSTOP) == IDRETRY)
				  return TRUE;
				 else
				  {
				  EndDialog (hDlg, 0);
				  return TRUE;
				  }
				 }

		  GetDlgItemText (hDlg, IDD_GROES_M3, (LPSTR) szString, 7);
		  Datei_Groes=(unsigned)atol(szString);

		  if(fehler(&szString[0]))
				 {
				 if(MessageBox (hDlg,"Unzulssiger Wert fr Dateigre!",
				  "Wertdiskrete Informationstheorie", MB_RETRYCANCEL | MB_ICONSTOP) == IDRETRY)
				  return TRUE;
				 else
				  {
				  EndDialog (hDlg, 0);
				  return TRUE;
				  }
				 }

			  if(Datei_Groes>60000U)
				{
				if(MessageBox (hDlg,"Die Groesse der Folge darf 60000 nicht berschreiten!",
					"Wertdiskrete Informationstheorie", MB_RETRYCANCEL | MB_ICONSTOP) == IDRETRY)
				 return TRUE;
				else
				 {
				 EndDialog (hDlg, 0);
				 return TRUE;
				 }
				}

		  EndDialog (hDlg, 1);
		  return TRUE;

	case IDCANCEL :
		  EndDialog (hDlg, 0);
		  return TRUE ;

	}
		 break ;

  case WM_PAINT:
		 hwndBild = GetDlgItem(hDlg, IDD_PAINT);
		 hdc = BeginPaint (hwndBild, &ps);
		 SetMapMode (hdc, MM_ISOTROPIC);
		 GetClientRect (hwndBild, &rect);
		 SetWindowExt (hdc, rect.right, rect.bottom);  // logische Groesse
		 SetViewportExt (hdc, rect.right, rect.bottom);
		 SetViewportOrg (hdc, 0, 0);
		 hMF=GetMetaFile("markov3.wmf");
		 PlayMetaFile(hdc, hMF);
		 DeleteMetaFile(hMF);
		 EndPaint (hwndBild, &ps);
		 break;
  }
 return FALSE ;
}


void Markov3_Datei(HWND hwnd)
{
 extern void     Markov3_Erzeugen(float P, float KonstMarkov, unsigned Datei_Groes);
 extern void     Para2_unchecked(void);
 FARPROC         lpDlgProc;

 lpDlgProc = MakeProcInstance((FARPROC)MARKOV3_DlgProc, hInst);
 OK=DialogBox(hInst, "MARKOV3", hwnd, lpDlgProc);
 FreeProcInstance(lpDlgProc);

 if(OK)
  Markov3_Erzeugen(pMarkov3, KonstMarkov, Datei_Groes);

 return;
}


