//-------------------------------------------------------------------------
//------------------------------- OPTIONEN.C ------------------------------
//-------------------------------------------------------------------------
//--------------- Optioneneinstellung "Wertdiskrete Informationstheorie" --
//-------------------- Erstellt von: Georg Delle --------------------------


#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include <commdlg.h>
#include <mem.h>
#include "math.h"
#include "wdit.h"
#include "wdit_typ.h"


#define deltay 12500
#define deltax 16000

extern HANDLE          hInst;
extern HWND            hwndSF, hwndHFK, hwndETP, hwndPAR;
extern HWND            hwndFrame;
extern HMENU			  hMenu;
extern HCURSOR         hCurWait, hCurArrow;
extern STRUCT_FENSTER  Fenster;
extern STRUCT_TOCHTER  SF, HFK, ETP, PAR;
extern short			  Modell;
extern BOOL            HFK_erneuernd;
extern char				  szDirName[_MAX_PATH];
extern char	           szPuffer[_MAX_PATH];
extern char				  drive[_MAX_DRIVE];
extern char				  dir[_MAX_DIR];
extern char				  file[_MAX_FNAME];
extern char				  ext[_MAX_EXT];
extern char				  szAusblZeichen[9];
extern int				  AusblZeichen[34];
extern long				  AusblStelle;
extern char				  Zeich[3][9];
extern long				  lLength;
extern int				  xposalt;
extern float			  KonstMarkov;
extern float			  pMarkov3;
extern float			  K[3];
extern long				  Haeufigkeit2[35][35];
extern long huge		  Haeufigkeit3[35][35][35];
extern BOOL				  OK;
extern BOOL				  VorNach2;
extern BOOL				  VorNach3;
extern BOOL				  pApBfest;
extern BOOL				  OhneZI;
extern BOOL				  OhneLZ;
extern BOOL				  OhneIP;
extern BOOL				  OhneSZ;
extern BOOL				  Frei_L;
extern BOOL				  Quelle;
extern BOOL            Folge_L;
extern BOOL				  Frei_R;
extern BOOL				  Folgedec;
extern BOOL            Folge_R;
extern BOOL				  ueber_p;

extern BOOL            fehler(char*);

BOOL FAR PASCAL        OPT_ETP_Markov2_DlgProc(HWND, UINT, UINT, LONG);
BOOL FAR PASCAL        OPT_ETP_Markov3_DlgProc(HWND, UINT, UINT, LONG);
BOOL FAR PASCAL        OPT_ETP_ASC_DlgProc(HWND, UINT, UINT, LONG);
BOOL FAR PASCAL        OPT_HFK_DlgProc(HWND, UINT, UINT, LONG);


BOOL FAR PASCAL OPT_ETP_Markov2_DlgProc (HWND hDlg, UINT message,	UINT wParam, LONG lparam)
{

 switch (message)
  {
  case WM_INITDIALOG :

		 if(pApBfest)
		  CheckRadioButton(hDlg, IDD_PAFEST, IDD_PBFEST, IDD_PBFEST);
		 else
		  CheckRadioButton(hDlg, IDD_PAFEST, IDD_PBFEST, IDD_PAFEST);

		 return TRUE ;

  case WM_COMMAND :
		 switch (wParam)
	{

	case IDD_PBFEST :
		  CheckRadioButton(hDlg, IDD_PAFEST, IDD_PBFEST, IDD_PBFEST);
		  pApBfest=TRUE;
		  return TRUE ;

	case IDD_PAFEST :
		  CheckRadioButton(hDlg, IDD_PAFEST, IDD_PBFEST, IDD_PAFEST);
		  pApBfest=FALSE;
		  return TRUE ;


	case IDOK :
		  EndDialog (hDlg, 1);
		  return TRUE;


	case IDCANCEL :
		  EndDialog (hDlg, 0);
		  return TRUE ;

	}
		 break ;

  }
 return FALSE ;
}


BOOL FAR PASCAL OPT_ETP_Markov3_DlgProc (HWND hDlg, UINT message,	UINT wParam, LONG lparam)
{
 char         szString[15];
 short        i;

 switch (message)
  {
  case WM_INITDIALOG :


		 if(ueber_p)
		  {
		  CheckRadioButton(hDlg, IDD_ETP_MK3p, IDD_ETP_MK3k, IDD_ETP_MK3p);
		  gcvt (KonstMarkov, 7, szString);
		  SetDlgItemText(hDlg, IDD_K1, (LPSTR) szString);
		  }
		 else
		  {
		  CheckRadioButton(hDlg, IDD_ETP_MK3p, IDD_ETP_MK3k, IDD_ETP_MK3k);
		  gcvt (pMarkov3, 7, szString);
		  SetDlgItemText(hDlg, IDD_K1, (LPSTR) szString);
		  }
		 for(i=0; i<=2; i++)
		  {
		  gcvt (K[i], 7, szString);
		  SetDlgItemText(hDlg, IDD_K2+i, (LPSTR) szString);
		  }
		 return TRUE ;

  case WM_COMMAND :
		 switch (wParam)
	{

	case IDD_ETP_MK3p :
		  ueber_p=TRUE;
		  gcvt (KonstMarkov, 7, szString);
		  SetDlgItemText(hDlg, IDD_K1, (LPSTR) szString);
		  return TRUE ;

	case IDD_ETP_MK3k :
		  ueber_p=FALSE;
		  gcvt (pMarkov3, 7, szString);
		  SetDlgItemText(hDlg, IDD_K1, (LPSTR) szString);
		  return TRUE ;

	case IDOK :
		 for(i=0; i<=2; i++)
		  {
		  GetDlgItemText (hDlg, IDD_K2+i, (LPSTR) szString, 7);
		  K[i]=atof(szString);
			  if(ueber_p)
				{
				if (K[i]<0 || K[i]>1 || fehler(&szString[0]))
				 {
				 if(MessageBox (hDlg,"Unzulssiger Wert!\n\n"
				  "Mgliche Fehler:\n"
				  "- Konstante k mu im Bereich 0<=k<=1 liegen;\n"
				  "- Komma wurde verwendet;",
				  "Wertdiskrete Informationstheorie", MB_RETRYCANCEL | MB_ICONSTOP) == IDRETRY)
				  return TRUE;
				 else
				  {
				  EndDialog (hDlg, 0);
				  return TRUE;
				  }
				 }
				}
			  else
				{
				if (K[i]<0 || K[i]>0.5 || fehler(&szString[0]))
				 {
				 if(MessageBox (hDlg,"Unzulssiger Wert!\n\n"
				  "Mgliche Fehler:\n"
				  "- bergangswahrscheinlichkeit p mu im\n"
				  "   Bereich 0<=p<=0.5 liegen;\n"
				  "- Komma wurde verwendet;",
				  "Wertdiskrete Informationstheorie", MB_RETRYCANCEL | MB_ICONSTOP) == IDRETRY)
				  return TRUE;
				 else
				  {
				  EndDialog (hDlg, 0);
				  return TRUE;
				  }
				 }
				}
		  }


		  EndDialog (hDlg, 1);
		  return TRUE;


	case IDCANCEL :
		  EndDialog (hDlg, 0);
		  return TRUE ;

	}
		 break ;

  }
 return FALSE ;
}


BOOL FAR PASCAL OPT_ETP_ASC_DlgProc (HWND hDlg, UINT message, UINT wParam, LONG lparam)
{

 switch (message)
  {
  case WM_INITDIALOG :

		 if(OhneZI)
		  CheckDlgButton(hDlg, IDD_OHNEZI, 1);
		 if(OhneLZ)
		  CheckDlgButton(hDlg, IDD_OHNELZ, 1);
		 if(OhneIP)
		  CheckDlgButton(hDlg, IDD_OHNEIP, 1);
		 if(OhneSZ)
		  CheckDlgButton(hDlg, IDD_OHNESZ, 1);

		 return TRUE ;

  case WM_COMMAND :
		 switch (wParam)
	{

	case IDD_OHNEZI :
		  if(!OhneZI)
			OhneZI=TRUE;
		  else if(OhneZI)
			OhneZI=FALSE;
		  return TRUE;

	case IDD_OHNELZ :
		  if(!OhneLZ)
			OhneLZ=TRUE;
		  else if(OhneLZ)
			OhneLZ=FALSE;
		  return TRUE;

	case IDD_OHNEIP :
		  if(!OhneIP)
			OhneIP=TRUE;
		  else if(OhneIP)
			OhneIP=FALSE;
		  return TRUE;

	case IDD_OHNESZ :
		  if(!OhneSZ)
			OhneSZ=TRUE;
		  else if(OhneSZ)
			OhneSZ=FALSE;
		  return TRUE;

	case IDOK :
		  EndDialog (hDlg, 1);
		  return TRUE;


	case IDCANCEL :
		  EndDialog (hDlg, 0);
		  return TRUE ;

	}
		 break ;

  }
 return FALSE ;
}


BOOL FAR PASCAL OPT_HFK_DlgProc (HWND hDlg, UINT message, UINT wParam, LONG lparam)
{
 int	        i, j, k;
 BOOL			  good=FALSE;
 extern char  Alphabet[35][4];
 extern void  AlphabetInit(void);

 switch (message)
  {
  case WM_INITDIALOG :

		 if(VorNach2)
		  CheckRadioButton(hDlg, IDD_PVOR2, IDD_PNACH2, IDD_PNACH2);
		 else
		  CheckRadioButton(hDlg, IDD_PVOR2, IDD_PNACH2, IDD_PVOR2);
		 if(VorNach3)
		  CheckRadioButton(hDlg, IDD_PVOR3, IDD_PNACH3, IDD_PNACH3);
		 else
		  CheckRadioButton(hDlg, IDD_PVOR3, IDD_PNACH3, IDD_PVOR3);


		 for(i=0; i<=2; i++)
		  SetDlgItemText(hDlg, IDD_ZEICH+i, (LPSTR) Zeich[i]);

		 return TRUE ;


  case WM_COMMAND :
		 switch (wParam)
	{

	case IDD_PVOR2 :
		  VorNach2=FALSE;
		  CheckRadioButton(hDlg, IDD_PVOR2, IDD_PNACH2, IDD_PVOR2);
		  return TRUE ;

	case IDD_PNACH2 :
		  VorNach2=TRUE;
		  CheckRadioButton(hDlg, IDD_PVOR2, IDD_PNACH2, IDD_PNACH2);
		  return TRUE ;

	case IDD_PVOR3 :
		  VorNach3=FALSE;
		  CheckRadioButton(hDlg, IDD_PVOR3, IDD_PNACH3, IDD_PVOR3);
		  return TRUE ;

	case IDD_PNACH3 :
		  VorNach3=TRUE;
		  CheckRadioButton(hDlg, IDD_PVOR3, IDD_PNACH3, IDD_PNACH3);
		  return TRUE ;

	case IDD_ZEICHEN:
		  CheckRadioButton(hDlg, IDD_ZEICHEN, IDD_SONDERZ, IDD_ZEICHEN);
		  EnableWindow(GetDlgItem(hDlg, IDD_ZEICH), TRUE);
		  return TRUE;

	case IDD_ZIFFER:
		  CheckRadioButton(hDlg, IDD_ZEICHEN, IDD_SONDERZ, IDD_ZIFFER);
		  strcpy(Zeich[0],"ZI");
		  SetDlgItemText(hDlg, IDD_ZEICH, (LPSTR) Zeich[0]);
		  EnableWindow(GetDlgItem(hDlg, IDD_ZEICH), FALSE);
		  return TRUE;

	case IDD_LEERZ:
		  CheckRadioButton(hDlg, IDD_ZEICHEN, IDD_SONDERZ, IDD_LEERZ);
		  strcpy(Zeich[0],"LZ");
		  SetDlgItemText(hDlg, IDD_ZEICH, (LPSTR) Zeich[0]);
		  EnableWindow(GetDlgItem(hDlg, IDD_ZEICH), FALSE);
		  return TRUE;

	case IDD_INTERP:
		  CheckRadioButton(hDlg, IDD_ZEICHEN, IDD_SONDERZ, IDD_INTERP);
		  strcpy(Zeich[0],"IP");
		  SetDlgItemText(hDlg, IDD_ZEICH, (LPSTR) Zeich[0]);
		  EnableWindow(GetDlgItem(hDlg, IDD_ZEICH), FALSE);
		  return TRUE;

	case IDD_SONDERZ:
		  CheckRadioButton(hDlg, IDD_ZEICHEN, IDD_SONDERZ, IDD_SONDERZ);
		  strcpy(Zeich[0],"SZ");
		  SetDlgItemText(hDlg, IDD_ZEICH, (LPSTR) Zeich[0]);
		  EnableWindow(GetDlgItem(hDlg, IDD_ZEICH), FALSE);
		  return TRUE;

	case IDD_ZEICHEN1:
		  CheckRadioButton(hDlg, IDD_ZEICHEN1, IDD_SONDERZ1, IDD_ZEICHEN1);
		  EnableWindow(GetDlgItem(hDlg, IDD_ZEICH1), TRUE);
		  return TRUE;

	case IDD_ZIFFER1:
		  CheckRadioButton(hDlg, IDD_ZEICHEN1, IDD_SONDERZ1, IDD_ZIFFER1);
		  strcpy(Zeich[1],"ZI");
		  SetDlgItemText(hDlg, IDD_ZEICH1, (LPSTR) Zeich[1]);
		  EnableWindow(GetDlgItem(hDlg, IDD_ZEICH1), FALSE);
		  return TRUE;

	case IDD_LEERZ1:
		  CheckRadioButton(hDlg, IDD_ZEICHEN1, IDD_SONDERZ1, IDD_LEERZ1);
		  strcpy(Zeich[1],"LZ");
		  SetDlgItemText(hDlg, IDD_ZEICH1, (LPSTR) Zeich[1]);
		  EnableWindow(GetDlgItem(hDlg, IDD_ZEICH1), FALSE);
		  return TRUE;

	case IDD_INTERP1:
		  CheckRadioButton(hDlg, IDD_ZEICHEN1, IDD_SONDERZ1, IDD_INTERP1);
		  strcpy(Zeich[1],"IP");
		  SetDlgItemText(hDlg, IDD_ZEICH1, (LPSTR) Zeich[1]);
		  EnableWindow(GetDlgItem(hDlg, IDD_ZEICH1), FALSE);
		  return TRUE;

	case IDD_SONDERZ1:
		  CheckRadioButton(hDlg, IDD_ZEICHEN1, IDD_SONDERZ1, IDD_SONDERZ1);
		  strcpy(Zeich[1],"SZ");
		  SetDlgItemText(hDlg, IDD_ZEICH1, (LPSTR) Zeich[1]);
		  EnableWindow(GetDlgItem(hDlg, IDD_ZEICH1), FALSE);
		  return TRUE;

	case IDD_ZEICHEN2:
		  CheckRadioButton(hDlg, IDD_ZEICHEN2, IDD_SONDERZ2, IDD_ZEICHEN2);
		  EnableWindow(GetDlgItem(hDlg, IDD_ZEICH2), TRUE);
		  return TRUE;

	case IDD_ZIFFER2:
		  CheckRadioButton(hDlg, IDD_ZEICHEN2, IDD_SONDERZ2, IDD_ZIFFER2);
		  strcpy(Zeich[2],"ZI");
		  SetDlgItemText(hDlg, IDD_ZEICH2, (LPSTR) Zeich[2]);
		  EnableWindow(GetDlgItem(hDlg, IDD_ZEICH2), FALSE);
		  return TRUE;

	case IDD_LEERZ2:
		  CheckRadioButton(hDlg, IDD_ZEICHEN2, IDD_SONDERZ2, IDD_LEERZ2);
		  strcpy(Zeich[2],"LZ");
		  SetDlgItemText(hDlg, IDD_ZEICH2, (LPSTR) Zeich[2]);
		  EnableWindow(GetDlgItem(hDlg, IDD_ZEICH2), FALSE);
		  return TRUE;

	case IDD_INTERP2:
		  CheckRadioButton(hDlg, IDD_ZEICHEN2, IDD_SONDERZ2, IDD_INTERP2);
		  strcpy(Zeich[2],"IP");
		  SetDlgItemText(hDlg, IDD_ZEICH2, (LPSTR) Zeich[2]);
		  EnableWindow(GetDlgItem(hDlg, IDD_ZEICH2), FALSE);
		  return TRUE;

	case IDD_SONDERZ2:
		  CheckRadioButton(hDlg, IDD_ZEICHEN2, IDD_SONDERZ2, IDD_SONDERZ2);
		  strcpy(Zeich[2],"SZ");
		  SetDlgItemText(hDlg, IDD_ZEICH2, (LPSTR) Zeich[2]);
		  EnableWindow(GetDlgItem(hDlg, IDD_ZEICH2), FALSE);
		  return TRUE;

	case IDOK :

		  AlphabetInit();
		  for(i=0; i<=2; i++)
			{
	 if(IsWindowEnabled(GetDlgItem(hDlg, IDD_ZEICH+i)))
	  {
			GetDlgItemText (hDlg, IDD_ZEICH+i, (LPSTR) Zeich[i], 9);
			for(j=0; j<=33; j++)
			 {
			 k=strcmp(Zeich[i], Alphabet[j]);
			 if(k==0)
			  good=TRUE;
			 }
			if(!good)
			 {
			 if(MessageBox (hDlg,"Unzul\344ssiges Zeichen eingegeben!",
				 "Wertdiskrete Informationstheorie", MB_RETRYCANCEL | MB_ICONSTOP) == IDRETRY)
				 return TRUE;
				else
				 {
				 EndDialog (hDlg, 0);
				 return TRUE;
				 }
			 }
	  }
			good=FALSE;
			}
		  EndDialog (hDlg, 1);

		  return TRUE;

	case IDCANCEL :
		  EndDialog (hDlg, 0);
		  return TRUE ;

	}
		 break ;

  }
 return FALSE ;
}


BOOL FAR PASCAL OPT_SF_ASC_DlgProc (HWND hDlg, UINT message, UINT wParam, LONG lparam)
{
 char         szBuffer[9];
 int	        i;
 unsigned 	  wCheck;
 extern BOOL  fehler(char*);
 extern char  Alphabet[35][4];
 extern void  AlphabetInit(void);

 switch (message)
  {
  case WM_INITDIALOG :

		  for(i=0; i<=33; i++)
			{
			if(AusblZeichen[i])
			 CheckDlgButton(hDlg, IDD_Z1+i, 1);
			}
		  ltoa(AusblStelle, szBuffer, 10);
		  SetDlgItemText(hDlg, IDD_AUSBLSTELLE, (LPSTR) szBuffer);

		 return TRUE ;


  case WM_COMMAND :
		 switch (wParam)
	{

	case IDOK :
		  for(i=0; i<=33;i++)
			{
			wCheck=IsDlgButtonChecked(hDlg, IDD_Z1+i);
			AusblZeichen[i]=wCheck;
			}

			GetDlgItemText (hDlg, IDD_AUSBLSTELLE, (LPSTR) szBuffer, 9);
			AusblStelle=atol(szBuffer);
			if(fehler(&szBuffer[0]))
				 {
				 if(MessageBox (hDlg,"Unzul\344ssiger Wert eingegeben!\n\n"
											"Fr 'Darstellen ab Zeichen' mu\n"
											"ein Zahlenwert eingegeben werden.",
				  "Wertdiskrete Informationstheorie", MB_RETRYCANCEL | MB_ICONSTOP) == IDRETRY)
				  return TRUE;
				 else
				  {
				  EndDialog (hDlg, 0);
				  return TRUE;
				  }
				 }

			if(AusblStelle>=lLength)
				 {
				 if(MessageBox (hDlg,"Unzul\344ssiger Wert eingegeben!\n\n"
											"Fr 'Darstellen ab Zeichen' mu ein\n"
											"Zahlenwert eingegeben werden, der kleiner\n"
											"als die Dateigroesse (siehe Fenster Parameter) ist.",
				  "Wertdiskrete Informationstheorie", MB_RETRYCANCEL | MB_ICONSTOP) == IDRETRY)
				  return TRUE;
				 else
				  {
				  EndDialog (hDlg, 0);
				  return TRUE;
				  }
				 }

		  EndDialog (hDlg, 1);
		  return TRUE;

	case IDCANCEL :
		  EndDialog (hDlg, 0);
		  return TRUE ;

	}
		 break ;

  }
 return FALSE ;
}


BOOL FAR PASCAL OPT_SF_SUN_DlgProc (HWND hDlg, UINT message, UINT wParam, LONG lparam)
{
 extern BOOL  fehler(char*);
 extern char  Alphabet[35][4];
 extern void  AlphabetInit(void);

 switch (message)
  {
  case WM_INITDIALOG :

		 if(Frei_L)
		  CheckRadioButton(hDlg, IDD_FREI_L, IDD_FOLGECOD_L, IDD_FREI_L);
		 if(Quelle)
		  CheckRadioButton(hDlg, IDD_FREI_L, IDD_FOLGECOD_L, IDD_QUELLE);
		 if(Folge_L)
		  CheckRadioButton(hDlg, IDD_FREI_L, IDD_FOLGECOD_L, IDD_FOLGECOD_L);
		 if(Frei_R)
		  CheckRadioButton(hDlg, IDD_FREI_R, IDD_FOLGECOD_R, IDD_FREI_R);
		 if(Folgedec)
		  CheckRadioButton(hDlg, IDD_FREI_R, IDD_FOLGECOD_R, IDD_FOLGEDEC);
		 if(Folge_R)
		  CheckRadioButton(hDlg, IDD_FREI_R, IDD_FOLGECOD_R, IDD_FOLGECOD_R);

		 return TRUE ;


  case WM_COMMAND :
		 switch (wParam)
	{

	case IDD_FREI_L :
		  Frei_L=TRUE;
		  Quelle=FALSE;
		  Folge_L=FALSE;
		  CheckRadioButton(hDlg, IDD_FREI_L, IDD_FOLGECOD_L, IDD_FREI_L);
		  return TRUE ;

	case IDD_QUELLE :
		  Quelle=TRUE;
		  Frei_L=FALSE;
		  Folge_L=FALSE;
		  CheckRadioButton(hDlg, IDD_FREI_L, IDD_FOLGECOD_L, IDD_QUELLE);
		  return TRUE ;

	case IDD_FOLGECOD_L :
		  Folge_L=TRUE;
		  Quelle=FALSE;
		  Frei_L=FALSE;
		  CheckRadioButton(hDlg, IDD_FREI_L, IDD_FOLGECOD_L, IDD_FOLGECOD_L);
		  return TRUE ;

	case IDD_FREI_R :
		  Frei_R=TRUE;
		  Folge_R=FALSE;
		  Folgedec=FALSE;
		  CheckRadioButton(hDlg, IDD_FREI_R, IDD_FOLGECOD_R, IDD_FREI_R);
		  return TRUE ;

	case IDD_FOLGEDEC :
		  Folgedec=TRUE;;
		  Frei_R=FALSE;
		  Folge_R=FALSE;
		  CheckRadioButton(hDlg, IDD_FREI_R, IDD_FOLGECOD_R, IDD_FOLGEDEC);
		  return TRUE ;

	case IDD_FOLGECOD_R :
		  Folge_R=TRUE;
		  Frei_R=FALSE;
		  Folgedec=FALSE;
		  CheckRadioButton(hDlg, IDD_FREI_R, IDD_FOLGECOD_R, IDD_FOLGECOD_R);
		  return TRUE ;

	case IDOK :
		  EndDialog (hDlg, 1);
		  return TRUE;

	case IDCANCEL :
		  EndDialog (hDlg, 0);
		  return TRUE ;

	}
		 break ;

  }
 return FALSE ;
}


void ETPOPT(HWND hwnd)
{
 FARPROC         lpDlgProc;
 extern int      ETP_xpos;

 if(Modell==3 || Modell==6)
  {
  lpDlgProc = MakeProcInstance((FARPROC)OPT_ETP_Markov2_DlgProc, hInst);
  OK=DialogBox(hInst, "OPT_ETP_MARKOV2", hwnd, lpDlgProc);
  FreeProcInstance(lpDlgProc);
  if(OK)
	{
	xposalt=-32000;
	if(Fenster.ETP)
	 InvalidateRect(hwndETP, NULL, TRUE);
	ETP.ermittelt1 = FALSE;
	}
  }

 else if(Modell==4 || Modell==7)
  {
  lpDlgProc = MakeProcInstance((FARPROC)OPT_ETP_Markov3_DlgProc, hInst);
  OK=DialogBox(hInst, "OPT_ETP_MARKOV3", hwnd, lpDlgProc);
  FreeProcInstance(lpDlgProc);
  if(OK)
	{
	xposalt=-32000;
	if(Fenster.ETP)
	 InvalidateRect(hwndETP, NULL, TRUE);
	ETP.ermittelt1 = FALSE;
	}
  }

 else if(Modell==8)
  {
  lpDlgProc = MakeProcInstance((FARPROC)OPT_ETP_ASC_DlgProc, hInst);
  OK=DialogBox(hInst, "OPT_ETP_ASC", hwnd, lpDlgProc);
  FreeProcInstance(lpDlgProc);
  if(OK)
	{
	ETP.ermittelt1 = FALSE;
	HFK.ermittelt1 = FALSE;
	if(Fenster.ETP)
	 InvalidateRect(hwndETP, NULL, TRUE);
	if(Fenster.HFK)
	 InvalidateRect(hwndHFK, NULL, TRUE);
	if(Fenster.PAR)
	 InvalidateRect(hwndPAR, NULL, TRUE);
	}
  }

 return;
}


void HFKOPT(HWND hwnd)
{
 FARPROC         lpDlgProc;
 extern int      HFK_xpos;

 if(Modell==8)
  {
  lpDlgProc = MakeProcInstance((FARPROC)OPT_HFK_DlgProc, hInst);
  OK=DialogBox(hInst, "OPT_HFK", hwnd, lpDlgProc);
  FreeProcInstance(lpDlgProc);
  }

 if(OK)
  {
  if(Fenster.HFK)
	InvalidateRect(hwndHFK, NULL, TRUE);
  }

 return;
}

void SFOPT(HWND hwnd)
{
 FARPROC         lpDlgProc;
 extern int      HFK_xpos;

 if(Modell==8)
  {
  lpDlgProc = MakeProcInstance((FARPROC)OPT_SF_ASC_DlgProc, hInst);
  OK=DialogBox(hInst, "OPT_SF_ASC", hwnd, lpDlgProc);
  FreeProcInstance(lpDlgProc);

  if(OK)
	{
	if(Fenster.SF)
	 InvalidateRect(hwndSF, NULL, TRUE);
	}
  }

 if(Modell==1 || Modell==5)
  {
  lpDlgProc = MakeProcInstance((FARPROC)OPT_SF_SUN_DlgProc, hInst);
  OK=DialogBox(hInst, "OPT_SF_SUN", hwnd, lpDlgProc);
  FreeProcInstance(lpDlgProc);

  if(OK)
	{
	if(Fenster.SF)
	 InvalidateRect(hwndSF, NULL, TRUE);
	}
  }

 return;
}


void SaveHaeufig(void)
 {

 LPSTR	        lpstrBuffer;
 HANDLE 			  hBuffer;
 OPENFILENAME 	  ofn;
 char         	  *szFilter[] = {"Hufigkeiten (*.hfk)","*.hfk", ""};
 int				  hFile;
 int 				  i, j, k;
 long				  hfk;
 unsigned		  pos;

 szPuffer[0] = '\0';

 ofn.lStructSize        = sizeof(OPENFILENAME);
 ofn.hwndOwner          = hwndFrame;
 ofn.hInstance          = (HANDLE)NULL;
 ofn.lpstrFilter        = szFilter[0];
 ofn.lpstrCustomFilter  = (LPSTR)NULL;
 ofn.nMaxCustFilter     = 0L;
 ofn.nFilterIndex       = 0L;
 ofn.lpstrFile          = szPuffer;
 ofn.nMaxFile           = sizeof(szPuffer);
 ofn.lpstrFileTitle     = NULL;
 ofn.nMaxFileTitle      = 0;
 ofn.lpstrInitialDir    = szDirName;
 ofn.lpstrTitle         = (LPSTR)"Hufigkeiten speichern";
 ofn.Flags              = OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT;
 ofn.nFileOffset        = 0;
 ofn.nFileExtension     = 0;
 ofn.lpstrDefExt        = (LPSTR)"HFK";
 ofn.lCustData          = 0L;
 ofn.lpfnHook           = (FARPROC)NULL;
 ofn.lpTemplateName     = (LPSTR)NULL;

  if(GetSaveFileName(&ofn))
	{
	SetCursor(hCurWait);
	hBuffer = GlobalAlloc (GHND, 65500L);
	lpstrBuffer=GlobalLock(hBuffer);
	_splitpath(szPuffer, drive, dir, file, ext);
	_makepath(szDirName, drive, dir, "", "");
	_fullpath(szDirName, szDirName, _MAX_PATH);

	hFile= _lcreat (szPuffer, 0);
	pos=0;
	for(i=0; i<=20; i++)
	 {
	 for(j=0; j<=25; j++)
	  {
	  for(k=0; k<=25; k++)
		{
		hfk=Haeufigkeit3[i][j][k];
		memmove((lpstrBuffer+pos), &hfk, 4);
		pos+=4;
		}
	  k=31;
	  hfk=Haeufigkeit3[i][j][k];
	  memmove((lpstrBuffer+pos), &hfk, 4);
	  pos+=4;
	  }
	 for(k=0; k<=25; k++)
	  {
	  j=31;
	  hfk=Haeufigkeit3[i][j][k];
	  memmove((lpstrBuffer+pos), &hfk, 4);
	  pos+=4;
	  }
	 k=31;
	 hfk=Haeufigkeit3[i][j][k];
	 memmove((lpstrBuffer+pos), &hfk, 4);
	 pos+=4;
	 }
	_lwrite (hFile, lpstrBuffer, (unsigned)61236L);
	memset(lpstrBuffer, 0, 65500U);

	pos=0;
	for(i=21; i<=25; i++)
	 {
	 for(j=0; j<=25; j++)
	  {
	  for(k=0; k<=25; k++)
		{
		hfk=Haeufigkeit3[i][j][k];
		memmove((lpstrBuffer+pos), &hfk, 4);
		pos+=4;
		}
	  k=31;
	  hfk=Haeufigkeit3[i][j][k];
	  memmove((lpstrBuffer+pos), &hfk, 4);
	  pos+=4;
	  }
	 for(k=0; k<=25; k++)
	  {
	  j=31;
	  hfk=Haeufigkeit3[i][j][k];
	  memmove((lpstrBuffer+pos), &hfk, 4);
	  pos+=4;
	  }
	 k=31;
	 hfk=Haeufigkeit3[i][j][k];
	 memmove((lpstrBuffer+pos), &hfk, 4);
	 pos+=4;
	 }

	for(j=0; j<=25; j++)
	 {
	  for(k=0; k<=25; k++)
		{
		i=31;
		hfk=Haeufigkeit3[i][j][k];
		memmove((lpstrBuffer+pos), &hfk, 4);
		pos+=4;
		}
	  k=31;
	  hfk=Haeufigkeit3[i][j][k];
	  memmove((lpstrBuffer+pos), &hfk, 4);
	  pos+=4;
	 }

	for(k=0; k<=25; k++)
	 {
	 j=31;
	 hfk=(long)Haeufigkeit3[i][j][k];
	 memmove((lpstrBuffer+pos), &hfk, 4);
	 pos+=4;
	 }
	k=31;
	hfk=Haeufigkeit3[i][j][k];
	memmove((lpstrBuffer+pos), &hfk, 4);
	_lwrite (hFile, lpstrBuffer, 17496);

	_lclose(hFile);
	GlobalUnlock(hBuffer);
	GlobalFree(hBuffer);
	}

  SetCursor(hCurArrow);

 return;
 }

