//-------------------------------------------------------------------------
//------------------------------- PAR_WND.C -------------------------------
//-------------------------------------------------------------------------
//------- Fensterfunktion Parameterfenster "Wertdiskrete Informationstheorie"
//-------------------- Erstellt von: Georg Delle --------------------------


#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include "wdit.h"
#include "wdit_typ.h"
#include <stdio.h>

extern HMENU           hMenu;
extern HANDLE          hInst;
extern STRUCT_FENSTER  Fenster;
extern STRUCT_DATEI    Datei1, Datei2;
extern short			  Modell;
extern BOOL				  codiert;
extern char				  szFile[_MAX_PATH];
extern char				  Code_Strn[8][8];
extern long				  Ausgewertet;
extern double			  Statist_P[8];
extern double			  Statist2_P[15];
extern float			  pMarkov2[2];
extern float			  pMarkov3;
extern float			  KonstMarkov;
extern float			  u[15];
extern long				  lLength;
extern unsigned		  Datei_Groes;

long FAR PASCAL PARWndProc(HWND hwnd, UINT message,
				UINT wParam, LONG lParam)
{
 PAINTSTRUCT ps;
 HDC         hdc;
 RECT        rect;
 extern void FensterInit(HWND);
 extern void FensterDest(HWND);
 extern void OrdnenAufbau(HWND, char);
 extern void OrdnenAbbau(HWND);
 static HWND hwndClient;
 void        PAR2_Ausgabe(HDC, RECT);
 void        PAR_Paint(HDC, RECT);


 switch(message)
  {
  case WM_CREATE:
		 hwndClient = GetParent(hwnd);
		 EnableMenuItem(hMenu, IDM_OPARAM, MF_GRAYED);
		 EnableMenuItem(hMenu, IDM_SPARAM, MF_ENABLED);
		 FensterInit(hwndClient);
		 OrdnenAufbau(hwnd, 'p');
		 Fenster.PAR = TRUE;
		 return 0;

  case WM_PAINT:
		 if(!Fenster.aktualisiert)
	SendMessage(GetParent(hwndClient), WM_COMMAND, IDM_RUN, 0L);
	//erzwingt Aktualisierung aller geoeffneten Fenster

		 hdc = BeginPaint (hwnd, &ps);
		 SetMapMode (hdc, MM_ISOTROPIC);
		 GetClientRect (hwnd, &rect);
		 PAR_Paint(hdc, rect);
		 EndPaint (hwnd, &ps);

		 return 0;

  case WM_DESTROY:
		 EnableMenuItem(hMenu, IDM_SPARAM, MF_GRAYED);
		 EnableMenuItem(hMenu, IDM_OPARAM, MF_ENABLED);
		 Fenster.PAR = FALSE;
		 FensterDest(hwndClient);
		 if(Fenster.neu != 0)
	OrdnenAbbau(hwndClient);
		 return 0 ;
  }
 return DefMDIChildProc (hwnd, message, wParam, lParam);
}


void PAR_Paint(HDC hdc, RECT rect)
 {
 void			PAR_Ausgabe1_5(HDC hdc);
 void			PAR_Ausgabe2(HDC hdc);
 void			PAR_Ausgabe3_6(HDC hdc);
 void			PAR_Ausgabe4_7(HDC hdc);
 void			PAR_Ausgabe8(HDC hdc);

 if(rect.right<2.8*rect.bottom)//senkrecht angeordnet
  {
  SetWindowExt (hdc, 10000, 10000);  // logische Groesse
  SetViewportExt (hdc, .25*(rect.right-rect.left), -.5*(rect.bottom-rect.top));
  SetViewportOrg (hdc, .5*(rect.right-rect.left)+rect.left, .5*(rect.bottom-rect.top)+rect.top);
  }
 else//waagrecht angeordnet
  {
  SetWindowExt (hdc, 10000, 10000);  // logische Groesse
  SetViewportExt (hdc, .5*(rect.right-rect.left), -.5*(rect.bottom-rect.top));
  SetViewportOrg (hdc, .5*(rect.right-rect.left)+rect.left, .5*(rect.bottom-rect.top)+rect.top);
  }
 switch(Modell)
  {
  case 1:
		 PAR_Ausgabe1_5(hdc);

		 break;

  case 2:
		 PAR_Ausgabe2(hdc);

		 break;

  case 3:
		 PAR_Ausgabe3_6(hdc);

		 break;

  case 4:
		 PAR_Ausgabe4_7(hdc);

		 break;

  case 5:
		 PAR_Ausgabe1_5(hdc);

		 break;

  case 6:
		 PAR_Ausgabe3_6(hdc);

		 break;

  case 7:
		 PAR_Ausgabe4_7(hdc);

		 break;

  case 8:
		 PAR_Ausgabe8(hdc);

		 break;

  }

 return;
 }


void PAR_Ausgabe1_5(HDC hdc)
 {
 TEXTMETRIC     	tm;
 HFONT          	hFont;
 extern LOGFONT	lfont;
 extern char		szBuffer[40];

  SetMapperFlags (hdc, 1L);
  lfont.lfPitchAndFamily=DEFAULT_PITCH | FF_SWISS;
  lfont.lfHeight= 3.7*470;
  hFont = SelectObject (hdc, CreateFontIndirect (&lfont));
  GetTextMetrics (hdc, &tm);
  SetTextAlign (hdc, TA_CENTER|TA_BASELINE);
  SetTextColor (hdc, RGB(150, 0, 0));
  if(Modell==1)
	{
	TextOut(hdc, 0, 6*tm.tmHeight, "Quelle :", 8);
	TextOut(hdc, 0, 5*tm.tmHeight, "statistisch unabhngige Symbolfolge", 35);
	}
  else
	{
	TextOut(hdc, 0, 6*tm.tmHeight, "Quellendatei :", 14);
	TextOut(hdc, 0, 5*tm.tmHeight, szFile, strlen(szFile));
	}
  sprintf(szBuffer, "Lnge N = %.li Symbole", Ausgewertet);
  TextOut(hdc, 0, 4*tm.tmHeight, szBuffer, strlen(szBuffer));

	SetTextAlign (hdc, TA_LEFT|TA_BASELINE);
	sprintf(szBuffer, "p(A)= %.3f", u[0]);
	TextOut(hdc, -22*tm.tmAveCharWidth, 2*tm.tmHeight, szBuffer, strlen(szBuffer));
	sprintf(szBuffer, "p(B)= %.3f", u[1]);
	TextOut(hdc, -5*tm.tmAveCharWidth, 2*tm.tmHeight, szBuffer, strlen(szBuffer));
	sprintf(szBuffer, "p(C)= %.3f", u[2]);
	TextOut(hdc, 12*tm.tmAveCharWidth, 2*tm.tmHeight, szBuffer, strlen(szBuffer));
	sprintf(szBuffer, "p(D)= %.3f", u[3]);
	TextOut(hdc, -22*tm.tmAveCharWidth, .5*tm.tmHeight, szBuffer, strlen(szBuffer));
	sprintf(szBuffer, "p(E)= %.3f", u[4]);
	TextOut(hdc, -5*tm.tmAveCharWidth, .5*tm.tmHeight, szBuffer, strlen(szBuffer));
	sprintf(szBuffer, "p(F)= %.3f", u[5]);
	TextOut(hdc, 12*tm.tmAveCharWidth, .5*tm.tmHeight, szBuffer, strlen(szBuffer));
	sprintf(szBuffer, "p(G)= %.3f", u[6]);
	TextOut(hdc, -22*tm.tmAveCharWidth, -tm.tmHeight, szBuffer, strlen(szBuffer));
	sprintf(szBuffer, "p(LZ)= %.3f", u[7]);
	TextOut(hdc, -5*tm.tmAveCharWidth, -tm.tmHeight, szBuffer, strlen(szBuffer));

	if(codiert)
	 {
	 sprintf(szBuffer, "Huffman-Codierung mit Zuordnung");
	 TextOut(hdc, -22*tm.tmAveCharWidth, -3*tm.tmHeight, szBuffer, strlen(szBuffer));
	 sprintf(szBuffer, "A: ");
	 strcat(szBuffer, Code_Strn[0]);
	 TextOut(hdc, -22*tm.tmAveCharWidth, -4*tm.tmHeight, szBuffer, strlen(szBuffer));
	 sprintf(szBuffer, "B: ");
	 strcat(szBuffer, Code_Strn[1]);
	 TextOut(hdc, -5*tm.tmAveCharWidth, -4*tm.tmHeight, szBuffer, strlen(szBuffer));
	 sprintf(szBuffer, "C: ");
	 strcat(szBuffer, Code_Strn[2]);
	 TextOut(hdc, 12*tm.tmAveCharWidth, -4*tm.tmHeight, szBuffer, strlen(szBuffer));
	 sprintf(szBuffer, "D: ");
	 strcat(szBuffer, Code_Strn[3]);
	 TextOut(hdc, -22*tm.tmAveCharWidth, -5.5*tm.tmHeight, szBuffer, strlen(szBuffer));
	 sprintf(szBuffer, "E: ");
	 strcat(szBuffer, Code_Strn[4]);
	 TextOut(hdc, -5*tm.tmAveCharWidth, -5.5*tm.tmHeight, szBuffer, strlen(szBuffer));
	 sprintf(szBuffer, "F: ");
	 strcat(szBuffer, Code_Strn[5]);
	 TextOut(hdc, 12*tm.tmAveCharWidth, -5.5*tm.tmHeight, szBuffer, strlen(szBuffer));
	 sprintf(szBuffer, "G: ");
	 strcat(szBuffer, Code_Strn[6]);
	 TextOut(hdc, -22*tm.tmAveCharWidth, -7*tm.tmHeight, szBuffer, strlen(szBuffer));
	 sprintf(szBuffer, "LZ: ");
	 strcat(szBuffer, Code_Strn[7]);
	 TextOut(hdc, -5*tm.tmAveCharWidth, -7*tm.tmHeight, szBuffer, strlen(szBuffer));
	 }

  DeleteObject (SelectObject (hdc, hFont));
 return;
 }

void PAR_Ausgabe2(HDC hdc)
 {
 TEXTMETRIC     	tm;
 HFONT          	hFont;
 extern LOGFONT	lfont;
 extern char		szBuffer[40];

  SetMapperFlags (hdc, 1L);
  lfont.lfPitchAndFamily=DEFAULT_PITCH | FF_SWISS;
  lfont.lfHeight= 3.7*500;
  hFont = SelectObject (hdc, CreateFontIndirect (&lfont));
  GetTextMetrics (hdc, &tm);
  SetTextAlign (hdc, TA_CENTER|TA_BASELINE);
  SetTextColor (hdc, RGB(150, 0, 0));
  TextOut(hdc, 0, 5*tm.tmHeight, "Quelle :", 8);
  TextOut(hdc, 0, 3.5*tm.tmHeight, "2 statistisch abhngige Symbolfolgen", 36);
  sprintf(szBuffer, "Lnge N = %.li Symbole", Ausgewertet);
  TextOut(hdc, 0, 2.5*tm.tmHeight, szBuffer, strlen(szBuffer));

	sprintf(szBuffer, "p(A)= %.3f", Statist2_P[0]);
	TextOut(hdc, -15*tm.tmAveCharWidth, 0.5*tm.tmHeight, szBuffer, strlen(szBuffer));
	sprintf(szBuffer, "p(B)= %.3f", Statist2_P[1]);
	TextOut(hdc, 0, 0.5*tm.tmHeight, szBuffer, strlen(szBuffer));
	sprintf(szBuffer, "p(C)= %.3f", Statist2_P[2]);
	TextOut(hdc, 15*tm.tmAveCharWidth, 0.5*tm.tmHeight, szBuffer, strlen(szBuffer));
	sprintf(szBuffer, "p(a|A)= %.3f", Statist2_P[3]);
	TextOut(hdc, -15*tm.tmAveCharWidth, -1*tm.tmHeight, szBuffer, strlen(szBuffer));
	sprintf(szBuffer, "p(a|B)= %.3f", Statist2_P[7]);
	TextOut(hdc, 0, -1*tm.tmHeight, szBuffer, strlen(szBuffer));
	sprintf(szBuffer, "p(a|C)= %.3f", Statist2_P[11]);
	TextOut(hdc, 15*tm.tmAveCharWidth, -1*tm.tmHeight, szBuffer, strlen(szBuffer));
	sprintf(szBuffer, "p(b|A)= %.3f", Statist2_P[4]);
	TextOut(hdc, -15*tm.tmAveCharWidth, -2.5*tm.tmHeight, szBuffer, strlen(szBuffer));
	sprintf(szBuffer, "p(b|B)= %.3f", Statist2_P[8]);
	TextOut(hdc, 0, -2.5*tm.tmHeight, szBuffer, strlen(szBuffer));
	sprintf(szBuffer, "p(b|C)= %.3f", Statist2_P[12]);
	TextOut(hdc, 15*tm.tmAveCharWidth, -2.5*tm.tmHeight, szBuffer, strlen(szBuffer));
	sprintf(szBuffer, "p(c|A)= %.3f", Statist2_P[5]);
	TextOut(hdc, -15*tm.tmAveCharWidth, -4*tm.tmHeight, szBuffer, strlen(szBuffer));
	sprintf(szBuffer, "p(c|B)= %.3f", Statist2_P[9]);
	TextOut(hdc, 0, -4*tm.tmHeight, szBuffer, strlen(szBuffer));
	sprintf(szBuffer, "p(c|C)= %.3f", Statist2_P[13]);
	TextOut(hdc, 15*tm.tmAveCharWidth, -4*tm.tmHeight, szBuffer, strlen(szBuffer));
	sprintf(szBuffer, "p(d|A)= %.3f", Statist2_P[6]);
	TextOut(hdc, -15*tm.tmAveCharWidth, -5.5*tm.tmHeight, szBuffer, strlen(szBuffer));
	sprintf(szBuffer, "p(d|B)= %.3f", Statist2_P[10]);
	TextOut(hdc, 0, -5.5*tm.tmHeight, szBuffer, strlen(szBuffer));
	sprintf(szBuffer, "p(d|C)= %.3f", Statist2_P[14]);
	TextOut(hdc, 15*tm.tmAveCharWidth, -5.5*tm.tmHeight, szBuffer, strlen(szBuffer));

  DeleteObject (SelectObject (hdc, hFont));
 return;
 }

void PAR_Ausgabe3_6(HDC hdc)
 {
 TEXTMETRIC     	tm;
 HFONT          	hFont;
 extern LOGFONT	lfont;
 extern char		szBuffer[40];

  SetMapperFlags (hdc, 1L);
  lfont.lfPitchAndFamily=DEFAULT_PITCH | FF_SWISS;
  lfont.lfHeight= 3.7*570;
  hFont = SelectObject (hdc, CreateFontIndirect (&lfont));
  GetTextMetrics (hdc, &tm);
  SetTextAlign (hdc, TA_CENTER|TA_BASELINE);
  SetTextColor (hdc, RGB(150, 0, 0));
  if(Modell==3)
	{
	TextOut(hdc, 0, 4*tm.tmHeight, "Quelle :", 8);
	TextOut(hdc, 0, 2*tm.tmHeight, "Markovquelle (M=2)", 18);
	sprintf(szBuffer, "Lnge N = %.u Symbole", Datei_Groes);
	TextOut(hdc, 0, tm.tmHeight, szBuffer, strlen(szBuffer));
	sprintf(szBuffer, "p(A|A)= %.3f", pMarkov2[0]);
	TextOut(hdc, -10*tm.tmAveCharWidth, -tm.tmHeight, szBuffer, strlen(szBuffer));
	sprintf(szBuffer, "p(B|B)= %.3f", pMarkov2[1]);
	TextOut(hdc, 10*tm.tmAveCharWidth, -tm.tmHeight, szBuffer, strlen(szBuffer));
	sprintf(szBuffer, "p(B|A)= %.3f", 1-pMarkov2[0]);
	TextOut(hdc, -10*tm.tmAveCharWidth, -2.5*tm.tmHeight, szBuffer, strlen(szBuffer));
	sprintf(szBuffer, "p(A|B)= %.3f", 1-pMarkov2[1]);
	TextOut(hdc, 10*tm.tmAveCharWidth, -2.5*tm.tmHeight, szBuffer, strlen(szBuffer));
	}
  else
	{
	TextOut(hdc, 0, 4*tm.tmHeight, "Quellendatei :", 14);
	TextOut(hdc, 0, 2*tm.tmHeight, szFile, strlen(szFile));
	sprintf(szBuffer, "Lnge N = %.li Symbole", Datei1.laenge);
	TextOut(hdc, 0, tm.tmHeight, szBuffer, strlen(szBuffer));
	}

  DeleteObject (SelectObject (hdc, hFont));
 return;
 }

void PAR_Ausgabe4_7(HDC hdc)
 {
 TEXTMETRIC     	tm;
 HFONT          	hFont;
 extern LOGFONT	lfont;
 extern char		szBuffer[40];

  SetMapperFlags (hdc, 1L);
  lfont.lfPitchAndFamily=DEFAULT_PITCH | FF_SWISS;
  lfont.lfHeight= 3.7*570;
  hFont = SelectObject (hdc, CreateFontIndirect (&lfont));
  GetTextMetrics (hdc, &tm);
  SetTextAlign (hdc, TA_CENTER|TA_BASELINE);
  SetTextColor (hdc, RGB(150, 0, 0));
  if(Modell==4)
	{
	TextOut(hdc, 0, 4*tm.tmHeight, "Quelle :", 8);
	TextOut(hdc, 0, 2*tm.tmHeight, "Markovquelle (M=3)", 18);
	sprintf(szBuffer, "Lnge N = %.u Symbole", Datei_Groes);
	TextOut(hdc, 0, tm.tmHeight, szBuffer, strlen(szBuffer));
	sprintf(szBuffer, "p= %.3f", pMarkov3);
	TextOut(hdc, -10*tm.tmAveCharWidth, -tm.tmHeight, szBuffer, strlen(szBuffer));
	sprintf(szBuffer, "k= %.3f", KonstMarkov);
	TextOut(hdc, 10*tm.tmAveCharWidth, -tm.tmHeight, szBuffer, strlen(szBuffer));
	}
  else
	{
	TextOut(hdc, 0, 4*tm.tmHeight, "Quellendatei :", 14);
	TextOut(hdc, 0, 2*tm.tmHeight, szFile, strlen(szFile));
	sprintf(szBuffer, "Lnge N = %.li Symbole", Datei1.laenge);
	TextOut(hdc, 0, tm.tmHeight, szBuffer, strlen(szBuffer));
	}

  DeleteObject (SelectObject (hdc, hFont));
 return;
 }

void PAR_Ausgabe8(HDC hdc)
 {
 TEXTMETRIC     	tm;
 HFONT          	hFont;
 extern LOGFONT	lfont;
 extern char		szBuffer[40];

  SetMapperFlags (hdc, 1L);
  lfont.lfPitchAndFamily=DEFAULT_PITCH | FF_SWISS;
  lfont.lfHeight= 3.7*570;
  hFont = SelectObject (hdc, CreateFontIndirect (&lfont));
  GetTextMetrics (hdc, &tm);
  SetTextAlign (hdc, TA_CENTER|TA_BASELINE);
  SetTextColor (hdc, RGB(150, 0, 0));
  TextOut(hdc, 0, 2*tm.tmHeight, "Quellendatei :", 14);
  TextOut(hdc, 0, 0, szFile, strlen(szFile));
  sprintf(szBuffer, "Lnge N = %.li Symbole", Datei1.laenge);
  TextOut(hdc, 0, -tm.tmHeight, szBuffer, strlen(szBuffer));
  sprintf(szBuffer, "Ausgewertet : %.li Symbole", Ausgewertet);
  TextOut(hdc, 0, -2*tm.tmHeight, szBuffer, strlen(szBuffer));
  DeleteObject (SelectObject (hdc, hFont));

 return;
 }

