//-------------------------------------------------------------------------
//------------------------------- SF_WND.C --------------------------------
//-------------------------------------------------------------------------
//-------------- Fensterfunktionen "Wertdiskrete Informationstheorie"------
//-------------------- Erstellt von Georg Delle ---------------------------


#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include <io.h>
#include <stdio.h>
#include <math.h>
#include "wdit.h"
#include "wdit_typ.h"



extern LPSTR			  lpstrCod;
extern HANDLE		     hBufferCod;
extern LPSTR			  lpstrDec;
extern HANDLE		     hBufferDec;
extern HWND            hwndSF;
extern short			  *Bkground;
extern short			  *HervorHeb;
extern HMENU           hMenu;
extern HWND            hwndFrame;
extern HANDLE          hInst;
extern HCURSOR         hCurWait, hCurArrow;
extern LPSTR			  lpstrPar;
extern LPSTR			  lpstrPar2;
extern STRUCT_FENSTER  Fenster;
extern STRUCT_DATEI    Datei1, Datei2;
extern short			  Modell;
extern BOOL				  decodieren;
extern char		  		  CodePuffer[_MAX_PATH];
extern char		        szFile[_MAX_PATH];
extern char	           szPuffer[_MAX_PATH];
extern char		  		  CodePuffer[_MAX_PATH];
extern long				  AusblStelle;
extern long				  lLength;
extern int				  AusblZeichen[34];
extern BOOL				  Frei_L;
extern BOOL				  Quelle;
extern BOOL            Folge_L;
extern BOOL				  Frei_R;
extern BOOL				  Folgedec;
extern BOOL            Folge_R;
extern BOOL				  codiert;
extern BOOL				  decodiert;
extern BOOL				  manuell;
extern unsigned		  CodeLength;
int						  NUMLINES;
int						  Spaltenzahl;

long FAR PASCAL SFWndProc(HWND hwnd, UINT message,
			  UINT wParam, LONG lParam)
{
 PAINTSTRUCT   ps;
 HDC           hdc;
 RECT          rect;
 TEXTMETRIC		tm;
 POINT         point;
 static HWND   hwndClient;
 extern void	SFOPT(HWND hwnd);
 extern void   FensterInit(HWND);
 extern void   FensterDest(HWND);
 extern void   OrdnenAufbau(HWND, char);
 extern void   OrdnenAbbau(HWND);
 void          SF_Paint(HDC, RECT, TEXTMETRIC);
 void				Uebertragungsfehler2(RECT rect, TEXTMETRIC tm, POINT point);

 switch(message)
  {
  case WM_CREATE:
		 hwndClient = GetParent(hwnd);
		 EnableMenuItem(hMenu, IDM_OSFOLGE, MF_GRAYED);
		 EnableMenuItem(hMenu, IDM_SSFOLGE, MF_ENABLED);
		 FensterInit(hwndClient);
		 OrdnenAufbau(hwnd, 'f');
		 Fenster.SF = TRUE;
		 return 0;


  case WM_PAINT:
		 if(!Fenster.aktualisiert)
	SendMessage(GetParent(hwndClient), WM_COMMAND, IDM_RUN, 0L);
	//erzwingt Aktualisierung aller geoeffneten Fenster
		 hdc = BeginPaint(hwnd, &ps);

		 GetClientRect(hwnd, &rect);
		 GetTextMetrics(hdc, &tm);
		 SF_Paint(hdc, rect, tm);
		 EndPaint(hwnd, &ps);

		 return 0;

  case WM_DESTROY:
		 EnableMenuItem(hMenu, IDM_SSFOLGE, MF_GRAYED);
		 EnableMenuItem(hMenu, IDM_OSFOLGE, MF_ENABLED);
		 Fenster.SF = FALSE;
		 FensterDest(hwndClient);
		 if(Fenster.neu != 0)
	OrdnenAbbau(hwndClient);
		 return 0 ;

  case WM_RBUTTONDOWN:
		 SFOPT(hwnd);
		 return 0;

  case WM_LBUTTONDOWN:
		 if(Modell==1 || Modell==5)
		  {
		  if(manuell)
			{
			hdc = BeginPaint(hwnd, &ps);
			GetClientRect(hwnd, &rect);
			GetTextMetrics(hdc, &tm);
			point.x = LOWORD(lParam);
			point.y = HIWORD(lParam);
			Uebertragungsfehler2(rect, tm, point);
			EndPaint(hwnd, &ps);
			}
		  }
		 return 0;
  }
 return DefMDIChildProc (hwnd, message, wParam, lParam) ;
}


void Uebertragungsfehler2(RECT rect, TEXTMETRIC tm, POINT point)
 {
 int			xpos, ypos, left1, left2, right1, right2, top;
 int			reihe, spalte, bit;
 int			hFile;

 xpos=point.x;
 ypos=point.y;
 left1=rect.right/40;
 left2=rect.right/2+rect.right/40;
 right1=rect.right/2-rect.right/40+tm.tmAveCharWidth/2;
 right2=rect.right-rect.right/40+tm.tmAveCharWidth/2;
 top=tm.tmHeight+tm.tmExternalLeading;

 if(xpos>left1 && xpos<right1 && ypos>top && Folge_L)
  {
  reihe=ypos/top;
  spalte=(xpos-left1)/tm.tmAveCharWidth+1;
  bit=(reihe-1)*Spaltenzahl+spalte-1;
  if(*(lpstrCod+bit)==48)
	*(lpstrCod+bit)=49;
  else
	*(lpstrCod+bit)=48;
  if(HervorHeb[bit]==0)//Fehler rot
	HervorHeb[bit]=1;
  else
	HervorHeb[bit]=0;
  hFile = _lcreat (CodePuffer, 0);
  _lwrite (hFile, lpstrCod, CodeLength);
  _lclose(hFile);
  InvalidateRect(hwndSF, NULL, TRUE);
  }

 if(xpos>left2 && xpos<right2 && ypos>top && Folge_R)
  {
  reihe=ypos/top;
  spalte=(xpos-left2)/tm.tmAveCharWidth+1;
  bit=(reihe-1)*Spaltenzahl+spalte-1;
  if(*(lpstrCod+bit)==48)
	*(lpstrCod+bit)=49;
  else
	*(lpstrCod+bit)=48;
  if(HervorHeb[bit]==0)//Fehler rot
	HervorHeb[bit]=1;
  else
	HervorHeb[bit]=0;
  hFile = _lcreat (CodePuffer, 0);
  _lwrite (hFile, lpstrCod, CodeLength);
  _lclose(hFile);
  InvalidateRect(hwndSF, NULL, TRUE);
  }

 return;
 }


void SF_Ausgabe1_links(HDC hdc, RECT rect, TEXTMETRIC tm)
 {
 int				xpos,	ypos;
 char				Zeichen[2];
 int				hFile;
 unsigned		i=0;
 long          lLaenge;
 unsigned		count1=0, count2=0;
 BOOL				Bk=FALSE;
 void          Zeile1_links(HDC hdc, RECT rect, TEXTMETRIC tm, BOOL b);

 if(Folge_L)
  {
  if(!codiert)
	{
	MessageBox(hwndFrame, (LPSTR) "Bitte zuerst codieren!",
		 (LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
	return;
	}
  Zeile1_links(hdc, rect, tm, FALSE);
  hFile = _lopen ((LPSTR)CodePuffer, OF_READ|OF_SHARE_DENY_WRITE);
  lLaenge=filelength(hFile);
  _lclose(hFile);
  }
 else
  {
  Zeile1_links(hdc, rect, tm, TRUE);
  lLaenge=lLength;
  }
  SetTextColor (hdc, RGB(0, 0, 150));
  xpos=rect.right/40;
  ypos=tm.tmHeight+tm.tmExternalLeading;
  for(i=1; i<=lLaenge; i++)
	{
	if(Quelle)
	 {
	 Zeichen[0]=*(lpstrPar+i-1);
	 TextOut (hdc, xpos, ypos, Zeichen, 1);
	 xpos+=tm.tmMaxCharWidth;
	 }

	if(Folge_L)
	 {
	 Zeichen[0]=*(lpstrCod+i-1);
	 if(!Bk)
	  SetBkColor(hdc, RGB(255, 255, 255));
	 else if(Bk)
	  SetBkColor(hdc, RGB(192, 192, 192));
	 if(HervorHeb[i-1]==1)
	  SetTextColor (hdc, RGB(255, 0, 0));
	 else
	  SetTextColor (hdc, RGB(0, 0, 150));
	 TextOut (hdc, xpos, ypos, Zeichen, 1);
	 count1++;
	 if(count1==Bkground[count2])
	  {
	  Bk=!Bk;
	  count1=0;
	  count2++;
	  }
	 xpos+=tm.tmAveCharWidth;
	 }

	if(xpos>(rect.right/2-rect.right/40))
	 {
	 xpos=rect.right/40;
	 ypos+=tm.tmHeight+tm.tmExternalLeading;
	 if(ypos>rect.bottom)
	  break;
	 }
	}
  SetBkColor(hdc, RGB(255, 255, 255));
  _lclose (hFile) ;

 return;
 }


void SF_Ausgabe1_rechts(HDC hdc, RECT rect, TEXTMETRIC tm)
 {
 int				xpos,	ypos;
 char				Zeichen[2];
 int				hFile;
 long		      lLaenge;
 unsigned		i=0;
 unsigned		count1=0, count2=0;
 BOOL				Bk=FALSE;
 void Zeile1_rechts(HDC hdc, RECT rect, TEXTMETRIC tm, BOOL b);

 if(Folge_R)
  {
  if(!codiert)
	{
	MessageBox(hwndFrame, (LPSTR) "Bitte zuerst codieren!",
	  (LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
	return;
	}
  Zeile1_rechts(hdc, rect, tm, FALSE);
  hFile = _lopen ((LPSTR)CodePuffer, OF_READ|OF_SHARE_DENY_WRITE);
  lLaenge=filelength(hFile);
  _lclose(hFile);
  }
 else
  {
  if(!decodiert)
	{
	MessageBox(hwndFrame, (LPSTR) "Bitte zuerst decodieren!",
	  (LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
	return;
	}
  Zeile1_rechts(hdc, rect, tm, TRUE);
  lLaenge=lLength;
  }

  SetTextColor (hdc, RGB(0, 0, 150));
  xpos=rect.right/2+rect.right/40;
  ypos=tm.tmHeight+tm.tmExternalLeading;
  for(i=1; i<=lLaenge; i++)
	{
	if(Folge_R)
	 {
	 Zeichen[0]=*(lpstrCod+i-1);
	 if(!Bk)
	  SetBkColor(hdc, RGB(255, 255, 255));
	 else if(Bk)
	  SetBkColor(hdc, RGB(192, 192, 192));
	 if(HervorHeb[i-1]==1)
	  SetTextColor (hdc, RGB(255, 0, 0));
	 else
	  SetTextColor (hdc, RGB(0, 0, 150));
	 TextOut (hdc, xpos, ypos, Zeichen, 1);
	 count1++;
	 if(count1==Bkground[count2])
	  {
	  Bk=!Bk;
	  count1=0;
	  count2++;
	  }
	 xpos+=tm.tmAveCharWidth;
	 }

	else//Decodierte Folge
	 {
	 Zeichen[0]=*(lpstrDec+i-1);
	 if(*(lpstrPar+i-1)==*(lpstrDec+i-1))
	  SetTextColor (hdc, RGB(0, 0, 150));
	 else
	  {
	  SetTextColor (hdc, RGB(255, 0, 0));
	  if(Zeichen[0]==32)//um rotes Leerzeichen darzustellen
		Zeichen[0]=95;
	  }
	 TextOut (hdc, xpos, ypos, Zeichen, 1);
	 xpos+=tm.tmMaxCharWidth;
	 }

	if(xpos>(rect.right-rect.right/40))
	 {
	 xpos=rect.right/2+rect.right/40;
	 ypos+=tm.tmHeight+tm.tmExternalLeading;
	 if(ypos>rect.bottom)
	  break;
	 }
	}

  _lclose (hFile) ;

 return;
 }


void SF_Ausgabe5_links(HDC hdc, RECT rect, TEXTMETRIC tm)
 {
 int				xpos,	ypos;
 char				Zeichen[2];
 int				hFile;
 long          lLaenge;
 unsigned		i=0;
 unsigned		laenge, count1=0, count2=0;
 BOOL				Bk=FALSE;
 void          Zeile1_links(HDC hdc, RECT rect, TEXTMETRIC tm, BOOL b);

 if(Folge_L)
  {
  if(!codiert)
	{
	MessageBox(hwndFrame, (LPSTR) "Bitte zuerst codieren!",
		 (LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
	return;
	}
  Zeile1_links(hdc, rect, tm, FALSE);
  strcpy(szPuffer, szFile);
  laenge=strlen(szPuffer);
  szPuffer[laenge-3]='H';
  szPuffer[laenge-2]='U';
  szPuffer[laenge-1]='F';
  hFile = _lopen ((LPSTR)szPuffer, OF_READ|OF_SHARE_DENY_WRITE);
  lLaenge=filelength(hFile);
  _lclose(hFile);
  }
 else
  {
  Zeile1_links(hdc, rect, tm, TRUE);
  if(-1 == (hFile = _lopen ((LPSTR)szFile, OF_READ|OF_SHARE_DENY_WRITE)))
	{
	MessageBox(hwndFrame, (LPSTR) "Datei kann nicht gelesen werden!",
	 (LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
	_lclose (hFile);
	return;
	}
  lLaenge=filelength(hFile);
  }

  SetTextColor (hdc, RGB(0, 0, 150));
  xpos=rect.right/40;
  ypos=tm.tmHeight+tm.tmExternalLeading;
  _lread (hFile, lpstrPar, (unsigned)lLaenge);
  for(i=1; i<=lLaenge; i++)
	{
	if(Quelle)
	 {
	 Zeichen[0]=*(lpstrPar+i-1);
	 TextOut (hdc, xpos, ypos, Zeichen, 1);
	 xpos+=tm.tmMaxCharWidth;
	 }

	if(Folge_L)
	 {
	 Zeichen[0]=*(lpstrCod+i-1);
	 if(!Bk)
	  SetBkColor(hdc, RGB(255, 255, 255));
	 else if(Bk)
	  SetBkColor(hdc, RGB(192, 192, 192));
	 if(HervorHeb[i-1]==1)
	  SetTextColor (hdc, RGB(255, 0, 0));
	 else
	  SetTextColor (hdc, RGB(0, 0, 150));
	 TextOut (hdc, xpos, ypos, Zeichen, 1);
	 count1++;
	 if(count1==Bkground[count2])
	  {
	  Bk=!Bk;
	  count1=0;
	  count2++;
	  }
	 xpos+=tm.tmAveCharWidth;
	 }

	if(xpos>(rect.right/2-rect.right/40))
	 {
	 xpos=rect.right/40;
	 ypos+=tm.tmHeight+tm.tmExternalLeading;
	 if(ypos>rect.bottom)
	  break;
	 }
	}
  SetBkColor(hdc, RGB(255, 255, 255));
  _lclose (hFile) ;


 return;
 }


void SF_Ausgabe5_rechts(HDC hdc, RECT rect, TEXTMETRIC tm)
 {
 int				xpos,	ypos;
 char				Zeichen[2];
 int				hFile;
 long          lLaenge;
 unsigned		i=0;
 unsigned		laenge, count1=0, count2=0;
 BOOL				Bk=FALSE;
 void Zeile1_rechts(HDC hdc, RECT rect, TEXTMETRIC tm, BOOL b);

 if(Folge_R)
  {
  if(!codiert)
	{
	MessageBox(hwndFrame, (LPSTR) "Bitte zuerst codieren!",
	  (LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
	return;
	}
  Zeile1_rechts(hdc, rect, tm, FALSE);
  strcpy(szPuffer, szFile);
  laenge=strlen(szPuffer);
  szPuffer[laenge-3]='H';
  szPuffer[laenge-2]='U';
  szPuffer[laenge-1]='F';
  hFile = _lopen ((LPSTR)szPuffer, OF_READ|OF_SHARE_DENY_WRITE);
  lLaenge=filelength(hFile);
  _lclose(hFile);
  }
 else
  {
  if(!decodiert)
	{
	MessageBox(hwndFrame, (LPSTR) "Bitte zuerst decodieren!",
	  (LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
	return;
	}
  Zeile1_rechts(hdc, rect, tm, TRUE);
  hFile = _lopen ((LPSTR)szFile, OF_READ|OF_SHARE_DENY_WRITE);
  lLaenge=filelength(hFile);
  _lclose(hFile);
  }
  SetTextColor (hdc, RGB(0, 0, 150));
  xpos=rect.right/2+rect.right/40;
  ypos=tm.tmHeight+tm.tmExternalLeading;
  for(i=1; i<=lLaenge; i++)
	{
	if(Folge_R)
	 {
	 Zeichen[0]=*(lpstrCod+i-1);
	 if(!Bk)
	  SetBkColor(hdc, RGB(255, 255, 255));
	 else if(Bk)
	  SetBkColor(hdc, RGB(192, 192, 192));
	 if(HervorHeb[i-1]==1)
	  SetTextColor (hdc, RGB(255, 0, 0));
	 else
	  SetTextColor (hdc, RGB(0, 0, 150));
	 TextOut (hdc, xpos, ypos, Zeichen, 1);
	 count1++;
	 if(count1==Bkground[count2])
	  {
	  Bk=!Bk;
	  count1=0;
	  count2++;
	  }
	 xpos+=tm.tmAveCharWidth;
	 }

	else//Decodierte Folge
	 {
	 Zeichen[0]=*(lpstrDec+i-1);
	 if(*(lpstrPar+i-1)==*(lpstrDec+i-1))
	  SetTextColor (hdc, RGB(0, 0, 150));
	 else
	  {
	  SetTextColor (hdc, RGB(255, 0, 0));
	  if(Zeichen[0]==32)//um rotes Leerzeichen darzustellen
		Zeichen[0]=95;
	  }
	 TextOut (hdc, xpos, ypos, Zeichen, 1);
	 xpos+=tm.tmMaxCharWidth;
	 }

	if(xpos>(rect.right-rect.right/40))
	 {
	 xpos=rect.right/2+rect.right/40;
	 ypos+=tm.tmHeight+tm.tmExternalLeading;
	 if(ypos>rect.bottom)
	  break;
	 }
	}

  _lclose (hFile) ;

 return;
 }


void SF_Ausgabe2(HDC hdc, RECT rect, TEXTMETRIC tm)
 {
 int				xpos,	ypos;
 char				Zeichen[2];
 unsigned      i=0;
 void          Zeile1_links(HDC hdc, RECT rect, TEXTMETRIC tm, BOOL b);
 void          Zeile1_rechts(HDC hdc, RECT rect, TEXTMETRIC tm, BOOL b);

  Zeile1_links(hdc, rect, tm, TRUE);
  SetTextColor (hdc, RGB(0, 0, 150));
  xpos=rect.right/40;
  ypos=tm.tmHeight+tm.tmExternalLeading;
  for(i=1; i<=lLength; i++)
	{
	Zeichen[0]=*(lpstrPar+i-1);
	TextOut (hdc, xpos, ypos, Zeichen, 1);
	xpos+=tm.tmMaxCharWidth;

	if(xpos>(rect.right/2-rect.right/40))
	 {
	 xpos=rect.right/40;
	 ypos+=tm.tmHeight+tm.tmExternalLeading;
	 if(ypos>rect.bottom)
	  break;
	 }
	}

  Zeile1_rechts(hdc, rect, tm, TRUE);
  xpos=rect.right/2+rect.right/40;
  ypos=tm.tmHeight+tm.tmExternalLeading;
  for(i=1; i<=lLength; i++)
	{
	Zeichen[0]=*(lpstrPar2+i-1);
	if(*(lpstrPar+i-1)==(*(lpstrPar2+i-1)-32))
	 SetTextColor (hdc, RGB(0, 0, 150));
	else
	 SetTextColor (hdc, RGB(255, 0, 0));
	TextOut (hdc, xpos, ypos, Zeichen, 1);
	xpos+=tm.tmMaxCharWidth;

	if(xpos>(rect.right-rect.right/40))
	 {
	 xpos=rect.right/2+rect.right/40;
	 ypos+=tm.tmHeight+tm.tmExternalLeading;
	 if(ypos>rect.bottom)
	  break;
	 }
	}

 return;
 }


void SF_Ausgabe3_4(HDC hdc, RECT rect, TEXTMETRIC tm)
 {
 int				xpos,	ypos;
 char				Zeichen[2];
 unsigned      i=0;
 void          Zeile1_Markov(HDC hdc, RECT rect, TEXTMETRIC tm, BOOL b);

  Zeile1_Markov(hdc, rect, tm, TRUE);
  SetTextColor (hdc, RGB(0, 0, 150));
  xpos=rect.right/40;
  ypos=tm.tmHeight+tm.tmExternalLeading;
  for(i=1; i<=lLength; i++)
	{
	Zeichen[0]=*(lpstrPar+i-1);
	TextOut (hdc, xpos, ypos, Zeichen, 1);
	xpos+=tm.tmMaxCharWidth;


	if(xpos>(rect.right-rect.right/40))
	 {
	 xpos=rect.right/40;
	 ypos+=tm.tmHeight+tm.tmExternalLeading;
	 if(ypos>rect.bottom)
	  break;
	 }
	}

 return;
 }


void SF_Ausgabe6_7(HDC hdc, RECT rect, TEXTMETRIC tm)
 {
 int				xpos,	ypos;
 char				Zeichen[2];
 int				hFile;
 long          i=0, lLaenge;
 void          Zeile1_Markov(HDC hdc, RECT rect, TEXTMETRIC tm, BOOL b);

  Zeile1_Markov(hdc, rect, tm, TRUE);
  if(-1 == (hFile = _lopen ((LPSTR)szFile, OF_READ|OF_SHARE_DENY_WRITE)))
	{
	MessageBox(hwndFrame, (LPSTR) "Datei kann nicht gelesen werden!",
	 (LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
	_lclose (hFile);
	return;
	}
  lLaenge=filelength(hFile);

  SetTextColor (hdc, RGB(0, 0, 150));
  xpos=rect.right/40;
  ypos=tm.tmHeight+tm.tmExternalLeading;
  for(i=1; i<=lLaenge; i++)
	{
	_lread(hFile, Zeichen, 1);
	TextOut (hdc, xpos, ypos, Zeichen, 1);
	xpos+=tm.tmMaxCharWidth;


	if(xpos>(rect.right-rect.right/40))
	 {
	 xpos=rect.right/40;
	 ypos+=tm.tmHeight+tm.tmExternalLeading;
	 if(ypos>rect.bottom)
	  break;
	 }
	}
	_lclose (hFile);

 return;
 }


void SF_Ausgabe8(HDC hdc, RECT rect)

 {
 LPSTR         lpstrBuffer;
 HANDLE        hBuffer;
 int				hFile;
 void				Zuweisen(LPSTR lpstrBuffer);


 SetTextColor (hdc, RGB(0, 0, 150));
 SetCursor(hCurWait);

 hBuffer = GlobalAlloc (GHND, 65000L);
 lpstrBuffer = GlobalLock(hBuffer);

 if(-1 == (hFile = _lopen ((LPSTR)szFile, OF_READ|OF_SHARE_DENY_WRITE)))
  {
  MessageBox(hwndFrame, (LPSTR) "Datei kann nicht gelesen werden!",
	 (LPSTR) "Wertdiskrete Informationstheorie", MB_ICONEXCLAMATION|MB_OK);
  _lclose (hFile);
  GlobalUnlock(hBuffer);
  GlobalFree(hBuffer);
  return;
  }
 lLength=filelength(hFile);

 _llseek(hFile, AusblStelle, 0);
 _lread (hFile, lpstrBuffer, (unsigned)65000L);

 Zuweisen(lpstrBuffer);

 OemToAnsi(lpstrBuffer, lpstrBuffer);
 DrawText (hdc, lpstrBuffer, -1, &rect, DT_EXTERNALLEADING | DT_WORDBREAK | DT_NOPREFIX);

 _lclose (hFile) ;
 GlobalUnlock(hBuffer);
 GlobalFree(hBuffer);
 SetCursor(hCurArrow);

 return;
 }


void Zeile1_links(HDC hdc, RECT rect, TEXTMETRIC tm, BOOL b)
 {
 char				Ziffer[2];
 int				i, xpos;

  SetTextColor (hdc, RGB(0, 150, 0));
  SetTextAlign (hdc, TA_LEFT|TA_TOP);

//Beschriftung oberste Zeile
  xpos=rect.right/40;
  i=0;
  if(Folge_L)
	Spaltenzahl=0;
  while(xpos<=(rect.right/2-rect.right/40))
	{
	sprintf(Ziffer, "%c", i+48);
	TextOut(hdc, xpos, 0, Ziffer, 1);
	if(b)
	 xpos+=tm.tmMaxCharWidth;
	else
	 {
	 xpos+=tm.tmAveCharWidth;
	 Spaltenzahl++;
	 }
	i++;
	if(i>9)
	 i=0;
	}

 return;
 }


void Zeile1_rechts(HDC hdc, RECT rect, TEXTMETRIC tm, BOOL b)
 {
 char				Ziffer[2];
 int				i, xpos;

  SetTextColor (hdc, RGB(0, 150, 0));
  SetTextAlign (hdc, TA_LEFT|TA_TOP);

//Beschriftung oberste Zeile
  xpos=rect.right/2+rect.right/40;
  i=0;
  if(Folge_R)
	Spaltenzahl=0;
  while(xpos<=(rect.right-rect.right/40))
	{
	sprintf(Ziffer, "%c", i+48);
	TextOut(hdc, xpos, 0, Ziffer, 1);
	if(b)
	 xpos+=tm.tmMaxCharWidth;
	else
	 {
	 xpos+=tm.tmAveCharWidth;
	 Spaltenzahl++;
	 }
	i++;
	if(i>9)
	 i=0;
	}

 return;
 }


void Zeile1_Markov(HDC hdc, RECT rect, TEXTMETRIC tm, BOOL b)
 {
 char				Ziffer[2];
 int				i, xpos;

  SetTextColor (hdc, RGB(0, 150, 0));
  SetTextAlign (hdc, TA_LEFT|TA_TOP);

//Beschriftung oberste Zeile
  xpos=rect.right/40;
  i=0;
  while(xpos<=(rect.right-rect.right/40))
	{
	sprintf(Ziffer, "%c", i+48);
	TextOut(hdc, xpos, 0, Ziffer, 1);
	if(b)
	 xpos+=tm.tmMaxCharWidth;
	else
	 xpos+=tm.tmAveCharWidth;
	i++;
	if(i>9)
	 i=0;
	}

 return;
 }


void SF_Paint(HDC hdc, RECT rect,  TEXTMETRIC tm)
{
 void				SF_Ausgabe1_links(HDC hdc, RECT rect, TEXTMETRIC tm);
 void				SF_Ausgabe1_rechts(HDC hdc, RECT rect, TEXTMETRIC tm);
 void				SF_Ausgabe2(HDC hdc, RECT rect, TEXTMETRIC tm);
 void				SF_Ausgabe3_4(HDC hdc, RECT rect, TEXTMETRIC tm);
 void				SF_Ausgabe5_links(HDC hdc, RECT rect, TEXTMETRIC tm);
 void				SF_Ausgabe5_rechts(HDC hdc, RECT rect, TEXTMETRIC tm);
 void				SF_Ausgabe6_7(HDC hdc, RECT rect, TEXTMETRIC tm);
 void          SF_Ausgabe8(HDC hdc, RECT rect);

 void          SUN_Ausgabe(HDC, short, short, short, RECT, int, float*, short);

	 switch(Modell)
	  {
	  case 1:
	  if(!Frei_L)
		SF_Ausgabe1_links(hdc, rect, tm);
	  if(!Frei_R)
		SF_Ausgabe1_rechts(hdc, rect, tm);
	  break;

	  case 2:
	  SF_Ausgabe2(hdc, rect, tm);
	  break;

	  case 3:
	  SF_Ausgabe3_4(hdc, rect, tm);
	  break;

	  case 4:
	  SF_Ausgabe3_4(hdc, rect, tm);
	  break;

	  case 5:
	  if(!Frei_L)
		SF_Ausgabe5_links(hdc, rect, tm);
	  if(!Frei_R)
		SF_Ausgabe5_rechts(hdc, rect, tm);
	  break;

	  case 6:
	  SF_Ausgabe6_7(hdc, rect, tm);
	  break;

	  case 7:
	  SF_Ausgabe6_7(hdc, rect, tm);
	  break;

	  case 8:
	  SF_Ausgabe8(hdc, rect);
	  break;

	  default:
	  break;
	  }

 return;
}


void Zuweisen(LPSTR lpstrBuffer)
 {
 char				Zeichen;
 short			i;
 void				Ausblenden(LPSTR lpstrBuffer, char Zeichen);

 for(i=0; i<=25; i++)
  {
  if(AusblZeichen[i])
	{
	Zeichen=i+65;
	Ausblenden(lpstrBuffer, Zeichen);
	Zeichen=i+97;
	Ausblenden(lpstrBuffer, Zeichen);
	}
  }

 if(AusblZeichen[26])
  {
  Zeichen=-124;
  Ausblenden(lpstrBuffer, Zeichen);
  Zeichen=-114;
  Ausblenden(lpstrBuffer, Zeichen);
  }
 if(AusblZeichen[27])
  {
  Zeichen=-108;
  Ausblenden(lpstrBuffer, Zeichen);
  Zeichen=-103;
  Ausblenden(lpstrBuffer, Zeichen);
  }
 if(AusblZeichen[28])
  {
  Zeichen=-127;
  Ausblenden(lpstrBuffer, Zeichen);
  Zeichen=-102;
  Ausblenden(lpstrBuffer, Zeichen);
  }
 if(AusblZeichen[29])
  {
  Zeichen=-31;
  Ausblenden(lpstrBuffer, Zeichen);
  }
 if(AusblZeichen[30])
  {
  for(i=48; i<=57; i++)
	{
	Zeichen=i;
	Ausblenden(lpstrBuffer, Zeichen);
	}
  }
 if(AusblZeichen[31])
  {
  Zeichen=32;
  Ausblenden(lpstrBuffer, Zeichen);
  }
 if(AusblZeichen[32])
  {
  Zeichen=33;
  Ausblenden(lpstrBuffer, Zeichen);
  Zeichen=44;
  Ausblenden(lpstrBuffer, Zeichen);
  Zeichen=45;
  Ausblenden(lpstrBuffer, Zeichen);
  Zeichen=46;
  Ausblenden(lpstrBuffer, Zeichen);
  Zeichen=58;
  Ausblenden(lpstrBuffer, Zeichen);
  Zeichen=59;
  Ausblenden(lpstrBuffer, Zeichen);
  Zeichen=63;
  Ausblenden(lpstrBuffer, Zeichen);
  }
 if(AusblZeichen[33])
  {
  for(i=34; i<=43; i++)
	{
	Zeichen=i;
	Ausblenden(lpstrBuffer, Zeichen);
	}
  Zeichen=47;
  Ausblenden(lpstrBuffer, Zeichen);
  for(i=60; i<=62; i++)
	{
	Zeichen=i;
	Ausblenden(lpstrBuffer, Zeichen);
	}
  Zeichen=64;
  Ausblenden(lpstrBuffer, Zeichen);
  for(i=91; i<=95; i++)
	{
	Zeichen=i;
	Ausblenden(lpstrBuffer, Zeichen);
	}
  for(i=123; i<=126; i++)
	{
	Zeichen=i;
	Ausblenden(lpstrBuffer, Zeichen);
	}
  }
 return;
 }

void Ausblenden(LPSTR lpstrBuffer, char Zeichen)
 {
 unsigned	i;
 char			Byte;

 for(i=0; i<=64999L; i++)
  {
  Byte = *(lpstrBuffer+i);
  if(Byte==Zeichen)
  *(lpstrBuffer+i)=95;
  }

 return;
 }


