	//-------------------------------------------------------------------------
//------------------------------- WDIT_WND.C -------------------------------
//-------------------------------------------------------------------------
//--------------- Fensterfunktion "Wertdiskrete Informationstheorie" ------
//-------------------- Erstellt von: Georg Delle --------------------------


#include <windows.h>
#include "wdit.h"
#include "wdit_typ.h"


extern HMENU           hMenu, hMenuWindow;
extern HANDLE          hInst;
extern HANDLE			  hBufferPar, hBufferPar2, hBufferCod, hBufferDec,
							  hBufferDat, hBufferBkGround;
extern HWND            hwndSF, hwndHFK, hwndETP, hwndPAR, hwndSH;
extern STRUCT_FENSTER  Fenster;
extern STRUCT_TOCHTER  SF, HFK, ETP, PAR;
extern STRUCT_DATEI    Datei1, Datei2;

long FAR PASCAL KanalWndProc(HWND hwnd, UINT message,
									  UINT wParam, LONG lParam)
{
 static HWND         hwndClient;
 extern void         Tile(HWND);
 extern void         HUFFCOD(HWND);
 extern void         HUFFDEC(HWND);
 extern void			Uebertragungsfehler1(HWND);
 extern void			StatistDatei(HWND);
 extern void 			Markov2_Datei(HWND);
 extern void			Markov3_Datei(HWND);
 extern void			Text_Datei(HWND);
 extern void         ETPOPT(HWND);
 extern void         HFKOPT(HWND);
 extern void			SFOPT(HWND hwnd);
 extern void			SaveHaeufig(void);
 extern void         LoadASCII(void);
 extern void         LoadStatist(void);
 extern void 			LoadMarkov2(void);
 extern void 			LoadMarkov3(void);
 extern void			Statist1(HWND hwnd);
 extern void			Statist2(HWND hwnd);
 extern void			Markov2(HWND hwnd);
 extern void			Markov3(HWND hwnd);
 extern void         Konvertieren(HWND hwnd);
 extern void         Para1_unchecked(void);
 extern void         Para2_unchecked(void);
 extern BOOL         Print(HWND, short);
 CLIENTCREATESTRUCT  clientcreate;
 MDICREATESTRUCT     mdicreate;
 DWORD               dwHelpContextId;
 static BOOL         bHelp=FALSE;
 extern int 			xposalt;

 switch (message)
  {
  case WM_CREATE:
		 clientcreate.hWindowMenu = hMenuWindow;
		 clientcreate.idFirstChild = IDM_FIRST;
		 hwndClient = CreateWindow ("MDICLIENT", NULL,
				  WS_CHILD | WS_CLIPCHILDREN |
				  WS_VISIBLE,
				  0, 0, 0, 0, hwnd, 1, hInst,
				  (LPSTR) &clientcreate);
		 PostMessage(hwnd, WM_COMMAND, ID_ANLEITUNG, 0L);
		 return 0 ;

  case WM_ENTERIDLE:
		 if(bHelp==TRUE)
	bHelp=FALSE;//wg. inaktiven Menpunkten
		 if((wParam == MSGF_MENU)&&(GetKeyState(VK_F1) & 0x8000))
	{
	bHelp=TRUE;
	PostMessage(hwnd, WM_KEYDOWN, VK_RETURN, 0L);
	}
		 return 0;


  case WM_COMMAND :
		 if(bHelp)
	{
	bHelp=FALSE;
	dwHelpContextId =
	 (wParam == IDM_STATIST_ERZ) ? (DWORD) IDM_STATIST_ERZ:
	 (wParam == IDM_MARKOV2_ERZ) ? (DWORD) IDM_STATIST_ERZ:
	 (wParam == IDM_MARKOV3_ERZ) ? (DWORD) IDM_STATIST_ERZ:
	 (wParam == IDM_TEXT_ERZ) ? (DWORD) IDM_STATIST_ERZ:
	 (wParam == IDM_KONVERT) ? (DWORD) IDM_KONVERT:
	 (wParam == IDM_DOS) ? (DWORD) IDM_DOS:
	 (wParam == IDM_EXIT) ? (DWORD) IDM_EXIT:

	 (wParam == IDM_STATIST1) ? (DWORD) IDM_STATIST1:
	 (wParam == IDM_STATIST2) ? (DWORD) IDM_STATIST1:
	 (wParam == IDM_MARKOV2) ? (DWORD) IDM_STATIST1:
	 (wParam == IDM_MARKOV3) ? (DWORD) IDM_STATIST1:

	 (wParam == IDM_STATIST_DAT) ? (DWORD) IDM_STATIST_DAT:
	 (wParam == IDM_MARKOV2_DAT) ? (DWORD) IDM_STATIST_DAT:
	 (wParam == IDM_MARKOV3_DAT) ? (DWORD) IDM_STATIST_DAT:
	 (wParam == IDM_ASCII) ? (DWORD) IDM_STATIST_DAT:

	 (wParam == IDM_HUFFCOD) ? (DWORD) IDM_HUFFCOD:
	 (wParam == IDM_HUFFDEC) ? (DWORD) IDM_HUFFDEC:
	 (wParam == IDM_UEBFEHLER) ? (DWORD) IDM_UEBFEHLER:

	 (wParam == IDM_SFOPT) ? (DWORD) IDM_SFOPT:
	 (wParam == IDM_HFKOPT) ? (DWORD) IDM_HFKOPT:
	 (wParam == IDM_ETPOPT) ? (DWORD) IDM_ETPOPT:
	 (wParam == IDM_HAEUFIG) ? (DWORD) IDM_HAEUFIG:

	 (wParam == IDM_RUN) ? (DWORD) IDM_RUN:
	 (wParam == IDM_OALLE) ? (DWORD) IDM_OALLE:
	 (wParam == IDM_OSFOLGE) ? (DWORD) IDM_OALLE:
	 (wParam == IDM_OHFK) ? (DWORD) IDM_OALLE:
	 (wParam == IDM_OETP) ? (DWORD) IDM_OALLE:
	 (wParam == IDM_OPARAM) ? (DWORD) IDM_OALLE:

	 (wParam == IDM_SALLE) ? (DWORD) IDM_SALLE:
	 (wParam == IDM_SSFOLGE) ? (DWORD) IDM_SALLE:
	 (wParam == IDM_SHFK) ? (DWORD) IDM_SALLE:
	 (wParam == IDM_SETP) ? (DWORD) IDM_SALLE:
	 (wParam == IDM_SPARAM) ? (DWORD) IDM_SALLE:

	 (wParam == IDM_THEORIE) ? (DWORD) IDM_THEORIE:
	 (wParam == IDM_CASCADE) ? (DWORD) IDM_TILE:
	 (wParam == IDM_TILE) ? (DWORD) IDM_TILE:
	 (wParam == IDM_ARRANGE) ? (DWORD) IDM_TILE:
	 (wParam == IDM_HELP) ? (DWORD) IDM_HELP:
	 (wParam == IDM_VORBER) ? (DWORD) IDM_VORBER:
	 (wParam == IDM_DURCHF) ? (DWORD) IDM_DURCHF:
	 (wParam == IDM_LNT) ? (DWORD) IDM_LNT:
	 (wParam == IDM_ABOUT) ? (DWORD) IDM_ABOUT:
	 (wParam == IDM_AUTOR) ? (DWORD) IDM_AUTOR:
	 (wParam == IDM_SOFTWARE) ? (DWORD) IDM_SOFTWARE:
	 (DWORD) 0L;
	if(!dwHelpContextId)
	 {
	 MessageBeep(0);
	 return DefFrameProc (hwnd, hwndClient, message, wParam, lParam);
	 }
	WinHelp(hwnd, "wdit.hlp", HELP_CONTEXT, dwHelpContextId);
	return 0;
	}

		 switch (wParam)
	{
	case ID_ANLEITUNG://Eingangsbildschirm
		  MessageBox (hwnd,"Dieses Programm bietet Ihnen die M\366glich"
			 "keit, sich in die Vorgehensweise bei informationtheoretischen"
			 " Untersuchungen einzuarbeiten und einige fachspezifische Begriffe"
			 " anhand von Grafiken zu verdeutlichen. Bevor es damit beginnen kann,"
			 " bedarf es einiger Aktivit\344ten Ihrerseits,"
			 " n\344mlich\n\n - Parameterwahl von Quelle und eventuell Code"
			 "\n - \326ffnen von maximal "
			 "vier Ausgabefenstern.\n\n"
			 "Liegt Ihnen die schriftliche Anleitung zu"
			 " diesem Versuch nicht vor, so k\366nnen"
			 " Sie das Kapitel 1 ('Theorie'), "
			 "Kapitel 2 ('Versuch -> Vorbereitung') und "
			 "Kapitel 3"
			 " ('Versuch -> Durchf\374hrung') unter den "
			 "gleichnamigen Men\374punkten auch am "
			 "Bildschirm abrufen. Die weiteren Men\374punkte"
			 " werden mit 'Hilfe' eingehend erl\344utert.\n\n"
			 "Wollen Sie nichts von alledem, so beenden "
			 "Sie das Programm unter dem Men\374punkt "
			 "'Datei'.",
			 "Kurzanleitung", MB_OK);
		  return 0;

	case IDM_KONVERT://Konvertieren
		  Konvertieren(hwnd);
		  return 0;

	case IDM_STATIST_ERZ://Statistisch unabhngige Symbole-Datei erzeugen
		  StatistDatei(hwnd);
		  return 0;

	case IDM_MARKOV2_ERZ://Markov
		  Markov2_Datei(hwnd);
		  return 0;

	case IDM_MARKOV3_ERZ://Markov
		  Markov3_Datei(hwnd);
		  return 0;

	case IDM_TEXT_ERZ://Text
		  Text_Datei(hwnd);
		  return 0;

	case IDM_DOS:
		  WinExec((LPCSTR)"DOSPRMPT.PIF", SW_SHOWNORMAL);
		  return 0;

	case IDM_EXIT://Beenden
		  SendMessage (hwnd, WM_CLOSE, 0, 0L) ;
		  return 0;

	case IDM_STATIST1://Parameterwahl-Statist. unabhngige Symbole-Datei
		  Statist1(hwnd);
		  return 0;

	case IDM_STATIST2://Parameterwahl-Statist. abhngige Symbole-Dateien
		  Statist2(hwnd);
		  return 0;

	case IDM_MARKOV2://Parameterwahl-Markov-Datei
		  Markov2(hwnd);
		  return 0;

	case IDM_MARKOV3://Parameterwahl-Markov-Datei
		  Markov3(hwnd);
		  return 0;

	case IDM_STATIST_DAT://Parameterwahl-Statist. unabh. Symbole-Datei
		  LoadStatist();
		  return 0;

	case IDM_MARKOV2_DAT://Parameterwahl-Markov-Datei
		  LoadMarkov2();
		  return 0;

	case IDM_MARKOV3_DAT://Parameterwahl-Markov-Datei
		  LoadMarkov3();
		  return 0;

	case IDM_ASCII://Parameterwahl-ASCII-Datei
		  LoadASCII();
		  return 0;

	case IDM_HUFFCOD://Huffman-Codierung
		  HUFFCOD(hwnd);
		  return 0;

	case IDM_HUFFDEC://Huffman-Decodierung
		  HUFFDEC(hwnd);
		  return 0;

	case IDM_UEBFEHLER://bertragungsfehler
		  Uebertragungsfehler1(hwnd);
		  return 0;

	case IDM_SFOPT://Optionen-Symbolfolge
		  SFOPT(hwnd);
		  return 0;

	case IDM_ETPOPT://Optionen-Entropie
		  ETPOPT(hwnd);
		  return 0;

	case IDM_HFKOPT://Optionen-Auftrittshufigkeiten
		  HFKOPT(hwnd);
		  return 0;

	case IDM_HAEUFIG://Hufigkeiten speichern
		  SaveHaeufig();
		  return 0;

	case IDM_RUN://Fenster-Aktualisieren
		  if(!Fenster.aktualisiert)
			{
			xposalt=-32000;
			Fenster.aktualisiert = TRUE;//verhindert nochmaliges
					  //Aufrufen durch WM_PAINT
			if(Fenster.PAR)
			 InvalidateRect(hwndPAR, NULL, TRUE);
			if(Fenster.SF)
			 InvalidateRect(hwndSF, NULL, TRUE);
			if(Fenster.HFK)
			 InvalidateRect(hwndHFK, NULL, TRUE);
			if(Fenster.ETP)
			 InvalidateRect(hwndETP, NULL, TRUE);

			EnableMenuItem(hMenu, IDM_RUN, MF_GRAYED);
			}
		  return 0;

	case IDM_OALLE://Fenster-Oeffnen-Alle
		  Fenster.neu = 4;
		  if(!Fenster.PAR)
			SendMessage(hwnd, WM_COMMAND, IDM_OPARAM, 0L);
		  if(!Fenster.SF)
			SendMessage(hwnd, WM_COMMAND, IDM_OSFOLGE, 0L);
		  if(!Fenster.HFK)
			SendMessage(hwnd, WM_COMMAND, IDM_OHFK, 0L);
		  if(!Fenster.ETP)
			SendMessage(hwnd, WM_COMMAND, IDM_OETP, 0L);
		  return 0;

	case IDM_OSFOLGE://Fenster-Oeffnen-Symbolfolgen
		  mdicreate.szClass = "SF";
		  mdicreate.szTitle = "Symbolfolgen" ;
		  mdicreate.hOwner  = hInst ;
		  mdicreate.x       = 0 ;
		  mdicreate.y       = 0 ;
		  mdicreate.cx      = CW_USEDEFAULT;
		  mdicreate.cy      = CW_USEDEFAULT;
		  mdicreate.style   = 0;//WS_VSCROLL
		  mdicreate.lParam  = NULL ;

		  hwndSF = (HWND) SendMessage (hwndClient, WM_MDICREATE, 0,
				(long) (LPMDICREATESTRUCT) &mdicreate) ;
		  if(!Fenster.init)
			{
			SendMessage (hwndClient, WM_MDISETMENU, 0,
				MAKELONG (hMenu, hMenuWindow)) ;
			DrawMenuBar (hwnd) ;
			Fenster.init = TRUE;
			}
		  return 0;

	case IDM_OHFK://Fenster-Oeffnen-Auftrittshufigkeiten
		  mdicreate.szClass = "HFK";
		  mdicreate.szTitle = "Auftrittshufigkeiten in %";
		  mdicreate.hOwner  = hInst;
		  mdicreate.x       = 0;
		  mdicreate.y       = 0;
		  mdicreate.cx      = CW_USEDEFAULT;
		  mdicreate.cy      = CW_USEDEFAULT;
		  mdicreate.style   = 0;
		  mdicreate.lParam  = NULL;

		  hwndHFK = (HWND) SendMessage (hwndClient, WM_MDICREATE, 0,
				 (long) (LPMDICREATESTRUCT) &mdicreate);

		  if(!Fenster.init)
			{
			SendMessage (hwndClient, WM_MDISETMENU, 0,
				MAKELONG (hMenu, hMenuWindow)) ;
			DrawMenuBar (hwnd) ;
			Fenster.init = TRUE;
			}
		  return 0;

	case IDM_OETP://Fenster-Oeffnen-Entropien
		  mdicreate.szClass = "ETP";
		  mdicreate.szTitle = "Entropien in bit/Symbol" ;
		  mdicreate.hOwner  = hInst ;
		  mdicreate.x       = 0 ;
		  mdicreate.y       = 0 ;
		  mdicreate.cx      = CW_USEDEFAULT;
		  mdicreate.cy      = CW_USEDEFAULT;
		  mdicreate.style   = 0 ;
		  mdicreate.lParam  = NULL ;

		  hwndETP = (HWND) SendMessage (hwndClient, WM_MDICREATE, 0,
				(long) (LPMDICREATESTRUCT) &mdicreate) ;

		  if(!Fenster.init)
			{
			SendMessage (hwndClient, WM_MDISETMENU, 0,
				MAKELONG (hMenu, hMenuWindow)) ;
			DrawMenuBar (hwnd) ;
			Fenster.init = TRUE;
			}
		  return 0;

	case IDM_OPARAM://Fenster-Oeffnen-Parameter
		  mdicreate.szClass = "PAR";
		  mdicreate.szTitle = "Parameter" ;
		  mdicreate.hOwner  = hInst ;
		  mdicreate.x       = 0 ;
		  mdicreate.y       = 0 ;
		  mdicreate.cx      = CW_USEDEFAULT;
		  mdicreate.cy      = CW_USEDEFAULT;
		  mdicreate.style   = 0 ;
		  mdicreate.lParam  = NULL ;

		  hwndPAR = (HWND) SendMessage (hwndClient, WM_MDICREATE, 0,
				(long) (LPMDICREATESTRUCT) &mdicreate) ;
		  if(!Fenster.init)
			{
			SendMessage (hwndClient, WM_MDISETMENU, 0,
				MAKELONG (hMenu, hMenuWindow)) ;
			DrawMenuBar (hwnd) ;
			Fenster.init = TRUE;
			}
		  return 0;

	case IDM_SALLE://Fenster-Schliessen-Alle
		  Fenster.neu = 0;
		  if(Fenster.SF)
			SendMessage(hwndClient, WM_MDIDESTROY, hwndSF, 0L);
		  if(Fenster.HFK)
			SendMessage(hwndClient, WM_MDIDESTROY, hwndHFK, 0L);
		  if(Fenster.ETP)
			SendMessage(hwndClient, WM_MDIDESTROY, hwndETP, 0L);
		  if(Fenster.PAR)
			SendMessage(hwndClient, WM_MDIDESTROY, hwndPAR, 0L);
		  return 0;

	case IDM_SSFOLGE://Fenster-Schliessen-Symbolfolgen
		  SendMessage(hwndClient, WM_MDIDESTROY, hwndSF, 0L);
		  return 0;

	case IDM_SHFK://Fenster-Schliessen-Auftrittshufigkeiten
		  SendMessage(hwndClient, WM_MDIDESTROY, hwndHFK, 0L);
		  return 0;

	case IDM_SETP://Fenster-Schliessen-Entropien
		  SendMessage(hwndClient, WM_MDIDESTROY, hwndETP, 0L);
		  return 0;

	case IDM_SPARAM://Fenster-Schliessen-Parameter
		  SendMessage(hwndClient, WM_MDIDESTROY, hwndPAR, 0L);
		  return 0;

	case IDM_CASCADE://Fenster-Anordnen-Ueberlappend
		  SendMessage(hwndClient, WM_MDICASCADE, 0, 0L);
		  return 0;

	case IDM_TILE://Fenster-Anordnen-Nebeneinander
		  Tile(hwndClient);
		  return 0;

	case IDM_ARRANGE://Fenster-Anordnen-Symbole anordnen
		  SendMessage(hwndClient, WM_MDIICONARRANGE, 0, 0L);
		  return 0;

	case IDM_THEORIE://Theorie
		  WinHelp(hwnd, "wdit_the.hlp", HELP_INDEX, 0L);
		  return 0;

	case IDM_VORBER://Versuch-Vorbereitung
		  WinHelp(hwnd, "wdit_vor.hlp", HELP_INDEX, 0L);
		  return 0;

	case IDM_DURCHF://Versuch-Durchfuehrung
		  WinHelp(hwnd, "wdit_dur.hlp", HELP_INDEX, 0L);
		  return 0;

	case IDM_LNT://Info ueber den Lehrstuhl fuer Nachrichtentechnik
		  WinHelp(hwnd, "wdit_inf.hlp", HELP_CONTEXT, IDM_LNT);
		  return 0;

	case IDM_ABOUT://Info about the Chair for Communications
		  WinHelp(hwnd, "about.hlp", HELP_INDEX, IDM_ABOUT);
		  return 0;

	case IDM_AUTOR://Info ueber das Programm
		  WinHelp(hwnd, "wdit_aut.hlp", HELP_INDEX, 0L);
		  return 0;

	case IDM_SOFTWARE://Info ueber andere Lehr-Software
		  WinHelp(hwnd, "wdit_inf.hlp", HELP_CONTEXT, IDM_SOFTWARE);
		  return 0;

	case IDM_HELP://Hilfe
		  WinHelp(hwnd, "wdit.hlp", HELP_INDEX, 0L);
		  return 0;
	}
		 break;

  case WM_DESTROY :

		 GlobalUnlock(hBufferPar);
		 GlobalFree(hBufferPar);
		 GlobalUnlock(hBufferPar2);
		 GlobalFree(hBufferPar2);
		 GlobalUnlock(hBufferCod);
		 GlobalFree(hBufferCod);
		 GlobalUnlock(hBufferDec);
		 GlobalFree(hBufferDec);
		 GlobalUnlock(hBufferBkGround);
		 GlobalFree(hBufferBkGround);
		 WinHelp(hwnd, "wdit.hlp", HELP_QUIT, NULL);

		 PostQuitMessage (0) ;

		 return 0 ;
  }
 return DefFrameProc (hwnd, hwndClient, message, wParam, lParam) ;
}






